% create various figures and tables for all algorithms
% for the whole testset (400 instances) + testset extension (148 instances)
% with HDR and LDR solution vectors (SPEAR L1-Testset instances 1-548).
%
% December 2012
%
grayscale = 1;  % set to 0 to create colored plots
plot_all  = 0;  % set to 0 to skip creating plots with all solvers together
plot_sepa = 1;  % set to 0 to skip plotting each solver separately
plot_mnnz = 1;  % set to 0 to skip plot "m against solution support size"
plot_muA  = 0;  % set to 0 to skip plot of mutual coherences of A
plot_HOCx = 0;  % set to 0 to skip plots for HOC impact example
do_tables = 1;  % set to 0 to skip creating LaTeX tables with statistics

% The default [1,0,1,1,0,0,1] produces 63 figures and 21 tables!

% Concatenate relevant result data vectors (dist. to opt. and running time)
load Results_L1_Comparison_HDR.mat;
Homotopy_HDR_xdiff = [Homotopy_HDR_xdiff;Homotopy_nonERCtestset_HDR_xdiff];
Homotopy_HDR_time = [Homotopy_HDR_time;Homotopy_nonERCtestset_HDR_time];
Homotopy_WS_HDR_xdiff = [Homotopy_WS_HDR_xdiff;Homotopy_WS_nonERCtestset_HDR_xdiff];
Homotopy_WS_HDR_time = [Homotopy_WS_HDR_time;Homotopy_WS_nonERCtestset_HDR_time];
Homotopy_HOC_HDR_xdiff = [Homotopy_HOC_HDR_xdiff; Homotopy_HOC_nonERCtestset_HDR_xdiff];
Homotopy_HOC_HDR_time = [Homotopy_HOC_HDR_time;Homotopy_HOC_nonERCtestset_HDR_time];
Homotopy_HOC_WS_HDR_xdiff = [Homotopy_HOC_WS_HDR_xdiff;Homotopy_HOC_WS_nonERCtestset_HDR_xdiff];
Homotopy_HOC_WS_HDR_time = [Homotopy_HOC_WS_HDR_time;Homotopy_HOC_WS_nonERCtestset_HDR_time];
Homotopy_1em9_HDR_xdiff = [Homotopy_1em9_HDR_xdiff;Homotopy_1em9_nonERCtestset_HDR_xdiff];
Homotopy_1em9_HDR_time = [Homotopy_1em9_HDR_time;Homotopy_1em9_nonERCtestset_HDR_time];
Homotopy_WS_1em9_HDR_xdiff = [Homotopy_WS_1em9_HDR_xdiff;Homotopy_WS_1em9_nonERCtestset_HDR_xdiff];
Homotopy_WS_1em9_HDR_time = [Homotopy_WS_1em9_HDR_time;Homotopy_WS_1em9_nonERCtestset_HDR_time];
Homotopy_HOC_1em9_HDR_xdiff = [Homotopy_HOC_1em9_HDR_xdiff;Homotopy_HOC_1em9_nonERCtestset_HDR_xdiff];
Homotopy_HOC_1em9_HDR_time = [Homotopy_HOC_1em9_HDR_time;Homotopy_HOC_1em9_nonERCtestset_HDR_time];
Homotopy_HOC_WS_1em9_HDR_xdiff = [Homotopy_HOC_WS_1em9_HDR_xdiff;Homotopy_HOC_WS_1em9_nonERCtestset_HDR_xdiff];
Homotopy_HOC_WS_1em9_HDR_time = [Homotopy_HOC_WS_1em9_HDR_time;Homotopy_HOC_WS_1em9_nonERCtestset_HDR_time];
ISAL1_HDR_xdiff = [ISAL1_HDR_xdiff;ISAL1_nonERCtestset_HDR_xdiff];
ISAL1_HDR_time = [ISAL1_HDR_time;ISAL1_nonERCtestset_HDR_time];
ISAL1_noHOC_HDR_xdiff = [ISAL1_noHOC_HDR_xdiff;ISAL1_noHOC_nonERCtestset_HDR_xdiff];
ISAL1_noHOC_HDR_time = [ISAL1_noHOC_HDR_time;ISAL1_noHOC_nonERCtestset_HDR_time];
L1LP_CPX_HDR_xdiff = [L1LP_CPX_HDR_xdiff;L1LP_CPX_nonERCtestset_HDR_xdiff];
L1LP_CPX_HDR_time = [L1LP_CPX_HDR_time;L1LP_CPX_nonERCtestset_HDR_time];
L1LP_SPX_HDR_xdiff = [L1LP_SPX_HDR_xdiff;L1LP_SPX_nonERCtestset_HDR_xdiff];
L1LP_SPX_HDR_time = [L1LP_SPX_HDR_time;L1LP_SPX_nonERCtestset_HDR_time];
l1MAGIC_HDR_xdiff = [l1MAGIC_HDR_xdiff;l1MAGIC_nonERCtestset_HDR_xdiff];
l1MAGIC_HDR_time = [l1MAGIC_HDR_time;l1MAGIC_nonERCtestset_HDR_time];
l1MAGIC_HOC_HDR_xdiff = [l1MAGIC_HOC_HDR_xdiff;l1MAGIC_HOC_nonERCtestset_HDR_xdiff];
l1MAGIC_HOC_HDR_time = [l1MAGIC_HOC_HDR_time;l1MAGIC_HOC_nonERCtestset_HDR_time];
SolveBP_HDR_xdiff = [SparseLabSolveBP_HDR_xdiff;SparseLabSolveBP_nonERCtestset_HDR_xdiff];
SolveBP_HDR_time = [SparseLabSolveBP_HDR_time;SparseLabSolveBP_nonERCtestset_HDR_time];
SolveBP_HOC_HDR_xdiff = [SparseLabSolveBP_HOC_HDR_xdiff;SparseLabSolveBP_HOC_nonERCtestset_HDR_xdiff];
SolveBP_HOC_HDR_time = [SparseLabSolveBP_HOC_HDR_time;SparseLabSolveBP_HOC_nonERCtestset_HDR_time];
SPGL1_HDR_xdiff = [SPGL1_HDR_xdiff;SPGL1_nonERCtestset_HDR_xdiff];
SPGL1_HDR_time = [SPGL1_HDR_time;SPGL1_nonERCtestset_HDR_time];
SPGL1_HOC_HDR_xdiff = [SPGL1_HOC_HDR_xdiff;SPGL1_HOC_nonERCtestset_HDR_xdiff];
SPGL1_HOC_HDR_time = [SPGL1_HOC_HDR_time;SPGL1_HOC_nonERCtestset_HDR_time];
YALL1_HDR_xdiff = [YALL1_HDR_xdiff;YALL1_nonERCtestset_HDR_xdiff];
YALL1_HDR_time = [YALL1_HDR_time;YALL1_nonERCtestset_HDR_time];
YALL1_HOC_HDR_xdiff = [YALL1_HOC_HDR_xdiff;YALL1_HOC_nonERCtestset_HDR_xdiff];
YALL1_HOC_HDR_time = [YALL1_HOC_HDR_time;YALL1_HOC_nonERCtestset_HDR_time];

load Results_L1_Comparison_LDR.mat;
Homotopy_LDR_xdiff = [Homotopy_LDR_xdiff;Homotopy_nonERCtestset_LDR_xdiff];
Homotopy_LDR_time = [Homotopy_LDR_time;Homotopy_nonERCtestset_LDR_time];
Homotopy_WS_LDR_xdiff = [Homotopy_WS_LDR_xdiff;Homotopy_WS_nonERCtestset_LDR_xdiff];
Homotopy_WS_LDR_time = [Homotopy_WS_LDR_time;Homotopy_WS_nonERCtestset_LDR_time];
Homotopy_HOC_LDR_xdiff = [Homotopy_HOC_LDR_xdiff; Homotopy_HOC_nonERCtestset_LDR_xdiff];
Homotopy_HOC_LDR_time = [Homotopy_HOC_LDR_time;Homotopy_HOC_nonERCtestset_LDR_time];
Homotopy_HOC_WS_LDR_xdiff = [Homotopy_HOC_WS_LDR_xdiff;Homotopy_HOC_WS_nonERCtestset_LDR_xdiff];
Homotopy_HOC_WS_LDR_time = [Homotopy_HOC_WS_LDR_time;Homotopy_HOC_WS_nonERCtestset_LDR_time];
Homotopy_1em9_LDR_xdiff = [Homotopy_1em9_LDR_xdiff;Homotopy_1em9_nonERCtestset_LDR_xdiff];
Homotopy_1em9_LDR_time = [Homotopy_1em9_LDR_time;Homotopy_1em9_nonERCtestset_LDR_time];
Homotopy_WS_1em9_LDR_xdiff = [Homotopy_WS_1em9_LDR_xdiff;Homotopy_WS_1em9_nonERCtestset_LDR_xdiff];
Homotopy_WS_1em9_LDR_time = [Homotopy_WS_1em9_LDR_time;Homotopy_WS_1em9_nonERCtestset_LDR_time];
Homotopy_HOC_1em9_LDR_xdiff = [Homotopy_HOC_1em9_LDR_xdiff;Homotopy_HOC_1em9_nonERCtestset_LDR_xdiff];
Homotopy_HOC_1em9_LDR_time = [Homotopy_HOC_1em9_LDR_time;Homotopy_HOC_1em9_nonERCtestset_LDR_time];
Homotopy_HOC_WS_1em9_LDR_xdiff = [Homotopy_HOC_WS_1em9_LDR_xdiff;Homotopy_HOC_WS_1em9_nonERCtestset_LDR_xdiff];
Homotopy_HOC_WS_1em9_LDR_time = [Homotopy_HOC_WS_1em9_LDR_time;Homotopy_HOC_WS_1em9_nonERCtestset_LDR_time];
ISAL1_LDR_xdiff = [ISAL1_LDR_xdiff;ISAL1_nonERCtestset_LDR_xdiff];
ISAL1_LDR_time = [ISAL1_LDR_time;ISAL1_nonERCtestset_LDR_time];
ISAL1_noHOC_LDR_xdiff = [ISAL1_noHOC_LDR_xdiff;ISAL1_noHOC_nonERCtestset_LDR_xdiff];
ISAL1_noHOC_LDR_time = [ISAL1_noHOC_LDR_time;ISAL1_noHOC_nonERCtestset_LDR_time];
L1LP_CPX_LDR_xdiff = [L1LP_CPX_LDR_xdiff;L1LP_CPX_nonERCtestset_LDR_xdiff];
L1LP_CPX_LDR_time = [L1LP_CPX_LDR_time;L1LP_CPX_nonERCtestset_LDR_time];
L1LP_SPX_LDR_xdiff = [L1LP_SPX_LDR_xdiff;L1LP_SPX_nonERCtestset_LDR_xdiff];
L1LP_SPX_LDR_time = [L1LP_SPX_LDR_time;L1LP_SPX_nonERCtestset_LDR_time];
l1MAGIC_LDR_xdiff = [l1MAGIC_LDR_xdiff;l1MAGIC_nonERCtestset_LDR_xdiff];
l1MAGIC_LDR_time = [l1MAGIC_LDR_time;l1MAGIC_nonERCtestset_LDR_time];
l1MAGIC_HOC_LDR_xdiff = [l1MAGIC_HOC_LDR_xdiff;l1MAGIC_HOC_nonERCtestset_LDR_xdiff];
l1MAGIC_HOC_LDR_time = [l1MAGIC_HOC_LDR_time;l1MAGIC_HOC_nonERCtestset_LDR_time];
SolveBP_LDR_xdiff = [SparseLabSolveBP_LDR_xdiff;SparseLabSolveBP_nonERCtestset_LDR_xdiff];
SolveBP_LDR_time = [SparseLabSolveBP_LDR_time;SparseLabSolveBP_nonERCtestset_LDR_time];
SolveBP_HOC_LDR_xdiff = [SparseLabSolveBP_HOC_LDR_xdiff;SparseLabSolveBP_HOC_nonERCtestset_LDR_xdiff];
SolveBP_HOC_LDR_time = [SparseLabSolveBP_HOC_LDR_time;SparseLabSolveBP_HOC_nonERCtestset_LDR_time];
SPGL1_LDR_xdiff = [SPGL1_LDR_xdiff;SPGL1_nonERCtestset_LDR_xdiff];
SPGL1_LDR_time = [SPGL1_LDR_time;SPGL1_nonERCtestset_LDR_time];
SPGL1_HOC_LDR_xdiff = [SPGL1_HOC_LDR_xdiff;SPGL1_HOC_nonERCtestset_LDR_xdiff];
SPGL1_HOC_LDR_time = [SPGL1_HOC_LDR_time;SPGL1_HOC_nonERCtestset_LDR_time];
YALL1_LDR_xdiff = [YALL1_LDR_xdiff;YALL1_nonERCtestset_LDR_xdiff];
YALL1_LDR_time = [YALL1_LDR_time;YALL1_nonERCtestset_LDR_time];
YALL1_HOC_LDR_xdiff = [YALL1_HOC_LDR_xdiff;YALL1_HOC_nonERCtestset_LDR_xdiff];
YALL1_HOC_LDR_time = [YALL1_HOC_LDR_time;YALL1_HOC_nonERCtestset_LDR_time];

Homotopy_xdiff = [Homotopy_HDR_xdiff;Homotopy_LDR_xdiff];
Homotopy_time = [Homotopy_HDR_time;Homotopy_LDR_time];
Homotopy_WS_xdiff = [Homotopy_WS_HDR_xdiff;Homotopy_WS_LDR_xdiff];
Homotopy_WS_time = [Homotopy_WS_HDR_time;Homotopy_WS_LDR_time];
Homotopy_HOC_xdiff = [Homotopy_HOC_HDR_xdiff; Homotopy_HOC_LDR_xdiff];
Homotopy_HOC_time = [Homotopy_HOC_HDR_time;Homotopy_HOC_LDR_time];
Homotopy_HOC_WS_xdiff = [Homotopy_HOC_WS_HDR_xdiff;Homotopy_HOC_WS_LDR_xdiff];
Homotopy_HOC_WS_time = [Homotopy_HOC_WS_HDR_time;Homotopy_HOC_WS_LDR_time];
Homotopy_1em9_xdiff = [Homotopy_1em9_HDR_xdiff;Homotopy_1em9_LDR_xdiff];
Homotopy_1em9_time = [Homotopy_1em9_HDR_time;Homotopy_1em9_LDR_time];
Homotopy_WS_1em9_xdiff = [Homotopy_WS_1em9_HDR_xdiff;Homotopy_WS_1em9_LDR_xdiff];
Homotopy_WS_1em9_time = [Homotopy_WS_1em9_HDR_time;Homotopy_WS_1em9_LDR_time];
Homotopy_HOC_1em9_xdiff = [Homotopy_HOC_1em9_HDR_xdiff;Homotopy_HOC_1em9_LDR_xdiff];
Homotopy_HOC_1em9_time = [Homotopy_HOC_1em9_HDR_time;Homotopy_HOC_1em9_LDR_time];
Homotopy_HOC_WS_1em9_xdiff = [Homotopy_HOC_WS_1em9_HDR_xdiff;Homotopy_HOC_WS_1em9_LDR_xdiff];
Homotopy_HOC_WS_1em9_time = [Homotopy_HOC_WS_1em9_HDR_time;Homotopy_HOC_WS_1em9_LDR_time];
ISAL1_xdiff = [ISAL1_HDR_xdiff;ISAL1_LDR_xdiff];
ISAL1_time = [ISAL1_HDR_time;ISAL1_LDR_time];
ISAL1_noHOC_xdiff = [ISAL1_noHOC_HDR_xdiff;ISAL1_noHOC_LDR_xdiff];
ISAL1_noHOC_time = [ISAL1_noHOC_HDR_time;ISAL1_noHOC_LDR_time];
L1LP_CPX_xdiff = [L1LP_CPX_HDR_xdiff;L1LP_CPX_LDR_xdiff];
L1LP_CPX_time = [L1LP_CPX_HDR_time;L1LP_CPX_LDR_time];
L1LP_SPX_xdiff = [L1LP_SPX_HDR_xdiff;L1LP_SPX_LDR_xdiff];
L1LP_SPX_time = [L1LP_SPX_HDR_time;L1LP_SPX_LDR_time];
l1MAGIC_xdiff = [l1MAGIC_HDR_xdiff;l1MAGIC_LDR_xdiff];
l1MAGIC_time = [l1MAGIC_HDR_time;l1MAGIC_LDR_time];
l1MAGIC_HOC_xdiff = [l1MAGIC_HOC_HDR_xdiff;l1MAGIC_HOC_LDR_xdiff];
l1MAGIC_HOC_time = [l1MAGIC_HOC_HDR_time;l1MAGIC_HOC_LDR_time];
SolveBP_xdiff = [SolveBP_HDR_xdiff;SolveBP_LDR_xdiff];
SolveBP_time = [SolveBP_HDR_time;SolveBP_LDR_time];
SolveBP_HOC_xdiff = [SolveBP_HOC_HDR_xdiff;SolveBP_HOC_LDR_xdiff];
SolveBP_HOC_time = [SolveBP_HOC_HDR_time;SolveBP_HOC_LDR_time];
SPGL1_xdiff = [SPGL1_HDR_xdiff;SPGL1_LDR_xdiff];
SPGL1_time = [SPGL1_HDR_time;SPGL1_LDR_time];
SPGL1_HOC_xdiff = [SPGL1_HOC_HDR_xdiff;SPGL1_HOC_LDR_xdiff];
SPGL1_HOC_time = [SPGL1_HOC_HDR_time;SPGL1_HOC_LDR_time];
YALL1_xdiff = [YALL1_HDR_xdiff;YALL1_LDR_xdiff];
YALL1_time = [YALL1_HDR_time;YALL1_LDR_time];
YALL1_HOC_xdiff = [YALL1_HOC_HDR_xdiff;YALL1_HOC_LDR_xdiff];
YALL1_HOC_time = [YALL1_HOC_HDR_time;YALL1_HOC_LDR_time];

%% Define some constants:

papersz = [12 9];
paperpos = [-0.2 0 13.2 9.5];
fontsz = 12;
markersz = 12;
xticks = [1e-2,1e-1,1e0,1e1,1e2];
yticks = [1e-12,1e-6,1e0,1e6];

HDR = 1:274;   HDRerc = 1:200;   HDRnonERC = 201:274;
LDR = 275:548; LDRerc = 275:474; LDRnonERC = 475:548;
TSerc = [HDRerc,LDRerc];
TSnonERC = [HDRnonERC,LDRnonERC];

tmax = ceil(max([Homotopy_HDR_time;Homotopy_WS_HDR_time;Homotopy_1em9_HDR_time;Homotopy_HOC_HDR_time;Homotopy_HOC_WS_HDR_time;Homotopy_HOC_1em9_HDR_time;Homotopy_HOC_WS_1em9_HDR_time;Homotopy_WS_1em9_HDR_time;ISAL1_noHOC_HDR_time;ISAL1_HDR_time;L1LP_CPX_HDR_time;L1LP_SPX_HDR_time;SPGL1_HDR_time;SPGL1_HOC_HDR_time;YALL1_HDR_time;YALL1_HOC_HDR_time;l1MAGIC_HDR_time;l1MAGIC_HOC_HDR_time;SolveBP_HDR_time;SolveBP_HOC_HDR_time;    Homotopy_LDR_time;Homotopy_WS_LDR_time;Homotopy_1em9_LDR_time;Homotopy_HOC_LDR_time;Homotopy_HOC_WS_LDR_time;Homotopy_HOC_1em9_LDR_time;Homotopy_HOC_WS_1em9_LDR_time;Homotopy_WS_1em9_LDR_time;ISAL1_noHOC_LDR_time;ISAL1_LDR_time;L1LP_CPX_LDR_time;L1LP_SPX_LDR_time;SPGL1_LDR_time;SPGL1_HOC_LDR_time;YALL1_LDR_time;YALL1_HOC_LDR_time;l1MAGIC_LDR_time;l1MAGIC_HOC_LDR_time;SolveBP_LDR_time;SolveBP_HOC_LDR_time]))+10;
ymax = ceil(max([Homotopy_HDR_xdiff;Homotopy_WS_HDR_xdiff;Homotopy_1em9_HDR_xdiff;Homotopy_HOC_HDR_xdiff;Homotopy_HOC_WS_HDR_xdiff;Homotopy_HOC_1em9_HDR_xdiff;Homotopy_HOC_WS_1em9_HDR_xdiff;Homotopy_WS_1em9_HDR_xdiff;ISAL1_noHOC_HDR_xdiff;ISAL1_HDR_xdiff;L1LP_CPX_HDR_xdiff;L1LP_SPX_HDR_xdiff;SPGL1_HDR_xdiff;SPGL1_HOC_HDR_xdiff;YALL1_HDR_xdiff;YALL1_HOC_HDR_xdiff;l1MAGIC_HDR_xdiff;l1MAGIC_HOC_HDR_xdiff;SolveBP_HDR_xdiff;SolveBP_HOC_HDR_xdiff;   Homotopy_LDR_xdiff;Homotopy_WS_LDR_xdiff;Homotopy_1em9_LDR_xdiff;Homotopy_HOC_LDR_xdiff;Homotopy_HOC_WS_LDR_xdiff;Homotopy_HOC_1em9_LDR_xdiff;Homotopy_HOC_WS_1em9_LDR_xdiff;Homotopy_WS_1em9_LDR_xdiff;ISAL1_noHOC_LDR_xdiff;ISAL1_LDR_xdiff;L1LP_CPX_LDR_xdiff;L1LP_SPX_LDR_xdiff;SPGL1_LDR_xdiff;SPGL1_HOC_LDR_xdiff;YALL1_LDR_xdiff;YALL1_HOC_LDR_xdiff;l1MAGIC_LDR_xdiff;l1MAGIC_HOC_LDR_xdiff;SolveBP_LDR_xdiff;SolveBP_HOC_LDR_xdiff]))+5e7;


%% ---- Plots for all solvers (all w/o HOC): ---- ---- ---- ----
if( plot_all )
    % (always in color, grayscale option is ignored...)
    markersz = 20; fontsz = 16;
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    loglog(ISAL1_noHOC_HDR_time,ISAL1_noHOC_HDR_xdiff,'.b','MarkerSize',markersz);              % blue
    loglog(SPGL1_HDR_time,SPGL1_HDR_xdiff,'.r','MarkerSize',markersz);                          % red
    loglog(YALL1_HDR_time,YALL1_HDR_xdiff,'.k','MarkerSize',markersz);                          % black
    loglog(L1LP_CPX_HDR_time,L1LP_CPX_HDR_xdiff,'.g','MarkerSize',markersz);                    % green
    loglog(L1LP_SPX_HDR_time,L1LP_SPX_HDR_xdiff,'.','Color',[0 0.8 0],'MarkerSize',markersz);   % darker green
    loglog(l1MAGIC_HDR_time,l1MAGIC_HDR_xdiff,'.','Color',[0 0.8 0.8],'MarkerSize',markersz);   % cyan (80%)
    loglog(SolveBP_HDR_time,SolveBP_HDR_xdiff,'.m','MarkerSize',markersz);                      % magenta
    loglog(Homotopy_HDR_time,Homotopy_HDR_xdiff,'.','Color',[0.9 0.4 0],'MarkerSize',markersz); % orange
    leg=legend('ISAL1','SPGL1','YALL1','CPLEX','SoPlex','l1-MAGIC',sprintf('SparseLab /\nPDCO'),'Homotopy','Location','NorthEastOutside');
    %set(leg,'Color','none');
    set(leg,'FontSize',16);
    ylim([1e-16 ymax]);
    xlim([5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{2}$','FontSize',fontsz,'Interpreter','Latex');
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    %title('Running Time vs. Distance to Optimum','FontSize',32);
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','Running Time vs. Distance to Optimum (without HOC) [HDR testset]'); % Fig. Window title
    %set(gcf,'PaperPosition', paperpos);
    %set(gcf','Papersize', papersz);
    %orient landscape
    set(gcf,'PaperUnits','points'); % better for beamer ...
    set(gcf,'PaperSize',[720 360]);
    set(gcf,'PaperPosition',[0 360.2 740 380]);
    set(gcf,'PaperOrientation','landscape');
    saveas(gcf,'HDR_all_solvers_wo_HOC','pdf');
    
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    loglog(ISAL1_noHOC_LDR_time,ISAL1_noHOC_LDR_xdiff,'.b','MarkerSize',markersz);              % blue
    loglog(SPGL1_LDR_time,SPGL1_LDR_xdiff,'.r','MarkerSize',markersz);                          % red
    loglog(YALL1_LDR_time,YALL1_LDR_xdiff,'.k','MarkerSize',markersz);                          % black
    loglog(L1LP_CPX_LDR_time,L1LP_CPX_LDR_xdiff,'.g','MarkerSize',markersz);                    % green
    loglog(L1LP_SPX_LDR_time,L1LP_SPX_LDR_xdiff,'.','Color',[0 0.8 0],'MarkerSize',markersz);   % darker green
    loglog(l1MAGIC_LDR_time,l1MAGIC_LDR_xdiff,'.','Color',[0 0.8 0.8],'MarkerSize',markersz);   % cyan (80%)
    loglog(SolveBP_LDR_time,SolveBP_LDR_xdiff,'.m','MarkerSize',markersz);                      % magenta
    loglog(Homotopy_LDR_time,Homotopy_LDR_xdiff,'.','Color',[0.9 0.4 0],'MarkerSize',markersz); % orange
    leg=legend('ISAL1','SPGL1','YALL1','CPLEX','SoPlex','l1-MAGIC',sprintf('SparseLab /\nPDCO'),'Homotopy','Location','NorthEastOutside');
    %set(leg,'Color','none');
    set(leg,'FontSize',16);
    ylim([1e-16 ymax]);
    xlim([5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{2}$','FontSize',fontsz,'Interpreter','Latex');
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    %title('Running Time vs. Distance to Optimum','FontSize',32);
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','Running Time vs. Distance to Optimum (without HOC) [LDR testset]'); % Fig. Window title
    %set(gcf,'PaperPosition', paperpos);
    %set(gcf','Papersize', papersz);
    %orient landscape
    set(gcf,'PaperUnits','points'); % better for beamer ...
    set(gcf,'PaperSize',[720 360]);
    set(gcf,'PaperPosition',[0 360.2 740 380]);
    set(gcf,'PaperOrientation','landscape');
    saveas(gcf,'LDR_all_solvers_wo_HOC','pdf');
    
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    loglog(ISAL1_noHOC_time,ISAL1_noHOC_xdiff,'.b','MarkerSize',markersz);              % blue
    loglog(SPGL1_time,SPGL1_xdiff,'.r','MarkerSize',markersz);                          % red
    loglog(YALL1_time,YALL1_xdiff,'.k','MarkerSize',markersz);                          % black
    loglog(L1LP_CPX_time,L1LP_CPX_xdiff,'.g','MarkerSize',markersz);                    % green
    loglog(L1LP_SPX_time,L1LP_SPX_xdiff,'.','Color',[0 0.8 0],'MarkerSize',markersz);   % darker green
    loglog(l1MAGIC_time,l1MAGIC_xdiff,'.','Color',[0 0.8 0.8],'MarkerSize',markersz);   % cyan (80%)
    loglog(SolveBP_time,SolveBP_xdiff,'.m','MarkerSize',markersz);                      % magenta
    loglog(Homotopy_time,Homotopy_xdiff,'.','Color',[0.9 0.4 0],'MarkerSize',markersz); % orange
    leg=legend('ISAL1','SPGL1','YALL1','CPLEX','SoPlex','l1-MAGIC',sprintf('SparseLab /\nPDCO'),'Homotopy','Location','NorthEastOutside');
    %set(leg,'Color','none');
    set(leg,'FontSize',16);
    ylim([1e-16 ymax]);
    xlim([5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{2}$','FontSize',fontsz,'Interpreter','Latex');
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    %title('Running Time vs. Distance to Optimum','FontSize',32);
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','Running Time vs. Distance to Optimum (without HOC) [HDR and LDR testsets]'); % Fig. Window title
    %set(gcf,'PaperPosition', paperpos);
    %set(gcf','Papersize', papersz);
    %orient landscape
    set(gcf,'PaperUnits','points'); % better for beamer ...
    set(gcf,'PaperSize',[720 360]);
    set(gcf,'PaperPosition',[0 360.2 740 380]);
    set(gcf,'PaperOrientation','landscape');
    saveas(gcf,'HDRandLDR_all_solvers_wo_HOC','pdf');
    
    % ---- Plot for all solvers (ISAL1,SPGL1,YALL1,l1MAGIC,Homotopy,SolveBP w/ HOC): ---- ---- ---- ----
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    loglog(ISAL1_HDR_time,ISAL1_HDR_xdiff,'.b','MarkerSize',markersz);                                  % blue
    loglog(SPGL1_HOC_HDR_time,SPGL1_HOC_HDR_xdiff,'.r','MarkerSize',markersz);                          % red
    loglog(YALL1_HOC_HDR_time,YALL1_HOC_HDR_xdiff,'.k','MarkerSize',markersz);                          % black
    loglog(L1LP_CPX_HDR_time,L1LP_CPX_HDR_xdiff,'.g','MarkerSize',markersz);                            % light green
    loglog(L1LP_SPX_HDR_time,L1LP_SPX_HDR_xdiff,'.','Color',[0 0.8 0],'MarkerSize',markersz);           % darker green
    loglog(l1MAGIC_HOC_HDR_time,l1MAGIC_HOC_HDR_xdiff,'.','Color',[0 0.8 0.8],'MarkerSize',markersz);   % cyan (80%)
    loglog(SolveBP_HOC_HDR_time,SolveBP_HOC_HDR_xdiff,'.m','MarkerSize',markersz);                      % magenta
    loglog(Homotopy_HOC_HDR_time,Homotopy_HOC_HDR_xdiff,'.','Color',[0.9 0.4 0],'MarkerSize',markersz); % orange
    leg=legend(sprintf('ISAL1 (w/ HOC)'),sprintf('SPGL1 (w/ HOC)'),sprintf('YALL1 (w/ HOC)'),'CPLEX','SoPlex',sprintf('l1-MAGIC (w/ HOC)'),sprintf('SparseLab/PDCO (w/ HOC)'),sprintf('Homotopy (w/ HOC)'),'Location','NorthEastOutside');
    %set(leg,'Color','none');
    set(leg,'FontSize',16);
    ylim([1e-16 ymax]);
    xlim([5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{2}$','FontSize',fontsz,'Interpreter','Latex');
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    %title('Running Time vs. Distance to Optimum','FontSize',32);
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','Running Time vs. Distance to Optimum (HOC included) [HDR testset]'); % Fig. Window title
    %set(gcf,'PaperPosition', paperpos);
    %set(gcf','Papersize', papersz);
    %orient landscape
    set(gcf,'PaperUnits','points'); % better for beamer ...
    set(gcf,'PaperSize',[720 360]);
    set(gcf,'PaperPosition',[0 360.2 740 380]);
    set(gcf,'PaperOrientation','landscape');
    saveas(gcf,'HDR_all_solvers_w_HOC','pdf');
    
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    loglog(ISAL1_LDR_time,ISAL1_LDR_xdiff,'.b','MarkerSize',markersz);                                  % blue
    loglog(SPGL1_HOC_LDR_time,SPGL1_HOC_LDR_xdiff,'.r','MarkerSize',markersz);                          % red
    loglog(YALL1_HOC_LDR_time,YALL1_HOC_LDR_xdiff,'.k','MarkerSize',markersz);                          % black
    loglog(L1LP_CPX_LDR_time,L1LP_CPX_LDR_xdiff,'.g','MarkerSize',markersz);                            % light green
    loglog(L1LP_SPX_LDR_time,L1LP_SPX_LDR_xdiff,'.','Color',[0 0.8 0],'MarkerSize',markersz);           % darker green
    loglog(l1MAGIC_HOC_LDR_time,l1MAGIC_HOC_LDR_xdiff,'.','Color',[0 0.8 0.8],'MarkerSize',markersz);   % cyan (80%)
    loglog(SolveBP_HOC_LDR_time,SolveBP_HOC_LDR_xdiff,'.m','MarkerSize',markersz);                      % magenta
    loglog(Homotopy_HOC_LDR_time,Homotopy_HOC_LDR_xdiff,'.','Color',[0.9 0.4 0],'MarkerSize',markersz); % orange
    leg=legend(sprintf('ISAL1 (w/ HOC)'),sprintf('SPGL1 (w/ HOC)'),sprintf('YALL1 (w/ HOC)'),'CPLEX','SoPlex',sprintf('l1-MAGIC (w/ HOC)'),sprintf('SparseLab/PDCO (w/ HOC)'),sprintf('Homotopy (w/ HOC)'),'Location','NorthEastOutside');
    %set(leg,'Color','none');
    set(leg,'FontSize',16);
    ylim([1e-16 ymax]);
    xlim([5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{2}$','FontSize',fontsz,'Interpreter','Latex');
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    %title('Running Time vs. Distance to Optimum','FontSize',32);
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','Running Time vs. Distance to Optimum (HOC included) [LDR testset]'); % Fig. Window title
    %set(gcf,'PaperPosition', paperpos);
    %set(gcf','Papersize', papersz);
    %orient landscape
    set(gcf,'PaperUnits','points'); % better for beamer ...
    set(gcf,'PaperSize',[720 360]);
    set(gcf,'PaperPosition',[0 360.2 740 380]);
    set(gcf,'PaperOrientation','landscape');
    saveas(gcf,'LDR_all_solvers_w_HOC','pdf');
    
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    loglog(ISAL1_time,ISAL1_xdiff,'.b','MarkerSize',markersz);                                  % blue
    loglog(SPGL1_HOC_time,SPGL1_HOC_xdiff,'.r','MarkerSize',markersz);                          % red
    loglog(YALL1_HOC_time,YALL1_HOC_xdiff,'.k','MarkerSize',markersz);                          % black
    loglog(L1LP_CPX_time,L1LP_CPX_xdiff,'.g','MarkerSize',markersz);                            % light green
    loglog(L1LP_SPX_time,L1LP_SPX_xdiff,'.','Color',[0 0.8 0],'MarkerSize',markersz);           % darker green
    loglog(l1MAGIC_HOC_time,l1MAGIC_HOC_xdiff,'.','Color',[0 0.8 0.8],'MarkerSize',markersz);   % cyan (80%)
    loglog(SolveBP_HOC_time,SolveBP_HOC_xdiff,'.m','MarkerSize',markersz);                      % magenta
    loglog(Homotopy_HOC_time,Homotopy_HOC_xdiff,'.','Color',[0.9 0.4 0],'MarkerSize',markersz); % orange
    leg=legend(sprintf('ISAL1 (w/ HOC)'),sprintf('SPGL1 (w/ HOC)'),sprintf('YALL1 (w/ HOC)'),'CPLEX','SoPlex',sprintf('l1-MAGIC (w/ HOC)'),sprintf('SparseLab/PDCO (w/ HOC)'),sprintf('Homotopy (w/ HOC)'),'Location','NorthEastOutside');
    %set(leg,'Color','none');
    set(leg,'FontSize',16);
    ylim([1e-16 ymax]);
    xlim([5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{2}$','FontSize',fontsz,'Interpreter','Latex');
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    %title('Running Time vs. Distance to Optimum','FontSize',32);
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','Running Time vs. Distance to Optimum (HOC included) [HDR and LDR testsets]'); % Fig. Window title
    %set(gcf,'PaperPosition', paperpos);
    %set(gcf','Papersize', papersz);
    %orient landscape
    set(gcf,'PaperUnits','points'); % better for beamer ...
    set(gcf,'PaperSize',[720 360]);
    set(gcf,'PaperPosition',[0 360.2 740 380]);
    set(gcf,'PaperOrientation','landscape');
    saveas(gcf,'HDRandLDR_all_solvers_w_HOC','pdf');
    
    markersz = 12; fontsz = 12;
end

%% Separate Plots for each solver (w/ and w/o HOC...) :
if( plot_sepa )
    
    % ISAL1: %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(ISAL1_noHOC_HDR_time(1:200),ISAL1_noHOC_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(ISAL1_noHOC_HDR_time(201:end),ISAL1_noHOC_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(ISAL1_noHOC_HDR_time(1:200),ISAL1_noHOC_HDR_xdiff(1:200),'.b','MarkerSize',markersz);              % blue
        loglog(ISAL1_noHOC_HDR_time(201:end),ISAL1_noHOC_HDR_xdiff(201:end),'xb','MarkerSize',markersz*0.4);      % blue
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('ISAL1 w/o HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','ISAL1 w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_ISAL1_wo_HOC','pdf');
    
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(ISAL1_noHOC_LDR_time(1:200),ISAL1_noHOC_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(ISAL1_noHOC_LDR_time(201:end),ISAL1_noHOC_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(ISAL1_noHOC_LDR_time(1:200),ISAL1_noHOC_LDR_xdiff(1:200),'.b','MarkerSize',markersz);              % blue
        loglog(ISAL1_noHOC_LDR_time(201:end),ISAL1_noHOC_LDR_xdiff(201:end),'xb','MarkerSize',markersz*0.4);      % blue
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('ISAL1 w/o HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','ISAL1 w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_ISAL1_wo_HOC','pdf');

    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(ISAL1_noHOC_HDR_time(1:200),ISAL1_noHOC_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(ISAL1_noHOC_HDR_time(201:end),ISAL1_noHOC_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(ISAL1_noHOC_LDR_time(1:200),ISAL1_noHOC_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(ISAL1_noHOC_LDR_time(201:end),ISAL1_noHOC_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(ISAL1_noHOC_HDR_time(1:200),ISAL1_noHOC_HDR_xdiff(1:200),'^b','MarkerSize',markersz*0.4);          % blue
        loglog(ISAL1_noHOC_HDR_time(201:end),ISAL1_noHOC_HDR_xdiff(201:end),'vb','MarkerSize',markersz*0.4);      % blue
        loglog(ISAL1_noHOC_LDR_time(1:200),ISAL1_noHOC_LDR_xdiff(1:200),'*b','MarkerSize',markersz*0.4);          % blue
        loglog(ISAL1_noHOC_LDR_time(201:end),ISAL1_noHOC_LDR_xdiff(201:end),'xb','MarkerSize',markersz*0.4);      % blue
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('ISAL1 w/o HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','ISAL1 w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_ISAL1_wo_HOC','pdf');    
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(ISAL1_HDR_time(1:200),ISAL1_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(ISAL1_HDR_time(201:end),ISAL1_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(ISAL1_HDR_time(1:200),ISAL1_HDR_xdiff(1:200),'.b','MarkerSize',markersz);              % blue
        loglog(ISAL1_HDR_time(201:end),ISAL1_HDR_xdiff(201:end),'xb','MarkerSize',markersz*0.4);      % blue
    end
    ylim([1e-16 ymax]);
    xlim([5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('ISAL1 w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','ISAL1 w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_ISAL1_w_HOC','pdf');

    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(ISAL1_LDR_time(1:200),ISAL1_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(ISAL1_LDR_time(201:end),ISAL1_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(ISAL1_LDR_time(1:200),ISAL1_LDR_xdiff(1:200),'.b','MarkerSize',markersz);              % blue
        loglog(ISAL1_LDR_time(201:end),ISAL1_LDR_xdiff(201:end),'xb','MarkerSize',markersz*0.4);      % blue
    end
    ylim([1e-16 ymax]);
    xlim([5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('ISAL1 w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','ISAL1 w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_ISAL1_w_HOC','pdf');
    
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(ISAL1_HDR_time(1:200),ISAL1_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(ISAL1_HDR_time(201:end),ISAL1_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(ISAL1_LDR_time(1:200),ISAL1_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(ISAL1_LDR_time(201:end),ISAL1_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(ISAL1_HDR_time(1:200),ISAL1_HDR_xdiff(1:200),'^b','MarkerSize',markersz*0.4);          % blue
        loglog(ISAL1_HDR_time(201:end),ISAL1_HDR_xdiff(201:end),'vb','MarkerSize',markersz*0.4);      % blue
        loglog(ISAL1_LDR_time(1:200),ISAL1_LDR_xdiff(1:200),'*b','MarkerSize',markersz*0.4);          % blue
        loglog(ISAL1_LDR_time(201:end),ISAL1_LDR_xdiff(201:end),'xb','MarkerSize',markersz*0.4);      % blue
    end
    ylim([1e-16 ymax]);
    xlim([5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('ISAL1 w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','ISAL1 w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_ISAL1_w_HOC','pdf');
    

    % SPGL1: %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(SPGL1_HDR_time(1:200),SPGL1_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(SPGL1_HDR_time(201:end),SPGL1_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(SPGL1_HDR_time(1:200),SPGL1_HDR_xdiff(1:200),'.r','MarkerSize',markersz);              % red
        loglog(SPGL1_HDR_time(201:end),SPGL1_HDR_xdiff(201:end),'xr','MarkerSize',markersz*0.4);      % red
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('SPGL1 w/o HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','SPGL1 w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_SPGL1_wo_HOC','pdf');
        
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(SPGL1_LDR_time(1:200),SPGL1_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(SPGL1_LDR_time(201:end),SPGL1_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(SPGL1_LDR_time(1:200),SPGL1_LDR_xdiff(1:200),'.r','MarkerSize',markersz);              % red
        loglog(SPGL1_LDR_time(201:end),SPGL1_LDR_xdiff(201:end),'xr','MarkerSize',markersz*0.4);      % red
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('SPGL1 w/o HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','SPGL1 w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_SPGL1_wo_HOC','pdf');
                
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(SPGL1_HDR_time(1:200),SPGL1_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(SPGL1_HDR_time(201:end),SPGL1_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(SPGL1_LDR_time(1:200),SPGL1_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(SPGL1_LDR_time(201:end),SPGL1_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(SPGL1_HDR_time(1:200),SPGL1_HDR_xdiff(1:200),'^r','MarkerSize',markersz*0.4);          % red
        loglog(SPGL1_HDR_time(201:end),SPGL1_HDR_xdiff(201:end),'vr','MarkerSize',markersz*0.4);      % red
        loglog(SPGL1_LDR_time(1:200),SPGL1_LDR_xdiff(1:200),'*r','MarkerSize',markersz*0.4);          % red
        loglog(SPGL1_LDR_time(201:end),SPGL1_LDR_xdiff(201:end),'xr','MarkerSize',markersz*0.4);      % red
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('SPGL1 w/o HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','SPGL1 w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_SPGL1_wo_HOC','pdf');
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(SPGL1_HOC_HDR_time(1:200),SPGL1_HOC_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(SPGL1_HOC_HDR_time(201:end),SPGL1_HOC_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(SPGL1_HOC_HDR_time(1:200),SPGL1_HOC_HDR_xdiff(1:200),'.r','MarkerSize',markersz);              % red
        loglog(SPGL1_HOC_HDR_time(201:end),SPGL1_HOC_HDR_xdiff(201:end),'xr','MarkerSize',markersz*0.4);      % red
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('SPGL1 w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','SPGL1 w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_SPGL1_w_HOC','pdf');
        
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(SPGL1_HOC_LDR_time(1:200),SPGL1_HOC_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(SPGL1_HOC_LDR_time(201:end),SPGL1_HOC_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(SPGL1_HOC_LDR_time(1:200),SPGL1_HOC_LDR_xdiff(1:200),'.r','MarkerSize',markersz);              % red
        loglog(SPGL1_HOC_LDR_time(201:end),SPGL1_HOC_LDR_xdiff(201:end),'xr','MarkerSize',markersz*0.4);      % red
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('SPGL1 w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','SPGL1 w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_SPGL1_w_HOC','pdf');    
    
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(SPGL1_HOC_HDR_time(1:200),SPGL1_HOC_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(SPGL1_HOC_HDR_time(201:end),SPGL1_HOC_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(SPGL1_HOC_LDR_time(1:200),SPGL1_HOC_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(SPGL1_HOC_LDR_time(201:end),SPGL1_HOC_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(SPGL1_HOC_HDR_time(1:200),SPGL1_HOC_HDR_xdiff(1:200),'^r','MarkerSize',markersz*0.4);          % red
        loglog(SPGL1_HOC_HDR_time(201:end),SPGL1_HOC_HDR_xdiff(201:end),'vr','MarkerSize',markersz*0.4);      % red
        loglog(SPGL1_HOC_LDR_time(1:200),SPGL1_HOC_LDR_xdiff(1:200),'*r','MarkerSize',markersz*0.4);          % red
        loglog(SPGL1_HOC_LDR_time(201:end),SPGL1_HOC_LDR_xdiff(201:end),'xr','MarkerSize',markersz*0.4);      % red
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('SPGL1 w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','SPGL1 w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_SPGL1_w_HOC','pdf');
    
    
    % YALL1: %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    loglog(YALL1_HDR_time(1:200),YALL1_HDR_xdiff(1:200),'.k','MarkerSize',markersz);              % black
    loglog(YALL1_HDR_time(201:end),YALL1_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);      % black
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('YALL1 w/o HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','YALL1 w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_YALL1_wo_HOC','pdf');
        
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    loglog(YALL1_LDR_time(1:200),YALL1_LDR_xdiff(1:200),'.k','MarkerSize',markersz);              % black
    loglog(YALL1_LDR_time(201:end),YALL1_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);      % black
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('YALL1 w/o HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','YALL1 w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_YALL1_wo_HOC','pdf');    
    
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    loglog(YALL1_HDR_time(1:200),YALL1_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);          % black
    loglog(YALL1_HDR_time(201:end),YALL1_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);      % black
    loglog(YALL1_LDR_time(1:200),YALL1_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);          % black
    loglog(YALL1_LDR_time(201:end),YALL1_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);      % black
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('YALL1 w/o HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','YALL1 w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_YALL1_wo_HOC','pdf');
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    loglog(YALL1_HOC_HDR_time(1:200),YALL1_HOC_HDR_xdiff(1:200),'.k','MarkerSize',markersz);              % black
    loglog(YALL1_HOC_HDR_time(201:end),YALL1_HOC_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);      % black
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('YALL1 w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','YALL1 w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_YALL1_w_HOC','pdf');
    
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    loglog(YALL1_HOC_LDR_time(1:200),YALL1_HOC_LDR_xdiff(1:200),'.k','MarkerSize',markersz);              % black
    loglog(YALL1_HOC_LDR_time(201:end),YALL1_HOC_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);      % black
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('YALL1 w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','YALL1 w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_YALL1_w_HOC','pdf');
    
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    loglog(YALL1_HOC_HDR_time(1:200),YALL1_HOC_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);          % black
    loglog(YALL1_HOC_HDR_time(201:end),YALL1_HOC_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);      % black
    loglog(YALL1_HOC_LDR_time(1:200),YALL1_HOC_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);          % black
    loglog(YALL1_HOC_LDR_time(201:end),YALL1_HOC_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);      % black
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('YALL1 w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','YALL1 w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_YALL1_w_HOC','pdf');
    
    
    % l1-Magic: %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(l1MAGIC_HDR_time(1:200),l1MAGIC_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(l1MAGIC_HDR_time(201:end),l1MAGIC_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(l1MAGIC_HDR_time(1:200),l1MAGIC_HDR_xdiff(1:200),'.','Color',[0 0.8 0.8],'MarkerSize',markersz);              % cyan
        loglog(l1MAGIC_HDR_time(201:end),l1MAGIC_HDR_xdiff(201:end),'x','Color',[0 0.8 0.8],'MarkerSize',markersz*0.4);      % cyan
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('l1-MAGIC w/o HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','l1MAGIC w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_l1magic_wo_HOC','pdf');
        
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(l1MAGIC_LDR_time(1:200),l1MAGIC_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(l1MAGIC_LDR_time(201:end),l1MAGIC_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(l1MAGIC_LDR_time(1:200),l1MAGIC_LDR_xdiff(1:200),'.','Color',[0 0.8 0.8],'MarkerSize',markersz);              % cyan
        loglog(l1MAGIC_LDR_time(201:end),l1MAGIC_LDR_xdiff(201:end),'x','Color',[0 0.8 0.8],'MarkerSize',markersz*0.4);      % cyan
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('l1-MAGIC w/o HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','l1MAGIC w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_l1magic_wo_HOC','pdf');
        
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(l1MAGIC_HDR_time(1:200),l1MAGIC_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(l1MAGIC_HDR_time(201:end),l1MAGIC_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(l1MAGIC_LDR_time(1:200),l1MAGIC_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(l1MAGIC_LDR_time(201:end),l1MAGIC_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(l1MAGIC_HDR_time(1:200),l1MAGIC_HDR_xdiff(1:200),'^','Color',[0 0.8 0.8],'MarkerSize',markersz*0.4);          % cyan
        loglog(l1MAGIC_HDR_time(201:end),l1MAGIC_HDR_xdiff(201:end),'v','Color',[0 0.8 0.8],'MarkerSize',markersz*0.4);      % cyan
        loglog(l1MAGIC_LDR_time(1:200),l1MAGIC_LDR_xdiff(1:200),'*','Color',[0 0.8 0.8],'MarkerSize',markersz*0.4);          % cyan
        loglog(l1MAGIC_LDR_time(201:end),l1MAGIC_LDR_xdiff(201:end),'x','Color',[0 0.8 0.8],'MarkerSize',markersz*0.4);      % cyan
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('l1-MAGIC w/o HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','l1MAGIC w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_l1magic_wo_HOC','pdf');
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(l1MAGIC_HOC_HDR_time(1:200),l1MAGIC_HOC_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(l1MAGIC_HOC_HDR_time(201:end),l1MAGIC_HOC_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(l1MAGIC_HOC_HDR_time(1:200),l1MAGIC_HOC_HDR_xdiff(1:200),'.','Color',[0 0.8 0.8],'MarkerSize',markersz);              % cyan
        loglog(l1MAGIC_HOC_HDR_time(201:end),l1MAGIC_HOC_HDR_xdiff(201:end),'x','Color',[0 0.8 0.8],'MarkerSize',markersz*0.4);      % cyan
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('l1-MAGIC w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','l1MAGIC w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_l1magic_w_HOC','pdf');
        
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(l1MAGIC_HOC_LDR_time(1:200),l1MAGIC_HOC_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(l1MAGIC_HOC_LDR_time(201:end),l1MAGIC_HOC_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(l1MAGIC_HOC_LDR_time(1:200),l1MAGIC_HOC_LDR_xdiff(1:200),'.','Color',[0 0.8 0.8],'MarkerSize',markersz);              % cyan
        loglog(l1MAGIC_HOC_LDR_time(201:end),l1MAGIC_HOC_LDR_xdiff(201:end),'x','Color',[0 0.8 0.8],'MarkerSize',markersz*0.4);      % cyan
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('l1-MAGIC w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','l1MAGIC w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_l1magic_w_HOC','pdf');
        
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(l1MAGIC_HOC_HDR_time(1:200),l1MAGIC_HOC_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(l1MAGIC_HOC_HDR_time(201:end),l1MAGIC_HOC_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(l1MAGIC_HOC_LDR_time(1:200),l1MAGIC_HOC_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(l1MAGIC_HOC_LDR_time(201:end),l1MAGIC_HOC_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(l1MAGIC_HOC_HDR_time(1:200),l1MAGIC_HOC_HDR_xdiff(1:200),'^','Color',[0 0.8 0.8],'MarkerSize',markersz*0.4);          % cyan
        loglog(l1MAGIC_HOC_HDR_time(201:end),l1MAGIC_HOC_HDR_xdiff(201:end),'v','Color',[0 0.8 0.8],'MarkerSize',markersz*0.4);      % cyan
        loglog(l1MAGIC_HOC_LDR_time(1:200),l1MAGIC_HOC_LDR_xdiff(1:200),'*','Color',[0 0.8 0.8],'MarkerSize',markersz*0.4);          % cyan
        loglog(l1MAGIC_HOC_LDR_time(201:end),l1MAGIC_HOC_LDR_xdiff(201:end),'x','Color',[0 0.8 0.8],'MarkerSize',markersz*0.4);      % cyan
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('l1-MAGIC w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','l1MAGIC w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_l1magic_w_HOC','pdf');
    
    
    % L1LP (CPLEX): %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(L1LP_CPX_HDR_time(1:200),L1LP_CPX_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(L1LP_CPX_HDR_time(201:end),L1LP_CPX_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(L1LP_CPX_HDR_time(1:200),L1LP_CPX_HDR_xdiff(1:200),'.g','MarkerSize',markersz);              % light green
        loglog(L1LP_CPX_HDR_time(201:end),L1LP_CPX_HDR_xdiff(201:end),'xg','MarkerSize',markersz*0.4);      % light green
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('CPLEX','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1LP (CPLEX) w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_CPLEX_wo_HOC','pdf');
    
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(L1LP_CPX_LDR_time(1:200),L1LP_CPX_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(L1LP_CPX_LDR_time(201:end),L1LP_CPX_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(L1LP_CPX_LDR_time(1:200),L1LP_CPX_LDR_xdiff(1:200),'.g','MarkerSize',markersz);              % light green
        loglog(L1LP_CPX_LDR_time(201:end),L1LP_CPX_LDR_xdiff(201:end),'xg','MarkerSize',markersz*0.4);      % light green
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('CPLEX','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1LP (CPLEX) w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_CPLEX_wo_HOC','pdf');
    
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(L1LP_CPX_HDR_time(1:200),L1LP_CPX_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(L1LP_CPX_HDR_time(201:end),L1LP_CPX_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(L1LP_CPX_LDR_time(1:200),L1LP_CPX_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(L1LP_CPX_LDR_time(201:end),L1LP_CPX_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(L1LP_CPX_HDR_time(1:200),L1LP_CPX_HDR_xdiff(1:200),'^g','MarkerSize',markersz*0.4);          % light green
        loglog(L1LP_CPX_HDR_time(201:end),L1LP_CPX_HDR_xdiff(201:end),'vg','MarkerSize',markersz*0.4);      % light green
        loglog(L1LP_CPX_LDR_time(1:200),L1LP_CPX_LDR_xdiff(1:200),'*g','MarkerSize',markersz*0.4);          % light green
        loglog(L1LP_CPX_LDR_time(201:end),L1LP_CPX_LDR_xdiff(201:end),'xg','MarkerSize',markersz*0.4);      % light green
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('CPLEX','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1LP (CPLEX) w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_CPLEX_wo_HOC','pdf');
    
    
    % L1LP (SoPLEX): %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(L1LP_SPX_HDR_time(1:200),L1LP_SPX_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(L1LP_SPX_HDR_time(201:end),L1LP_SPX_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(L1LP_SPX_HDR_time(1:200),L1LP_SPX_HDR_xdiff(1:200),'.','Color',[0 0.8 0],'MarkerSize',markersz);              % darker green
        loglog(L1LP_SPX_HDR_time(201:end),L1LP_SPX_HDR_xdiff(201:end),'x','Color',[0 0.8 0],'MarkerSize',markersz*0.4);      % darker green
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('SoPlex','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1LP (SoPlex) w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_SoPlex_wo_HOC','pdf');
    
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(L1LP_SPX_LDR_time(1:200),L1LP_SPX_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(L1LP_SPX_LDR_time(201:end),L1LP_SPX_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(L1LP_SPX_LDR_time(1:200),L1LP_SPX_LDR_xdiff(1:200),'.','Color',[0 0.8 0],'MarkerSize',markersz);              % darker green
        loglog(L1LP_SPX_LDR_time(201:end),L1LP_SPX_LDR_xdiff(201:end),'x','Color',[0 0.8 0],'MarkerSize',markersz*0.4);      % darker green
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('SoPlex','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1LP (SoPlex) w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_SoPlex_wo_HOC','pdf');
    
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(L1LP_SPX_HDR_time(1:200),L1LP_SPX_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(L1LP_SPX_HDR_time(201:end),L1LP_SPX_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(L1LP_SPX_LDR_time(1:200),L1LP_SPX_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(L1LP_SPX_LDR_time(201:end),L1LP_SPX_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(L1LP_SPX_HDR_time(1:200),L1LP_SPX_HDR_xdiff(1:200),'^','Color',[0 0.8 0],'MarkerSize',markersz*0.4);          % darker green
        loglog(L1LP_SPX_HDR_time(201:end),L1LP_SPX_HDR_xdiff(201:end),'v','Color',[0 0.8 0],'MarkerSize',markersz*0.4);      % darker green
        loglog(L1LP_SPX_LDR_time(1:200),L1LP_SPX_LDR_xdiff(1:200),'*','Color',[0 0.8 0],'MarkerSize',markersz*0.4);          % darker green
        loglog(L1LP_SPX_LDR_time(201:end),L1LP_SPX_LDR_xdiff(201:end),'x','Color',[0 0.8 0],'MarkerSize',markersz*0.4);      % darker green
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('SoPlex','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1LP (SoPlex) w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_SoPlex_wo_HOC','pdf');
    
    
    % SolveBP (SparseLab/PDCO): %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(SolveBP_HDR_time(1:200),SolveBP_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(SolveBP_HDR_time(201:end),SolveBP_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(SolveBP_HDR_time(1:200),SolveBP_HDR_xdiff(1:200),'.m','MarkerSize',markersz);              % magenta
        loglog(SolveBP_HDR_time(201:end),SolveBP_HDR_xdiff(201:end),'xm','MarkerSize',markersz*0.4);      % magenta
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('SparseLab/PDCO','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','SparseLab/PDCO w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_SparseLab_PDCO_wo_HOC','pdf');
        
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(SolveBP_LDR_time(1:200),SolveBP_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(SolveBP_LDR_time(201:end),SolveBP_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(SolveBP_LDR_time(1:200),SolveBP_LDR_xdiff(1:200),'.m','MarkerSize',markersz);              % magenta
        loglog(SolveBP_LDR_time(201:end),SolveBP_LDR_xdiff(201:end),'xm','MarkerSize',markersz*0.4);      % magenta
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('SparseLab/PDCO','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','SparseLab/PDCO w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_SparseLab_PDCO_wo_HOC','pdf');
        
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(SolveBP_HDR_time(1:200),SolveBP_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(SolveBP_HDR_time(201:end),SolveBP_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(SolveBP_LDR_time(1:200),SolveBP_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(SolveBP_LDR_time(201:end),SolveBP_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(SolveBP_HDR_time(1:200),SolveBP_HDR_xdiff(1:200),'^m','MarkerSize',markersz*0.4);          % magenta
        loglog(SolveBP_HDR_time(201:end),SolveBP_HDR_xdiff(201:end),'vm','MarkerSize',markersz*0.4);      % magenta
        loglog(SolveBP_LDR_time(1:200),SolveBP_LDR_xdiff(1:200),'*m','MarkerSize',markersz*0.4);          % magenta
        loglog(SolveBP_LDR_time(201:end),SolveBP_LDR_xdiff(201:end),'xm','MarkerSize',markersz*0.4);      % magenta
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('SparseLab/PDCO','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','SparseLab/PDCO w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_SparseLab_PDCO_wo_HOC','pdf');
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(SolveBP_HOC_HDR_time(1:200),SolveBP_HOC_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(SolveBP_HOC_HDR_time(201:end),SolveBP_HOC_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(SolveBP_HOC_HDR_time(1:200),SolveBP_HOC_HDR_xdiff(1:200),'.m','MarkerSize',markersz);              % magenta
        loglog(SolveBP_HOC_HDR_time(201:end),SolveBP_HOC_HDR_xdiff(201:end),'xm','MarkerSize',markersz*0.4);      % magenta
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('SparseLab/PDCO w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','SparseLab/PDCO w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_SparseLab_PDCO_w_HOC','pdf');
        
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(SolveBP_HOC_LDR_time(1:200),SolveBP_HOC_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(SolveBP_HOC_LDR_time(201:end),SolveBP_HOC_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(SolveBP_HOC_LDR_time(1:200),SolveBP_HOC_LDR_xdiff(1:200),'.m','MarkerSize',markersz);              % magenta
        loglog(SolveBP_HOC_LDR_time(201:end),SolveBP_HOC_LDR_xdiff(201:end),'xm','MarkerSize',markersz*0.4);      % magenta
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('SparseLab/PDCO w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','SparseLab/PDCO w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_SparseLab_PDCO_w_HOC','pdf');
        
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(SolveBP_HOC_HDR_time(1:200),SolveBP_HOC_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(SolveBP_HOC_HDR_time(201:end),SolveBP_HOC_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(SolveBP_HOC_LDR_time(1:200),SolveBP_HOC_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(SolveBP_HOC_LDR_time(201:end),SolveBP_HOC_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(SolveBP_HOC_HDR_time(1:200),SolveBP_HOC_HDR_xdiff(1:200),'^m','MarkerSize',markersz*0.4);          % magenta
        loglog(SolveBP_HOC_HDR_time(201:end),SolveBP_HOC_HDR_xdiff(201:end),'vm','MarkerSize',markersz*0.4);      % magenta
        loglog(SolveBP_HOC_LDR_time(1:200),SolveBP_HOC_LDR_xdiff(1:200),'*m','MarkerSize',markersz*0.4);          % magenta
        loglog(SolveBP_HOC_LDR_time(201:end),SolveBP_HOC_LDR_xdiff(201:end),'xm','MarkerSize',markersz*0.4);      % magenta
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('SparseLab/PDCO w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','SparseLab/PDCO w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_SparseLab_PDCO_w_HOC','pdf');
    
    
    % L1-Homotopy: %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_HDR_time(1:200),Homotopy_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(Homotopy_HDR_time(201:end),Homotopy_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_HDR_time(1:200),Homotopy_HDR_xdiff(1:200),'.','Color',[0.9 0.4 0],'MarkerSize',markersz);              % orange
        loglog(Homotopy_HDR_time(201:end),Homotopy_HDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1-Homotopy w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_homotopy_wo_HOC','pdf');
        
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_LDR_time(1:200),Homotopy_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(Homotopy_LDR_time(201:end),Homotopy_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_LDR_time(1:200),Homotopy_LDR_xdiff(1:200),'.','Color',[0.9 0.4 0],'MarkerSize',markersz);              % orange
        loglog(Homotopy_LDR_time(201:end),Homotopy_LDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1-Homotopy w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_homotopy_wo_HOC','pdf');
        
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_HDR_time(1:200),Homotopy_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(Homotopy_HDR_time(201:end),Homotopy_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(Homotopy_LDR_time(1:200),Homotopy_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(Homotopy_LDR_time(201:end),Homotopy_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_HDR_time(1:200),Homotopy_HDR_xdiff(1:200),'^','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);          % orange
        loglog(Homotopy_HDR_time(201:end),Homotopy_HDR_xdiff(201:end),'v','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
        loglog(Homotopy_LDR_time(1:200),Homotopy_LDR_xdiff(1:200),'*','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);          % orange
        loglog(Homotopy_LDR_time(201:end),Homotopy_LDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1-Homotopy w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_homotopy_wo_HOC','pdf');
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_WS_HDR_time(1:200),Homotopy_WS_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(Homotopy_WS_HDR_time(201:end),Homotopy_WS_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_WS_HDR_time(1:200),Homotopy_WS_HDR_xdiff(1:200),'.','Color',[0.9 0.4 0],'MarkerSize',markersz);              % orange
        loglog(Homotopy_WS_HDR_time(201:end),Homotopy_WS_HDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (WarnStop)','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1-Homotopy (warn-stop) w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_homotopy_WS_wo_HOC','pdf');
        
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_WS_LDR_time(1:200),Homotopy_WS_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(Homotopy_WS_LDR_time(201:end),Homotopy_WS_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_WS_LDR_time(1:200),Homotopy_WS_LDR_xdiff(1:200),'.','Color',[0.9 0.4 0],'MarkerSize',markersz);              % orange
        loglog(Homotopy_WS_LDR_time(201:end),Homotopy_WS_LDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (WarnStop)','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1-Homotopy (warn-stop) w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_homotopy_WS_wo_HOC','pdf');
        
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_WS_HDR_time(1:200),Homotopy_WS_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(Homotopy_WS_HDR_time(201:end),Homotopy_WS_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(Homotopy_WS_LDR_time(1:200),Homotopy_WS_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(Homotopy_WS_LDR_time(201:end),Homotopy_WS_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_WS_HDR_time(1:200),Homotopy_WS_HDR_xdiff(1:200),'^','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);          % orange
        loglog(Homotopy_WS_HDR_time(201:end),Homotopy_WS_HDR_xdiff(201:end),'v','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
        loglog(Homotopy_WS_LDR_time(1:200),Homotopy_WS_LDR_xdiff(1:200),'*','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);          % orange
        loglog(Homotopy_WS_LDR_time(201:end),Homotopy_WS_LDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (WarnStop)','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1-Homotopy (warn-stop) w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_homotopy_WS_wo_HOC','pdf');
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_1em9_HDR_time(1:200),Homotopy_1em9_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(Homotopy_1em9_HDR_time(201:end),Homotopy_1em9_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_1em9_HDR_time(1:200),Homotopy_1em9_HDR_xdiff(1:200),'.','Color',[0.9 0.4 0],'MarkerSize',markersz);              % orange
        loglog(Homotopy_1em9_HDR_time(201:end),Homotopy_1em9_HDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (1e-9)','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','L1-Homotopy (1e-9) w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_homotopy_1e-9_wo_HOC','pdf');
        
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_1em9_LDR_time(1:200),Homotopy_1em9_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(Homotopy_1em9_LDR_time(201:end),Homotopy_1em9_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_1em9_LDR_time(1:200),Homotopy_1em9_LDR_xdiff(1:200),'.','Color',[0.9 0.4 0],'MarkerSize',markersz);              % orange
        loglog(Homotopy_1em9_LDR_time(201:end),Homotopy_1em9_LDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (1e-9)','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','L1-Homotopy (1e-9) w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_homotopy_1e-9_wo_HOC','pdf');
        
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_1em9_HDR_time(1:200),Homotopy_1em9_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(Homotopy_1em9_HDR_time(201:end),Homotopy_1em9_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(Homotopy_1em9_LDR_time(1:200),Homotopy_1em9_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(Homotopy_1em9_LDR_time(201:end),Homotopy_1em9_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_1em9_HDR_time(1:200),Homotopy_1em9_HDR_xdiff(1:200),'^','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);          % orange
        loglog(Homotopy_1em9_HDR_time(201:end),Homotopy_1em9_HDR_xdiff(201:end),'v','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
        loglog(Homotopy_1em9_LDR_time(1:200),Homotopy_1em9_LDR_xdiff(1:200),'*','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);          % orange
        loglog(Homotopy_1em9_LDR_time(201:end),Homotopy_1em9_LDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (1e-9)','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','L1-Homotopy (1e-9) w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_homotopy_1e-9_wo_HOC','pdf');
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_HOC_HDR_time(1:200),Homotopy_HOC_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(Homotopy_HOC_HDR_time(201:end),Homotopy_HOC_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_HOC_HDR_time(1:200),Homotopy_HOC_HDR_xdiff(1:200),'.','Color',[0.9 0.4 0],'MarkerSize',markersz);              % orange
        loglog(Homotopy_HOC_HDR_time(201:end),Homotopy_HOC_HDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1-Homotopy w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_homotopy_w_HOC','pdf');
        
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_HOC_LDR_time(1:200),Homotopy_HOC_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(Homotopy_HOC_LDR_time(201:end),Homotopy_HOC_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_HOC_LDR_time(1:200),Homotopy_HOC_LDR_xdiff(1:200),'.','Color',[0.9 0.4 0],'MarkerSize',markersz);              % orange
        loglog(Homotopy_HOC_LDR_time(201:end),Homotopy_HOC_LDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1-Homotopy w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_homotopy_w_HOC','pdf');
        
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_HOC_HDR_time(1:200),Homotopy_HOC_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(Homotopy_HOC_HDR_time(201:end),Homotopy_HOC_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(Homotopy_HOC_LDR_time(1:200),Homotopy_HOC_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(Homotopy_HOC_LDR_time(201:end),Homotopy_HOC_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_HOC_HDR_time(1:200),Homotopy_HOC_HDR_xdiff(1:200),'^','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);          % orange
        loglog(Homotopy_HOC_HDR_time(201:end),Homotopy_HOC_HDR_xdiff(201:end),'v','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
        loglog(Homotopy_HOC_LDR_time(1:200),Homotopy_HOC_LDR_xdiff(1:200),'*','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);          % orange
        loglog(Homotopy_HOC_LDR_time(201:end),Homotopy_HOC_LDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1-Homotopy w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_homotopy_w_HOC','pdf');
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_HOC_WS_HDR_time(1:200),Homotopy_HOC_WS_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(Homotopy_HOC_WS_HDR_time(201:end),Homotopy_HOC_WS_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_HOC_WS_HDR_time(1:200),Homotopy_HOC_WS_HDR_xdiff(1:200),'.','Color',[0.9 0.4 0],'MarkerSize',markersz);              % orange
        loglog(Homotopy_HOC_WS_HDR_time(201:end),Homotopy_HOC_WS_HDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (WarnStop) w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1-Homotopy (warn-stop) w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_homotopy_WS_w_HOC','pdf');
    
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_HOC_WS_LDR_time(1:200),Homotopy_HOC_WS_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(Homotopy_HOC_WS_LDR_time(201:end),Homotopy_HOC_WS_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_HOC_WS_LDR_time(1:200),Homotopy_HOC_WS_LDR_xdiff(1:200),'.','Color',[0.9 0.4 0],'MarkerSize',markersz);              % orange
        loglog(Homotopy_HOC_WS_LDR_time(201:end),Homotopy_HOC_WS_LDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (WarnStop) w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1-Homotopy (warn-stop) w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_homotopy_WS_w_HOC','pdf');
    
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_HOC_WS_HDR_time(1:200),Homotopy_HOC_WS_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(Homotopy_HOC_WS_HDR_time(201:end),Homotopy_HOC_WS_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(Homotopy_HOC_WS_LDR_time(1:200),Homotopy_HOC_WS_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(Homotopy_HOC_WS_LDR_time(201:end),Homotopy_HOC_WS_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_HOC_WS_HDR_time(1:200),Homotopy_HOC_WS_HDR_xdiff(1:200),'^','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);          % orange
        loglog(Homotopy_HOC_WS_HDR_time(201:end),Homotopy_HOC_WS_HDR_xdiff(201:end),'v','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
        loglog(Homotopy_HOC_WS_LDR_time(1:200),Homotopy_HOC_WS_LDR_xdiff(1:200),'*','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);          % orange
        loglog(Homotopy_HOC_WS_LDR_time(201:end),Homotopy_HOC_WS_LDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (WarnStop) w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',1);
    set(gcf,'Name','L1-Homotopy (warn-stop) w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_homotopy_WS_w_HOC','pdf');
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_HOC_1em9_HDR_time(1:200),Homotopy_HOC_1em9_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(Homotopy_HOC_1em9_HDR_time(201:end),Homotopy_HOC_1em9_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_HOC_1em9_HDR_time(1:200),Homotopy_HOC_1em9_HDR_xdiff(1:200),'.','Color',[0.9 0.4 0],'MarkerSize',markersz);              % orange
        loglog(Homotopy_HOC_1em9_HDR_time(201:end),Homotopy_HOC_1em9_HDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (1e-9) w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','L1-Homotopy (1e-9) w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_homotopy_1e-9_w_HOC','pdf');
        
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_HOC_1em9_LDR_time(1:200),Homotopy_HOC_1em9_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(Homotopy_HOC_1em9_LDR_time(201:end),Homotopy_HOC_1em9_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_HOC_1em9_LDR_time(1:200),Homotopy_HOC_1em9_LDR_xdiff(1:200),'.','Color',[0.9 0.4 0],'MarkerSize',markersz);              % orange
        loglog(Homotopy_HOC_1em9_LDR_time(201:end),Homotopy_HOC_1em9_LDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (1e-9) w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','L1-Homotopy (1e-9) w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_homotopy_1e-9_w_HOC','pdf');
        
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_HOC_1em9_HDR_time(1:200),Homotopy_HOC_1em9_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(Homotopy_HOC_1em9_HDR_time(201:end),Homotopy_HOC_1em9_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(Homotopy_HOC_1em9_LDR_time(1:200),Homotopy_HOC_1em9_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(Homotopy_HOC_1em9_LDR_time(201:end),Homotopy_HOC_1em9_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_HOC_1em9_HDR_time(1:200),Homotopy_HOC_1em9_HDR_xdiff(1:200),'^','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);          % orange
        loglog(Homotopy_HOC_1em9_HDR_time(201:end),Homotopy_HOC_1em9_HDR_xdiff(201:end),'v','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
        loglog(Homotopy_HOC_1em9_LDR_time(1:200),Homotopy_HOC_1em9_LDR_xdiff(1:200),'*','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);          % orange
        loglog(Homotopy_HOC_1em9_LDR_time(201:end),Homotopy_HOC_1em9_LDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (1e-9) w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','L1-Homotopy (1e-9) w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_homotopy_1e-9_w_HOC','pdf');
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_WS_1em9_HDR_time(1:200),Homotopy_WS_1em9_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(Homotopy_WS_1em9_HDR_time(201:end),Homotopy_WS_1em9_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_WS_1em9_HDR_time(1:200),Homotopy_WS_1em9_HDR_xdiff(1:200),'.','Color',[0.9 0.4 0],'MarkerSize',markersz);              % orange
        loglog(Homotopy_WS_1em9_HDR_time(201:end),Homotopy_WS_1em9_HDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (WarnStop, 1e-9)','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','L1-Homotopy (warn-stop, 1e-9) w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_homotopy_WS_1e-9_wo_HOC','pdf');
        
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_WS_1em9_LDR_time(1:200),Homotopy_WS_1em9_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(Homotopy_WS_1em9_LDR_time(201:end),Homotopy_WS_1em9_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_WS_1em9_LDR_time(1:200),Homotopy_WS_1em9_LDR_xdiff(1:200),'.','Color',[0.9 0.4 0],'MarkerSize',markersz);              % orange
        loglog(Homotopy_WS_1em9_LDR_time(201:end),Homotopy_WS_1em9_LDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (WarnStop, 1e-9)','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','L1-Homotopy (warn-stop, 1e-9) w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_homotopy_WS_1e-9_wo_HOC','pdf');
        
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_WS_1em9_HDR_time(1:200),Homotopy_WS_1em9_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(Homotopy_WS_1em9_HDR_time(201:end),Homotopy_WS_1em9_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(Homotopy_WS_1em9_LDR_time(1:200),Homotopy_WS_1em9_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(Homotopy_WS_1em9_LDR_time(201:end),Homotopy_WS_1em9_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_WS_1em9_HDR_time(1:200),Homotopy_WS_1em9_HDR_xdiff(1:200),'^','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);              % orange
        loglog(Homotopy_WS_1em9_HDR_time(201:end),Homotopy_WS_1em9_HDR_xdiff(201:end),'v','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
        loglog(Homotopy_WS_1em9_LDR_time(1:200),Homotopy_WS_1em9_LDR_xdiff(1:200),'*','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);              % orange
        loglog(Homotopy_WS_1em9_LDR_time(201:end),Homotopy_WS_1em9_LDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (WarnStop, 1e-9)','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','L1-Homotopy (warn-stop, 1e-9) w/o HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_homotopy_WS_1e-9_wo_HOC','pdf');
    
    % Create figure HDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_HOC_WS_1em9_HDR_time(1:200),Homotopy_HOC_WS_1em9_HDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(Homotopy_HOC_WS_1em9_HDR_time(201:end),Homotopy_HOC_WS_1em9_HDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_HOC_WS_1em9_HDR_time(1:200),Homotopy_HOC_WS_1em9_HDR_xdiff(1:200),'.','Color',[0.9 0.4 0],'MarkerSize',markersz);              % orange
        loglog(Homotopy_HOC_WS_1em9_HDR_time(201:end),Homotopy_HOC_WS_1em9_HDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (WarnStop, 1e-9) w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','L1-Homotopy (warn-stop, 1e-9) w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDR_homotopy_WS_1e-9_w_HOC','pdf');
        
    % Create figure LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_HOC_WS_1em9_LDR_time(1:200),Homotopy_HOC_WS_1em9_LDR_xdiff(1:200),'.k','MarkerSize',markersz);
        loglog(Homotopy_HOC_WS_1em9_LDR_time(201:end),Homotopy_HOC_WS_1em9_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_HOC_WS_1em9_LDR_time(1:200),Homotopy_HOC_WS_1em9_LDR_xdiff(1:200),'.','Color',[0.9 0.4 0],'MarkerSize',markersz);              % orange
        loglog(Homotopy_HOC_WS_1em9_LDR_time(201:end),Homotopy_HOC_WS_1em9_LDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (WarnStop, 1e-9) w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','L1-Homotopy (warn-stop, 1e-9) w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'LDR_homotopy_WS_1e-9_w_HOC','pdf');
        
    % Create figure HDR and LDR
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    % Create axes
    axes1 = axes('Parent',figure1,'YScale','log','XScale','log',...
        'YMinorTick','on','XMinorTick','off','Box','on','FontSize',fontsz);
    hold;
    if( grayscale )
        loglog(Homotopy_HOC_WS_1em9_HDR_time(1:200),Homotopy_HOC_WS_1em9_HDR_xdiff(1:200),'^k','MarkerSize',markersz*0.4);
        loglog(Homotopy_HOC_WS_1em9_HDR_time(201:end),Homotopy_HOC_WS_1em9_HDR_xdiff(201:end),'vk','MarkerSize',markersz*0.4);
        loglog(Homotopy_HOC_WS_1em9_LDR_time(1:200),Homotopy_HOC_WS_1em9_LDR_xdiff(1:200),'*k','MarkerSize',markersz*0.4);
        loglog(Homotopy_HOC_WS_1em9_LDR_time(201:end),Homotopy_HOC_WS_1em9_LDR_xdiff(201:end),'xk','MarkerSize',markersz*0.4);
    else
        loglog(Homotopy_HOC_WS_1em9_HDR_time(1:200),Homotopy_HOC_WS_1em9_HDR_xdiff(1:200),'^','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);          % orange
        loglog(Homotopy_HOC_WS_1em9_HDR_time(201:end),Homotopy_HOC_WS_1em9_HDR_xdiff(201:end),'v','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
        loglog(Homotopy_HOC_WS_1em9_LDR_time(1:200),Homotopy_HOC_WS_1em9_LDR_xdiff(1:200),'*','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);          % orange
        loglog(Homotopy_HOC_WS_1em9_LDR_time(201:end),Homotopy_HOC_WS_1em9_LDR_xdiff(201:end),'x','Color',[0.9 0.4 0],'MarkerSize',markersz*0.4);      % orange
    end
    ylim(gca,[1e-16 ymax]);
    xlim(gca,[5e-3 tmax]);
    xlabel('Running Times [sec]','FontSize',fontsz);
    ylabel('${\left\Vert \bar{x}-~~x^*\right\Vert}_{\hspace*{-0.6em}2}$','FontSize',fontsz,'Interpreter','Latex');
    %title('Homotopy Method (WarnStop, 1e-9) w/ HOC','FontSize',fontsz);
    set(gca,'XTick',xticks);
    set(gca,'YTick',yticks);
    set(gca,'xgrid','on');
    set(gca,'ygrid','on');
    set(gca,'xminorgrid','off');
    set(gca,'xminortick','off');
    loglog(5e-3:tmax,(1e-6)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    loglog(5e-3:tmax,(1e-1)*ones(size(5e-3:tmax)),'--k','LineWidth',2);
    set(gcf,'Name','L1-Homotopy (warn-stop, 1e-9) w/ HOC - Running Time vs. Distance to Optimum'); % Fig. Window title
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    saveas(gcf,'HDRandLDR_homotopy_WS_1e-9_w_HOC','pdf');   
end

%% Create figures "m against nnz" (HDR, LDR, both)
if( plot_mnnz )
    j=1;
    k=zeros(1,274);
    instances;
    % HDR:
    for i=1:274
        if(cell2mat(InstancesHDR(i,1))==512)
            k(j) = 1;
        elseif(cell2mat(InstancesHDR(i,1))==1024)
            k(j) = 2;
        elseif(cell2mat(InstancesHDR(i,1))==2048)
            k(j) = 3;
        elseif(cell2mat(InstancesHDR(i,1))==8192)
            k(j) = 4;
        end
        j = j+1;
    end
    figure
    %plot(cell2mat(InstancesHDR(:,1)),cell2mat(InstancesHDR(:,4)),'.','MarkerSize',15)
    if( grayscale )
        plot(k,cell2mat(InstancesHDR(:,4)),'.k','MarkerSize',15)
    else
        plot(k,cell2mat(InstancesHDR(:,4)),'.','MarkerSize',15)
    end
    axis([0.5 4.5 0 1200])
    box on
    xlabel('Number of rows','FontSize',fontsz)
    ylabel('Number of nonzero entries','FontSize',fontsz)
    %set(gca,'xtick',[512 1024 2048 8192])
    set(gca,'xtick',1:4)
    set(gca,'xticklabel','512|1024|2048|8192')
    grid on
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz+[0.5 0]);
    saveas(gcf,'HDR_m_against_nnz','pdf');
    
    % LDR
    figure
    %plot(cell2mat(InstancesLDR(:,1)),cell2mat(InstancesLDR(:,4)),'.','MarkerSize',15)
    if( grayscale )
        plot(k,cell2mat(InstancesLDR(:,4)),'.k','MarkerSize',15)
    else
        plot(k,cell2mat(InstancesLDR(:,4)),'.','MarkerSize',15)
    end
    axis([0.5 4.5 0 1200])
    box on
    xlabel('Number of rows','FontSize',fontsz)
    ylabel('Number of nonzero entries','FontSize',fontsz)
    %set(gca,'xtick',[512 1024 2048 8192])
    set(gca,'xtick',1:4)
    set(gca,'xticklabel','512|1024|2048|8192')
    grid on
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz+[0.5 0]);
    saveas(gcf,'LDR_m_against_nnz','pdf');
    
    % both HDR and LDR:
    figure
    hold;
    if( grayscale )
        plot(k,cell2mat(InstancesHDR(:,4)),'.k','MarkerSize',15)
        plot(k,cell2mat(InstancesLDR(:,4)),'*k','MarkerSize',markersz*0.5)
    else
        plot(k,cell2mat(InstancesHDR(:,4)),'.','MarkerSize',15)
        plot(k,cell2mat(InstancesLDR(:,4)),'*','MarkerSize',markersz*0.5)
    end
    axis([0.5 4.5 0 1200])
    box on
    xlabel('Number of rows','FontSize',fontsz)
    ylabel('Number of nonzero entries','FontSize',fontsz)
    %set(gca,'xtick',[512 1024 2048 8192])
    set(gca,'xtick',1:4)
    set(gca,'xticklabel','512|1024|2048|8192')
    grid on
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz+[0.5 0]);
    saveas(gcf,'HDRandLDR_m_against_nnz','pdf');
end


%% Create figure "mutual coherences"
if( plot_muA )
    load mutual_coherences.mat
    instances;
    j=1;
    k=zeros(1,100);
    for i=1:2:200
        if(cell2mat(InstancesHDR(i,1))==512)
            k(j) = 1;
        elseif(cell2mat(InstancesHDR(i,1))==1024)
            k(j) = 2;
        elseif(cell2mat(InstancesHDR(i,1))==2048)
            k(j) = 3;
        elseif(cell2mat(InstancesHDR(i,1))==8192)
            k(j) = 4;
        end
        j = j+1;
    end    
    figure
    %plot(cell2mat(InstancesHDR(1:2:200,1)),mu,'.','MarkerSize',15);
    if( grayscale )
        plot(k,mu,'.k','MarkerSize',15);
    else
        plot(k,mu,'.','MarkerSize',15);
    end
    axis([0.5 4.5 0 1.05]);
    box on
    xlabel('Number of rows','FontSize',fontsz)
    ylabel('Mutual Coherence','FontSize',fontsz)
    %set(gca,'xtick',[512 1024 2048 8192])
    set(gca,'xtick',1:4)
    set(gca,'xticklabel','512|1024|2048|8192')
    grid on
    set(gcf,'PaperPosition', paperpos);
    set(gcf,'Papersize', papersz+[0.5 0]);
    saveas(gcf,'mutual_coherences','pdf');
end

%% create figure showing HOC impact on ISAL1, SPGL1 and l1-MAGIC
% for a specific instance (74b=148)
if( plot_HOCx )
    % (plot is always grayscale; grayscale-option parameter is ignored)    
    load HOC_example_data.mat
    papersz = [12 9];
    fontsz = 16;
    paperpos = [0 0 12.5 9];
    yticks = [1e-12,1e-6,1e0,1e6];
    
    % Create figure
    % ISAL1 plot:
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    %subplot(1,3,1,'YScale','log','YMinorTick','on','FontSize',20,'OuterPosition',[0.074,0.313,0.281,0.693]);
    h1=semilogy(0:length(ISAL1_noHOC_feasv)-1,ISAL1_noHOC_feasv,'-','Color',[0.5,0.5,0.5],'LineWidth',2,'DisplayName','${\left\Vert A{x}^{k}-\,~b\,\right\Vert}_{\hspace*{-0.8em}\infty}$');      % gray
    hold;
    h2=semilogy(0:length(ISAL1_noHOC_HDR_xdiffv)-1,ISAL1_noHOC_HDR_xdiffv,'-k','LineWidth',2,'DisplayName','${\left\Vert {x}^{k}-~\,x^*\right\Vert}_{\hspace*{-0.8em}2}$');          % black
    h3=line([ISAL1_HOC_it;ISAL1_HOC_it],[1e-20;1e11],'Color','k','LineStyle','--','LineWidth',1,'DisplayName','HOC success');  % black
    h4=line([0;length(ISAL1_noHOC_feasv)-1],[1e-6;1e-6],'Color','k','LineStyle','--','LineWidth',1,'DisplayName','1e-6');
    hx=line([0;length(ISAL1_noHOC_feasv)-1],[1e-1;1e-1],'Color','k','LineStyle','--','LineWidth',1,'DisplayName','1e-1');
    h5=semilogy(ISAL1_HOC_it,ISAL1_HOC_feasv(end),'o','Color',[0.5,0.5,0.5],'MarkerSize',8,'LineWidth',2,'DisplayName','${\left\Vert A\bar{x}-\,~b\,\right\Vert}_{\hspace*{-0.8em}\infty}$');
    h6=semilogy(ISAL1_HOC_it,ISAL1_HOC_HDR_xdiffv(end),'ok','MarkerSize',8,'LineWidth',2,'DisplayName','${\left\Vert\bar{x}-~\,x^*\right\Vert}_{\hspace*{-0.8em}2}$');
    ylim([1e-12 1e6]);
    xlim([0 length(ISAL1_noHOC_feasv)-1]);
    xlabel('Iteration k','FontSize',fontsz);
    set(gca,'XTick',[0,ISAL1_HOC_it,length(ISAL1_noHOC_feasv)-1]);
    %ylabel(sprintf('Feasibility Violation (black) /\nDistance to Optimum (gray)'),'FontSize',20);
    set(gca,'YTick',yticks)
    set(gca,'FontSize',fontsz)
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    set(gcf,'Name','HOC impact in ISAL1'); % Fig. Window title
    saveas(gcf,'HOC_in_ISAL1','pdf');
    
    
    % SPGL1 plot:
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    %subplot(1,3,2,'YScale','log','YMinorTick','on','FontSize',20,'OuterPosition',[0.38,0.313,0.255,0.693]);
    semilogy(0:length(SPGL1_noHOC_feasv)-1,SPGL1_noHOC_feasv,'-','Color',[0.5,0.5,0.5],'LineWidth',2,'DisplayName','${\left\Vert A{x}^{k}-\,~b\,\right\Vert}_{\hspace*{-0.8em}\infty}$');         % gray
    hold;
    semilogy(0:length(SPGL1_noHOC_feasv)-1,SPGL1_noHOC_HDR_xdiffv,'-k','LineWidth',2,'DisplayName','${\left\Vert {x}^{k}-~\,x^*\right\Vert}_{\hspace*{-0.8em}2}$');              % black
    line([SPGL1_HOC_it;SPGL1_HOC_it],[1e-20;1e11],'Color','k','LineStyle','--','LineWidth',1,'DisplayName','HOC success');  % black
    %semilogy(0:length(ISAnoOptTest_feas),1e-6,'k','LineWidth',2,'DisplayName','1e-6');
    line([0;length(SPGL1_noHOC_feasv)-1],[1e-6;1e-6],'Color','k','LineStyle','--','LineWidth',1,'DisplayName','1e-6');
    line([0;length(SPGL1_noHOC_feasv)-1],[1e-1;1e-1],'Color','k','LineStyle','--','LineWidth',1,'DisplayName','1e-1');
    semilogy(SPGL1_HOC_it,SPGL1_HOC_feasv(end),'o','Color',[0.5,0.5,0.5],'MarkerSize',8,'LineWidth',2,'DisplayName','${\left\Vert A\bar{x}-\,~b\,\right\Vert}_{\hspace*{-0.8em}\infty}$');
    semilogy(SPGL1_HOC_it,SPGL1_HOC_HDR_xdiffv(end),'ok','MarkerSize',8,'LineWidth',2,'DisplayName','${\left\Vert\bar{x}-~\,x^*\right\Vert}_{\hspace*{-0.8em}2}$');
    ylim([1e-12 1e6]);
    xlim([0 length(SPGL1_noHOC_feasv)-1]);
    xlabel('Iteration k','FontSize',fontsz);
    set(gca,'XTick',[0,SPGL1_HOC_it,length(SPGL1_noHOC_feasv)-1]);
    set(gca,'YTick',yticks)
    set(gca,'FontSize',fontsz)
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    set(gcf,'Name','HOC impact in SPGL1'); % Fig. Window title
    saveas(gcf,'HOC_in_SPGL1','pdf');
    
    % l1-MAGIC plot:
    figure1 = figure('XVisual',...
        '0x23 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');
    %subplot(1,3,3,'YScale','log','YMinorTick','on','FontSize',20,'OuterPosition',[0.661,0.313,0.252,0.693]);
    semilogy(0:length(l1MAGIC_noHOC_feasv)-1,l1MAGIC_noHOC_feasv,'-','Color',[0.5,0.5,0.5],'LineWidth',2,'DisplayName','${\left\Vert A{x}^{k}-\,~b\,\right\Vert}_{\hspace*{-0.8em}\infty}$');     % gray
    hold;
    semilogy(0:length(l1MAGIC_noHOC_feasv)-1,l1MAGIC_noHOC_HDR_xdiffv,'-k','LineWidth',2,'DisplayName','${\left\Vert {x}^{k}-~\,x^*\right\Vert}_{\hspace*{-0.8em}2}$');          % black
    line([l1MAGIC_HOC_it;l1MAGIC_HOC_it],[1e-20;1e11],'Color','k','LineStyle','--','LineWidth',1,'DisplayName','HOC success');  % black
    %semilogy(0:length(ISAnoOptTest_feas),1e-6,'k','LineWidth',2,'DisplayName','1e-6');
    line([0;length(l1MAGIC_noHOC_feasv)-1],[1e-6;1e-6],'Color','k','LineStyle','--','LineWidth',1,'DisplayName','1e-6');
    line([0;length(l1MAGIC_noHOC_feasv)-1],[1e-1;1e-1],'Color','k','LineStyle','--','LineWidth',1,'DisplayName','1e-1');
    semilogy(l1MAGIC_HOC_it,l1MAGIC_HOC_feasv(end),'o','Color',[0.5,0.5,0.5],'MarkerSize',8,'LineWidth',2,'DisplayName','${\left\Vert A\bar{x}-\,~b\,\right\Vert}_{\hspace*{-0.8em}\infty}$');
    semilogy(l1MAGIC_HOC_it,l1MAGIC_HOC_HDR_xdiffv(end),'ok','MarkerSize',8,'LineWidth',2,'DisplayName','${\left\Vert\bar{x}-~\,x^*\right\Vert}_{\hspace*{-0.8em}2}$');
    ylim([1e-12 1e6]);
    xlim([0 length(l1MAGIC_noHOC_feasv)-1]);
    xlabel('Iteration k','FontSize',fontsz);
    set(gca,'XTick',[0,l1MAGIC_HOC_it,length(l1MAGIC_noHOC_feasv)-1]);
    set(gca,'YTick',yticks)
    set(gca,'FontSize',fontsz)
    set(gcf,'PaperPosition', paperpos);
    set(gcf','Papersize', papersz);
    set(gcf,'Name','HOC impact in l1-MAGIC'); % Fig. Window title
    saveas(gcf,'HOC_in_l1MAGIC','pdf');
end


%% Create LaTeX tables with some results statistics ...
if( do_tables )
    % Create tables with geometric running time means vs number of columns
    % (ONLY FOR THOSE INSTANCES (per group) FOR WHICH ALL SOLVERS REACH AT
    % LEAST 'ACCEPTABLE' STATUS -- YALL1 and l1MAGIC are excluded because
    % they produced inacceptable solutions too often!)
    %
    % 1st: without HOC
    %
    % HDR:
    j=1;
    k=zeros(1,274);
    instances;
    for i=1:274
        if(cell2mat(InstancesHDR(i,2))==1024)
            k(j) = 1;
        elseif(cell2mat(InstancesHDR(i,2))==1536)
            k(j) = 2;
        elseif(cell2mat(InstancesHDR(i,2))==2048)
            k(j) = 3;
        elseif(cell2mat(InstancesHDR(i,2))==3072)
            k(j) = 4;
        elseif(cell2mat(InstancesHDR(i,2))==4096)
            k(j) = 5;
        elseif(cell2mat(InstancesHDR(i,2))==6144)
            k(j) = 6;
        elseif(cell2mat(InstancesHDR(i,2))==8192)
            k(j) = 7;
        elseif(cell2mat(InstancesHDR(i,2))==12288)
            k(j) = 8;
        elseif(cell2mat(InstancesHDR(i,2))==16384)
            k(j) = 9;
        elseif(cell2mat(InstancesHDR(i,2))==24576)
            k(j) = 10;
        elseif(cell2mat(InstancesHDR(i,2))==32768)
            k(j) = 11;
        elseif(cell2mat(InstancesHDR(i,2))==49152)
            k(j) = 12;
        end
        j = j+1;
    end
    %geomean = @(x)prod(x.^(1/length(x))); % already exists in Matlab ...
    columns = [1024 1536 2048 3072 4096 6144 8192 12288 16384 24576 32768 49152];

    % limit to those instances each solver (except Yall1 and l1magic)
    % reached an acceptable solution:
    ISAL1_acceptable = find( ISAL1_noHOC_HDR_xdiff <= 0.1 );
    SPGL1_acceptable = find( SPGL1_HDR_xdiff <= 0.1 );
    L1LP_CPX_acceptable = find( L1LP_CPX_HDR_xdiff <= 0.1 );
    L1LP_SPX_acceptable = find( L1LP_SPX_HDR_xdiff <= 0.1 );
    SolveBP_acceptable = find( SolveBP_HDR_xdiff <= 0.1 );
    Homotopy_acceptable = find( Homotopy_HDR_xdiff <= 0.1 );

    filename = 'HDR_table_mean_times_acceptable_wo_HOC_over_same_cols.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\footnotesize\n\\newcolumntype{d}[1]{D{.}{.}{#1}}\n');
    fprintf(fid,'\\begin{tabular*}{\\textwidth}{@{\\extracolsep{\\fill}}r@{\\quad} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2}@{}}\\toprule\n');
    fprintf(fid,'  & \\multicolumn{1}{c}{used/of} & \\multicolumn{1}{c}{$\\ell_{1}$-Hom.} & \\multicolumn{1}{c}{SPGL1} & \\multicolumn{1}{c}{SolveBP} & \\multicolumn{1}{c}{ISAL1} & \\multicolumn{1}{c}{CPLEX} & \\multicolumn{1}{c}{SoPlex} \\\\\n');  %& \\multicolumn{1}{c}{\\ell_{1}-M.} 
    fprintf(fid,'  & & \\multicolumn{1}{c}{w/o HOC} & \\multicolumn{1}{c}{w/o HOC} & \\multicolumn{1}{c}{w/o HOC} & \\multicolumn{1}{c}{w/o HOC} & \\multicolumn{1}{c}{(w/o HOC)} & \\multicolumn{1}{c}{(w/o HOC)} \\\\\n');
    fprintf(fid,'\\midrule\n$n$  & & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]}  & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]}\\\\\n\\midrule\n');
    
    for j = 1:12
        group = find( k == j );
        orig_groupsize = numel(group);
        
        group = intersect( group, Homotopy_acceptable );
        group = intersect( group, SPGL1_acceptable );
        group = intersect( group, SolveBP_acceptable );
        group = intersect( group, ISAL1_acceptable );
        group = intersect( group, L1LP_CPX_acceptable );
        group = intersect( group, L1LP_SPX_acceptable );
        
        groupsize = numel(group);
        
        fprintf(fid,' $%d$ & \\multicolumn{1}{c}{$%d/%d$}',columns(j),groupsize,orig_groupsize);
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}\\\\[0.5em]\n');
        else
            fprintf(fid,' & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$}  \\\\\n',...
                geomean(Homotopy_HDR_time(group)),geomean(SPGL1_HDR_time(group)),geomean(SolveBP_HDR_time(group)),...
                geomean(ISAL1_noHOC_HDR_time(group)),geomean(L1LP_CPX_HDR_time(group(L1LP_CPX_HDR_time(group)~=0))),geomean(L1LP_SPX_HDR_time(group)));
            fprintf(fid,'& \\multicolumn{1}{c}{var | max:} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$}  \\\\[0.5em]\n',...
                var(Homotopy_HDR_time(group)),max(Homotopy_HDR_time(group)),var(SPGL1_HDR_time(group)),max(SPGL1_HDR_time(group)),var(SolveBP_HDR_time(group)),max(SolveBP_HDR_time(group)),...
                var(ISAL1_noHOC_HDR_time(group)),max(ISAL1_noHOC_HDR_time(group)),var(L1LP_CPX_HDR_time(group)),max(L1LP_CPX_HDR_time(group)),var(L1LP_SPX_HDR_time(group)),max(L1LP_SPX_HDR_time(group)));                 
        end
    end
    fprintf(fid,'\\bottomrule\n\\end{tabular*}\n');
    fclose(fid);    
    % LDR:
    ISAL1_acceptable = find( ISAL1_noHOC_LDR_xdiff <= 0.1 );
    SPGL1_acceptable = find( SPGL1_LDR_xdiff <= 0.1 );
    L1LP_CPX_acceptable = find( L1LP_CPX_LDR_xdiff <= 0.1 );
    L1LP_SPX_acceptable = find( L1LP_SPX_LDR_xdiff <= 0.1 );
    SolveBP_acceptable = find( SolveBP_LDR_xdiff <= 0.1 );
    Homotopy_acceptable = find( Homotopy_LDR_xdiff <= 0.1 );

    filename = 'LDR_table_mean_times_acceptable_wo_HOC_over_same_cols.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\footnotesize\n\\newcolumntype{d}[1]{D{.}{.}{#1}}\n');
    fprintf(fid,'\\begin{tabular*}{\\textwidth}{@{\\extracolsep{\\fill}}r@{\\quad} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2}@{}}\\toprule\n');
    fprintf(fid,'  & \\multicolumn{1}{c}{used/of} & \\multicolumn{1}{c}{$\\ell_{1}$-Hom.} & \\multicolumn{1}{c}{SPGL1} & \\multicolumn{1}{c}{SolveBP} & \\multicolumn{1}{c}{ISAL1} & \\multicolumn{1}{c}{CPLEX} & \\multicolumn{1}{c}{SoPlex} \\\\\n');  %& \\multicolumn{1}{c}{\\ell_{1}-M.} 
    fprintf(fid,'  & & \\multicolumn{1}{c}{w/o HOC} & \\multicolumn{1}{c}{w/o HOC} & \\multicolumn{1}{c}{w/o HOC} & \\multicolumn{1}{c}{w/o HOC} & \\multicolumn{1}{c}{(w/o HOC)} & \\multicolumn{1}{c}{(w/o HOC)} \\\\\n');
    fprintf(fid,'\\midrule\n$n$  & & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]}  & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]}\\\\\n\\midrule\n');
    
    for j = 1:12
        group = find( k == j );
        orig_groupsize = numel(group);
        
        group = intersect( group, Homotopy_acceptable );
        group = intersect( group, SPGL1_acceptable );
        group = intersect( group, SolveBP_acceptable );
        group = intersect( group, ISAL1_acceptable );
        group = intersect( group, L1LP_CPX_acceptable );
        group = intersect( group, L1LP_SPX_acceptable );
        
        groupsize = numel(group);
        
        fprintf(fid,' $%d$ & \\multicolumn{1}{c}{$%d/%d$}',columns(j),groupsize,orig_groupsize);
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}\\\\[0.5em]\n');
        else
            fprintf(fid,' & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$}  \\\\\n',...
                geomean(Homotopy_LDR_time(group)),geomean(SPGL1_LDR_time(group)),geomean(SolveBP_LDR_time(group)),...
                geomean(ISAL1_noHOC_LDR_time(group)),geomean(L1LP_CPX_LDR_time(group(L1LP_CPX_LDR_time(group)~=0))),geomean(L1LP_SPX_LDR_time(group)));
            fprintf(fid,'& \\multicolumn{1}{c}{var | max:} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$}  \\\\[0.5em]\n',...
                var(Homotopy_LDR_time(group)),max(Homotopy_LDR_time(group)),var(SPGL1_LDR_time(group)),max(SPGL1_LDR_time(group)),var(SolveBP_LDR_time(group)),max(SolveBP_LDR_time(group)),...
                var(ISAL1_noHOC_LDR_time(group)),max(ISAL1_noHOC_LDR_time(group)),var(L1LP_CPX_LDR_time(group)),max(L1LP_CPX_LDR_time(group)),var(L1LP_SPX_LDR_time(group)),max(L1LP_SPX_LDR_time(group)));                 
        end
    end
    fprintf(fid,'\\bottomrule\n\\end{tabular*}\n');
    fclose(fid);
    % HDR and LDR:
    k = [k,k];
    ISAL1_acceptable = find( ISAL1_noHOC_xdiff <= 0.1 );
    SPGL1_acceptable = find( SPGL1_xdiff <= 0.1 );
    L1LP_CPX_acceptable = find( L1LP_CPX_xdiff <= 0.1 );
    L1LP_SPX_acceptable = find( L1LP_SPX_xdiff <= 0.1 );
    SolveBP_acceptable = find( SolveBP_xdiff <= 0.1 );
    Homotopy_acceptable = find( Homotopy_xdiff <= 0.1 );

    filename = 'HDRandLDR_table_mean_times_acceptable_wo_HOC_over_same_cols.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\footnotesize\n\\newcolumntype{d}[1]{D{.}{.}{#1}}\n');
    fprintf(fid,'\\begin{tabular*}{\\textwidth}{@{\\extracolsep{\\fill}}r@{\\quad} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2}@{}}\\toprule\n');
    fprintf(fid,'  & \\multicolumn{1}{c}{used/of} & \\multicolumn{1}{c}{$\\ell_{1}$-Hom.} & \\multicolumn{1}{c}{SPGL1} & \\multicolumn{1}{c}{SolveBP} & \\multicolumn{1}{c}{ISAL1} & \\multicolumn{1}{c}{CPLEX} & \\multicolumn{1}{c}{SoPlex} \\\\\n');  %& \\multicolumn{1}{c}{\\ell_{1}-M.} 
    fprintf(fid,'  & & \\multicolumn{1}{c}{w/o HOC} & \\multicolumn{1}{c}{w/o HOC} & \\multicolumn{1}{c}{w/o HOC} & \\multicolumn{1}{c}{w/o HOC} & \\multicolumn{1}{c}{(w/o HOC)} & \\multicolumn{1}{c}{(w/o HOC)} \\\\\n');
    fprintf(fid,'\\midrule\n$n$  & & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]}  & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]}\\\\\n\\midrule\n');
    
    for j = 1:12
        group = find( k == j );
        orig_groupsize = numel(group);
        
        group = intersect( group, Homotopy_acceptable );
        group = intersect( group, SPGL1_acceptable );
        group = intersect( group, SolveBP_acceptable );
        group = intersect( group, ISAL1_acceptable );
        group = intersect( group, L1LP_CPX_acceptable );
        group = intersect( group, L1LP_SPX_acceptable );
        
        groupsize = numel(group);
        
        fprintf(fid,' $%d$ & \\multicolumn{1}{c}{$%d/%d$}',columns(j),groupsize,orig_groupsize);
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}\\\\[0.5em]\n');
        else
            fprintf(fid,' & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$}  \\\\\n',...
                geomean(Homotopy_time(group)),geomean(SPGL1_time(group)),geomean(SolveBP_time(group)),...
                geomean(ISAL1_noHOC_time(group)),geomean(L1LP_CPX_time(group(L1LP_CPX_time(group)~=0))),geomean(L1LP_SPX_time(group)));
            fprintf(fid,'& \\multicolumn{1}{c}{var | max:} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$}  \\\\[0.5em]\n',...
                var(Homotopy_time(group)),max(Homotopy_time(group)),var(SPGL1_time(group)),max(SPGL1_time(group)),var(SolveBP_time(group)),max(SolveBP_time(group)),...
                var(ISAL1_noHOC_time(group)),max(ISAL1_noHOC_time(group)),var(L1LP_CPX_time(group)),max(L1LP_CPX_time(group)),var(L1LP_SPX_time(group)),max(L1LP_SPX_time(group)));                 
        end
    end
    fprintf(fid,'\\bottomrule\n\\end{tabular*}\n');
    fclose(fid);
    
    % 2nd: with HOC
    %
    % HDR:
    j=1;
    k=zeros(1,274);
    instances;
    for i=1:274
        if(cell2mat(InstancesHDR(i,2))==1024)
            k(j) = 1;
        elseif(cell2mat(InstancesHDR(i,2))==1536)
            k(j) = 2;
        elseif(cell2mat(InstancesHDR(i,2))==2048)
            k(j) = 3;
        elseif(cell2mat(InstancesHDR(i,2))==3072)
            k(j) = 4;
        elseif(cell2mat(InstancesHDR(i,2))==4096)
            k(j) = 5;
        elseif(cell2mat(InstancesHDR(i,2))==6144)
            k(j) = 6;
        elseif(cell2mat(InstancesHDR(i,2))==8192)
            k(j) = 7;
        elseif(cell2mat(InstancesHDR(i,2))==12288)
            k(j) = 8;
        elseif(cell2mat(InstancesHDR(i,2))==16384)
            k(j) = 9;
        elseif(cell2mat(InstancesHDR(i,2))==24576)
            k(j) = 10;
        elseif(cell2mat(InstancesHDR(i,2))==32768)
            k(j) = 11;
        elseif(cell2mat(InstancesHDR(i,2))==49152)
            k(j) = 12;
        end
        j = j+1;
    end
    %geomean = @(x)prod(x.^(1/length(x))); % already exists in Matlab ...
    columns = [1024 1536 2048 3072 4096 6144 8192 12288 16384 24576 32768 49152];

    % limit to those instances each solver (except Yall1 and l1magic)
    % reached an acceptable solution:
    ISAL1_acceptable = find( ISAL1_HDR_xdiff <= 0.1 );
    SPGL1_acceptable = find( SPGL1_HOC_HDR_xdiff <= 0.1 );
    L1LP_CPX_acceptable = find( L1LP_CPX_HDR_xdiff <= 0.1 );
    L1LP_SPX_acceptable = find( L1LP_SPX_HDR_xdiff <= 0.1 );
    SolveBP_acceptable = find( SolveBP_HOC_HDR_xdiff <= 0.1 );
    Homotopy_acceptable = find( Homotopy_HOC_HDR_xdiff <= 0.1 );

    filename = 'HDR_table_mean_times_acceptable_w_HOC_over_same_cols.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\footnotesize\n\\newcolumntype{d}[1]{D{.}{.}{#1}}\n');
    fprintf(fid,'\\begin{tabular*}{\\textwidth}{@{\\extracolsep{\\fill}}r@{\\quad} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2}@{}}\\toprule\n');
    fprintf(fid,'  & \\multicolumn{1}{c}{used/of} & \\multicolumn{1}{c}{$\\ell_{1}$-Hom.} & \\multicolumn{1}{c}{SPGL1} & \\multicolumn{1}{c}{SolveBP} & \\multicolumn{1}{c}{ISAL1} & \\multicolumn{1}{c}{CPLEX} & \\multicolumn{1}{c}{SoPlex} \\\\\n');  %& \\multicolumn{1}{c}{\\ell_{1}-M.} 
    fprintf(fid,'  & & \\multicolumn{1}{c}{w/ HOC} & \\multicolumn{1}{c}{w/ HOC} & \\multicolumn{1}{c}{w/ HOC} & \\multicolumn{1}{c}{w/ HOC} & \\multicolumn{1}{c}{(w/o HOC)} & \\multicolumn{1}{c}{(w/o HOC)} \\\\\n');
    fprintf(fid,'\\midrule\n$n$  & & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]}  & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]}\\\\\n\\midrule\n');
    
    for j = 1:12
        group = find( k == j );
        orig_groupsize = numel(group);
        
        group = intersect( group, Homotopy_acceptable );
        group = intersect( group, SPGL1_acceptable );
        group = intersect( group, SolveBP_acceptable );
        group = intersect( group, ISAL1_acceptable );
        group = intersect( group, L1LP_CPX_acceptable );
        group = intersect( group, L1LP_SPX_acceptable );
        
        groupsize = numel(group);
        
        fprintf(fid,' $%d$ & \\multicolumn{1}{c}{$%d/%d$}',columns(j),groupsize,orig_groupsize);
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}\\\\[0.5em]\n');
        else
            fprintf(fid,' & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$}  \\\\\n',...
                geomean(Homotopy_HOC_HDR_time(group)),geomean(SPGL1_HOC_HDR_time(group)),geomean(SolveBP_HOC_HDR_time(group)),...
                geomean(ISAL1_HDR_time(group)),geomean(L1LP_CPX_HDR_time(group(L1LP_CPX_HDR_time(group)~=0))),geomean(L1LP_SPX_HDR_time(group)));
            fprintf(fid,'& \\multicolumn{1}{c}{var | max:} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$}  \\\\[0.5em]\n',...
                var(Homotopy_HOC_HDR_time(group)),max(Homotopy_HOC_HDR_time(group)),var(SPGL1_HOC_HDR_time(group)),max(SPGL1_HOC_HDR_time(group)),var(SolveBP_HOC_HDR_time(group)),max(SolveBP_HOC_HDR_time(group)),...
                var(ISAL1_HDR_time(group)),max(ISAL1_HDR_time(group)),var(L1LP_CPX_HDR_time(group)),max(L1LP_CPX_HDR_time(group)),var(L1LP_SPX_HDR_time(group)),max(L1LP_SPX_HDR_time(group)));                 
        end
    end
    fprintf(fid,'\\bottomrule\n\\end{tabular*}\n');
    fclose(fid);    
    % LDR:
    ISAL1_acceptable = find( ISAL1_LDR_xdiff <= 0.1 );
    SPGL1_acceptable = find( SPGL1_HOC_LDR_xdiff <= 0.1 );
    L1LP_CPX_acceptable = find( L1LP_CPX_LDR_xdiff <= 0.1 );
    L1LP_SPX_acceptable = find( L1LP_SPX_LDR_xdiff <= 0.1 );
    SolveBP_acceptable = find( SolveBP_HOC_LDR_xdiff <= 0.1 );
    Homotopy_acceptable = find( Homotopy_HOC_LDR_xdiff <= 0.1 );

    filename = 'LDR_table_mean_times_acceptable_w_HOC_over_same_cols.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\footnotesize\n\\newcolumntype{d}[1]{D{.}{.}{#1}}\n');
    fprintf(fid,'\\begin{tabular*}{\\textwidth}{@{\\extracolsep{\\fill}}r@{\\quad} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2}@{}}\\toprule\n');
    fprintf(fid,'  & \\multicolumn{1}{c}{used/of} & \\multicolumn{1}{c}{$\\ell_{1}$-Hom.} & \\multicolumn{1}{c}{SPGL1} & \\multicolumn{1}{c}{SolveBP} & \\multicolumn{1}{c}{ISAL1} & \\multicolumn{1}{c}{CPLEX} & \\multicolumn{1}{c}{SoPlex} \\\\\n');  %& \\multicolumn{1}{c}{\\ell_{1}-M.} 
    fprintf(fid,'  & & \\multicolumn{1}{c}{w/ HOC} & \\multicolumn{1}{c}{w/ HOC} & \\multicolumn{1}{c}{w/ HOC} & \\multicolumn{1}{c}{w/ HOC} & \\multicolumn{1}{c}{(w/o HOC)} & \\multicolumn{1}{c}{(w/o HOC)} \\\\\n');
    fprintf(fid,'\\midrule\n$n$  & & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]}  & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]}\\\\\n\\midrule\n');
    
    for j = 1:12
        group = find( k == j );
        orig_groupsize = numel(group);
        
        group = intersect( group, Homotopy_acceptable );
        group = intersect( group, SPGL1_acceptable );
        group = intersect( group, SolveBP_acceptable );
        group = intersect( group, ISAL1_acceptable );
        group = intersect( group, L1LP_CPX_acceptable );
        group = intersect( group, L1LP_SPX_acceptable );
        
        groupsize = numel(group);
        
        fprintf(fid,' $%d$ & \\multicolumn{1}{c}{$%d/%d$}',columns(j),groupsize,orig_groupsize);
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}\\\\[0.5em]\n');
        else
            fprintf(fid,' & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$}  \\\\\n',...
                geomean(Homotopy_HOC_LDR_time(group)),geomean(SPGL1_HOC_LDR_time(group)),geomean(SolveBP_HOC_LDR_time(group)),...
                geomean(ISAL1_LDR_time(group)),geomean(L1LP_CPX_LDR_time(group(L1LP_CPX_LDR_time(group)~=0))),geomean(L1LP_SPX_LDR_time(group)));
            fprintf(fid,'& \\multicolumn{1}{c}{var | max:} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$}  \\\\[0.5em]\n',...
                var(Homotopy_HOC_LDR_time(group)),max(Homotopy_HOC_LDR_time(group)),var(SPGL1_HOC_LDR_time(group)),max(SPGL1_HOC_LDR_time(group)),var(SolveBP_HOC_LDR_time(group)),max(SolveBP_HOC_LDR_time(group)),...
                var(ISAL1_LDR_time(group)),max(ISAL1_LDR_time(group)),var(L1LP_CPX_LDR_time(group)),max(L1LP_CPX_LDR_time(group)),var(L1LP_SPX_LDR_time(group)),max(L1LP_SPX_LDR_time(group)));                 
        end
    end
    fprintf(fid,'\\bottomrule\n\\end{tabular*}\n');
    fclose(fid);
    % HDR and LDR:
    k = [k,k];
    ISAL1_acceptable = find( ISAL1_xdiff <= 0.1 );
    SPGL1_acceptable = find( SPGL1_HOC_xdiff <= 0.1 );
    L1LP_CPX_acceptable = find( L1LP_CPX_xdiff <= 0.1 );
    L1LP_SPX_acceptable = find( L1LP_SPX_xdiff <= 0.1 );
    SolveBP_acceptable = find( SolveBP_HOC_xdiff <= 0.1 );
    Homotopy_acceptable = find( Homotopy_HOC_xdiff <= 0.1 );
    l1MAGIC_acceptable = find( l1MAGIC_HOC_xdiff <=0.1 );

    filename = 'HDRandLDR_table_mean_times_acceptable_w_HOC_over_same_cols.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\footnotesize\n\\newcolumntype{d}[1]{D{.}{.}{#1}}\n');
    fprintf(fid,'\\begin{tabular*}{\\textwidth}{@{\\extracolsep{\\fill}}r@{\\quad} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2}@{}}\\toprule\n');
    fprintf(fid,'  & \\multicolumn{1}{c}{used/of} & \\multicolumn{1}{c}{$\\ell_{1}$-Hom.} & \\multicolumn{1}{c}{SPGL1} & \\multicolumn{1}{c}{SolveBP} & \\multicolumn{1}{c}{ISAL1} & \\multicolumn{1}{c}{$\\ell_1$-Magic} & \\multicolumn{1}{c}{CPLEX} & \\multicolumn{1}{c}{SoPlex} \\\\\n');  %& \\multicolumn{1}{c}{\\ell_{1}-M.} 
    fprintf(fid,'  & & \\multicolumn{1}{c}{w/ HOC} & \\multicolumn{1}{c}{w/ HOC} & \\multicolumn{1}{c}{w/ HOC} & \\multicolumn{1}{c}{w/ HOC} & \\multicolumn{1}{c}{w/ HOC} & \\multicolumn{1}{c}{(w/o HOC)} & \\multicolumn{1}{c}{(w/o HOC)} \\\\\n');
    fprintf(fid,'\\midrule\n$n$  & & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]}  & \\multicolumn{1}{r}{$t$ [s]} & \\multicolumn{1}{r}{$t$ [s]}\\\\\n\\midrule\n');
    
    for j = 1:12
        group = find( k == j );
        orig_groupsize = numel(group);
        
        group = intersect( group, Homotopy_acceptable );
        group = intersect( group, SPGL1_acceptable );
        group = intersect( group, SolveBP_acceptable );
        group = intersect( group, ISAL1_acceptable );
        group = intersect( group, L1LP_CPX_acceptable );
        group = intersect( group, L1LP_SPX_acceptable );
        group = intersect( group, l1MAGIC_acceptable );
        
        groupsize = numel(group);
        
        fprintf(fid,' $%d$ & \\multicolumn{1}{c}{$%d/%d$}',columns(j),groupsize,orig_groupsize);
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}\\\\[0.5em]\n');
        else
            fprintf(fid,' & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$}  \\\\\n',...
                geomean(Homotopy_HOC_time(group)),geomean(SPGL1_HOC_time(group)),geomean(SolveBP_HOC_time(group)),...
                geomean(ISAL1_time(group)),geomean(l1MAGIC_HOC_time(group)),geomean(L1LP_CPX_time(group(L1LP_CPX_time(group)~=0))),geomean(L1LP_SPX_time(group)));
            fprintf(fid,'& \\multicolumn{1}{c}{var | max:} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$|$%3.2f$}  \\\\[0.5em]\n',...
                var(Homotopy_HOC_time(group)),max(Homotopy_HOC_time(group)),var(SPGL1_HOC_time(group)),max(SPGL1_HOC_time(group)),var(SolveBP_HOC_time(group)),max(SolveBP_HOC_time(group)),...
                var(ISAL1_time(group)),max(ISAL1_time(group)),var(l1MAGIC_HOC_time(group)),max(l1MAGIC_HOC_time(group)),var(L1LP_CPX_time(group)),max(L1LP_CPX_time(group)),var(L1LP_SPX_time(group)),max(L1LP_SPX_time(group)));                 
        end
    end
    fprintf(fid,'\\bottomrule\n\\end{tabular*}\n');
    fclose(fid);

    
    
    % Create tables with geometric running time means vs number of columns
    % (ONLY FOR THOSE INSTANCES (per group) FOR WHICH ALL SOLVERS REACH AT
    % LEAST 'SOLVED' STATUS WITHOUT HOC
    % --> only consider l1-Homotopy, ISAL1, CPLEX, SoPlex
    %
    % HDR:
    j=1;
    k=zeros(1,274);
    instances;
    for i=1:274
        if(cell2mat(InstancesHDR(i,2))==1024)
            k(j) = 1;
        elseif(cell2mat(InstancesHDR(i,2))==1536)
            k(j) = 2;
        elseif(cell2mat(InstancesHDR(i,2))==2048)
            k(j) = 3;
        elseif(cell2mat(InstancesHDR(i,2))==3072)
            k(j) = 4;
        elseif(cell2mat(InstancesHDR(i,2))==4096)
            k(j) = 5;
        elseif(cell2mat(InstancesHDR(i,2))==6144)
            k(j) = 6;
        elseif(cell2mat(InstancesHDR(i,2))==8192)
            k(j) = 7;
        elseif(cell2mat(InstancesHDR(i,2))==12288)
            k(j) = 8;
        elseif(cell2mat(InstancesHDR(i,2))==16384)
            k(j) = 9;
        elseif(cell2mat(InstancesHDR(i,2))==24576)
            k(j) = 10;
        elseif(cell2mat(InstancesHDR(i,2))==32768)
            k(j) = 11;
        elseif(cell2mat(InstancesHDR(i,2))==49152)
            k(j) = 12;
        end
        j = j+1;
    end
    %geomean = @(x)prod(x.^(1/length(x))); % already exists in Matlab ...
    columns = [1024 1536 2048 3072 4096 6144 8192 12288 16384 24576 32768 49152];

    % limit to those instances each solver reached "solved" status:
    ISAL1_solved = find( ISAL1_noHOC_HDR_xdiff <= 1e-6 );
    L1LP_CPX_solved = find( L1LP_CPX_HDR_xdiff <= 1e-6 );
    L1LP_SPX_solved = find( L1LP_SPX_HDR_xdiff <= 1e-6 );
    Homotopy_solved = find( Homotopy_HDR_xdiff <= 1e-6 );

    filename = 'HDR_table_mean_times_solved_wo_HOC_over_same_cols.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\footnotesize\n\\newcolumntype{d}[1]{D{.}{.}{#1}}\n');
    fprintf(fid,'\\begin{tabular*}{\\textwidth}{@{\\extracolsep{\\fill}}r@{\\quad} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2}@{}}\\toprule\n');
    fprintf(fid,'  & & & \\multicolumn{1}{c}{$\\ell_{1}$-Hom.} & \\multicolumn{1}{c}{ISAL1} & \\multicolumn{1}{c}{CPLEX} & \\multicolumn{1}{c}{SoPlex} \\\\\n');  %& \\multicolumn{1}{c}{\\ell_{1}-M.} 
    fprintf(fid,'  & & & \\multicolumn{1}{c}{w/o HOC} & \\multicolumn{1}{c}{w/o HOC} & \\multicolumn{1}{c}{(w/o HOC)} & \\multicolumn{1}{c}{(w/o HOC)} \\\\\n');
    fprintf(fid,'\\midrule\n $n$ & \\multicolumn{1}{c}{solved by all/of} & & & & \\\\\n\\midrule\n');
    
    for j = 1:12
        group = find( k == j );
        orig_groupsize = numel(group);
        orig_group = group;
        
        group = intersect( group, Homotopy_solved );
        group = intersect( group, ISAL1_solved );
        group = intersect( group, L1LP_CPX_solved );
        group = intersect( group, L1LP_SPX_solved );
        
        groupsize = numel(group);
        
        fprintf(fid,' $%d$ & \\multicolumn{1}{c}{$%d/%d$} & \\multicolumn{1}{r}{solved} & \\multicolumn{1}{r}{$%d/%d$} & \\multicolumn{1}{r}{$%d/%d$} & \\multicolumn{1}{r}{$%d/%d$} & \\multicolumn{1}{r}{$%d/%d$}\\\\\n',...
            columns(j),groupsize,orig_groupsize,nnz(Homotopy_HDR_xdiff(orig_group)<=1e-6),orig_groupsize,nnz(ISAL1_noHOC_HDR_xdiff(orig_group)<=1e-6),orig_groupsize,nnz(L1LP_CPX_HDR_xdiff(orig_group)<=1e-6),orig_groupsize,nnz(L1LP_SPX_HDR_xdiff(orig_group)<=1e-6),orig_groupsize);
      
        fprintf(fid,' & & \\multicolumn{1}{r}{$t$ [s]} ');
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}\\\\\n');
        else
            fprintf(fid,' & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$}  \\\\\n',...
                geomean(Homotopy_HDR_time(group)),geomean(ISAL1_noHOC_HDR_time(group)),geomean(L1LP_CPX_HDR_time(group(L1LP_CPX_HDR_time(group)~=0))),geomean(L1LP_SPX_HDR_time(group)));            
        end
        fprintf(fid,' & & \\multicolumn{1}{r}{var$(t)$~|~max~$t$} ');
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}\\\\\n');
        else
            fprintf(fid,'& \\multicolumn{1}{r}{$%3.2f$ | $%3.2f$} & \\multicolumn{1}{r}{$%3.2f$ | $%3.2f$} & \\multicolumn{1}{r}{$%3.2f$ | $%3.2f$} & \\multicolumn{1}{r}{$%3.2f$ | $%3.2f$}\\\\\n',...
                var(Homotopy_HDR_time(group)),max(Homotopy_HDR_time(group)),var(ISAL1_noHOC_HDR_time(group)),max(ISAL1_noHOC_HDR_time(group)),var(L1LP_CPX_HDR_time(group)),max(L1LP_CPX_HDR_time(group)),var(L1LP_SPX_HDR_time(group)),max(L1LP_SPX_HDR_time(group)));                 
        end
        fprintf(fid,' & & \\multicolumn{1}{r}{$\\|\\bar x -x^*\\|$} ');        
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}\\\\\n');
        else
            fprintf(fid,' & \\multicolumn{1}{r}{%3.2e} & \\multicolumn{1}{r}{%3.2e} & \\multicolumn{1}{r}{%3.2e} & \\multicolumn{1}{r}{%3.2e}\\\\[0.5em]\n',...
                mean(Homotopy_HDR_xdiff(group)),mean(ISAL1_noHOC_HDR_xdiff(group)),mean(L1LP_CPX_HDR_xdiff(group)),mean(L1LP_SPX_HDR_xdiff(group)));            
        end
    end
    fprintf(fid,'\\bottomrule\n\\end{tabular*}\n');
    fclose(fid);    
    % LDR:
    ISAL1_solved = find( ISAL1_noHOC_LDR_xdiff <= 1e-6 );
    L1LP_CPX_solved = find( L1LP_CPX_LDR_xdiff <= 1e-6 );
    L1LP_SPX_solved = find( L1LP_SPX_LDR_xdiff <= 1e-6 );
    Homotopy_solved = find( Homotopy_LDR_xdiff <= 1e-6 );

    filename = 'LDR_table_mean_times_solved_wo_HOC_over_same_cols.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\footnotesize\n\\newcolumntype{d}[1]{D{.}{.}{#1}}\n');
    fprintf(fid,'\\begin{tabular*}{\\textwidth}{@{\\extracolsep{\\fill}}r@{\\quad} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2} d{3.2}@{}}\\toprule\n');
    fprintf(fid,'  & & & \\multicolumn{1}{c}{$\\ell_{1}$-Hom.} & \\multicolumn{1}{c}{ISAL1} & \\multicolumn{1}{c}{CPLEX} & \\multicolumn{1}{c}{SoPlex} \\\\\n');  %& \\multicolumn{1}{c}{\\ell_{1}-M.} 
    fprintf(fid,'  & & & \\multicolumn{1}{c}{w/o HOC} & \\multicolumn{1}{c}{w/o HOC} & \\multicolumn{1}{c}{(w/o HOC)} & \\multicolumn{1}{c}{(w/o HOC)} \\\\\n');
    fprintf(fid,'\\midrule\n $n$ & \\multicolumn{1}{c}{solved by all/of} & & & & \\\\\n\\midrule\n');
    
    for j = 1:12
        group = find( k == j );
        orig_groupsize = numel(group);
        orig_group = group;
        
        group = intersect( group, Homotopy_solved );
        group = intersect( group, ISAL1_solved );
        group = intersect( group, L1LP_CPX_solved );
        group = intersect( group, L1LP_SPX_solved );
        
        groupsize = numel(group);
        
        fprintf(fid,' $%d$ & \\multicolumn{1}{c}{$%d/%d$} & \\multicolumn{1}{r}{solved} & \\multicolumn{1}{r}{$%d/%d$} & \\multicolumn{1}{r}{$%d/%d$} & \\multicolumn{1}{r}{$%d/%d$} & \\multicolumn{1}{r}{$%d/%d$}\\\\\n',...
            columns(j),groupsize,orig_groupsize,nnz(Homotopy_LDR_xdiff(orig_group)<=1e-6),orig_groupsize,nnz(ISAL1_noHOC_LDR_xdiff(orig_group)<=1e-6),orig_groupsize,nnz(L1LP_CPX_LDR_xdiff(orig_group)<=1e-6),orig_groupsize,nnz(L1LP_SPX_LDR_xdiff(orig_group)<=1e-6),orig_groupsize);
        fprintf(fid,' & & \\multicolumn{1}{r}{$t$ [s]} ');
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}\\\\\n');
        else
            fprintf(fid,' & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$}  \\\\\n',...
                geomean(Homotopy_LDR_time(group)),geomean(ISAL1_noHOC_LDR_time(group)),geomean(L1LP_CPX_LDR_time(group(L1LP_CPX_LDR_time(group)~=0))),geomean(L1LP_SPX_LDR_time(group)));            
        end
        fprintf(fid,' & & \\multicolumn{1}{r}{var$(t)$~|~max~$t$} ');
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}\\\\\n');
        else
            fprintf(fid,'& \\multicolumn{1}{r}{$%3.2f$ | $%3.2f$} & \\multicolumn{1}{r}{$%3.2f$ | $%3.2f$} & \\multicolumn{1}{r}{$%3.2f$ | $%3.2f$} & \\multicolumn{1}{r}{$%3.2f$ | $%3.2f$}\\\\\n',...
                var(Homotopy_LDR_time(group)),max(Homotopy_LDR_time(group)),var(ISAL1_noHOC_LDR_time(group)),max(ISAL1_noHOC_LDR_time(group)),var(L1LP_CPX_LDR_time(group)),max(L1LP_CPX_LDR_time(group)),var(L1LP_SPX_LDR_time(group)),max(L1LP_SPX_LDR_time(group)));                 
        end
        fprintf(fid,' & & \\multicolumn{1}{r}{$\\|\\bar x -x^*\\|$} ');        
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}\\\\\n');
        else
            fprintf(fid,' & \\multicolumn{1}{r}{%3.2e} & \\multicolumn{1}{r}{%3.2e} & \\multicolumn{1}{r}{%3.2e} & \\multicolumn{1}{r}{%3.2e}\\\\[0.5em]\n',...
                mean(Homotopy_LDR_xdiff(group)),mean(ISAL1_noHOC_LDR_xdiff(group)),mean(L1LP_CPX_LDR_xdiff(group)),mean(L1LP_SPX_LDR_xdiff(group)));            
        end
    end
    fprintf(fid,'\\bottomrule\n\\end{tabular*}\n');
    fclose(fid);
    % HDR and LDR:
    k = [k,k];
    ISAL1_solved = find( ISAL1_noHOC_xdiff <= 1e-6 );
    L1LP_CPX_solved = find( L1LP_CPX_xdiff <= 1e-6 );
    L1LP_SPX_solved = find( L1LP_SPX_xdiff <= 1e-6 );
    Homotopy_solved = find( Homotopy_xdiff <= 1e-6 );

    filename = 'HDRandLDR_table_mean_times_solved_wo_HOC_over_same_cols.tex';
    fid = fopen(filename,'wt');
    %fprintf(fid,'\\newcolumntype{d}[1]{D{.}{.}{#1}}\n');
    fprintf(fid,'\\begin{tabular*}{\\textwidth}{@{\\extracolsep{\\fill}}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{}}\\toprule\n');
    fprintf(fid,' $n$ & \\multicolumn{1}{r}{used/of} & & \\multicolumn{1}{r}{$\\ell_{1}$-Hom.} & \\multicolumn{1}{r}{ISAL1} & \\multicolumn{1}{r}{CPLEX} & \\multicolumn{1}{r}{SoPlex} \\\\\n');  %& \\multicolumn{1}{c}{\\ell_{1}-M.} 
    %fprintf(fid,'  & & & \\multicolumn{1}{r}{w/o HOC} & \\multicolumn{1}{r}{w/o HOC} & \\multicolumn{1}{r}{(w/o HOC)} & \\multicolumn{1}{r}{(w/o HOC)} \\\\\n');
    fprintf(fid,'\\midrule\n');
        
    for j = 1:12
        group = find( k == j );
        orig_groupsize = numel(group);
        orig_group = group;        
        group = intersect( group, Homotopy_solved );
        group = intersect( group, ISAL1_solved );
        group = intersect( group, L1LP_CPX_solved );
        group = intersect( group, L1LP_SPX_solved );
        
        groupsize = numel(group);
        
        fprintf(fid,' $%d$ & \\multicolumn{1}{r}{$%d/%d$} & \\multicolumn{1}{r}{solved} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$}\\\\\n',...
            columns(j),groupsize,orig_groupsize,nnz(Homotopy_xdiff(orig_group)<=1e-6),nnz(ISAL1_noHOC_xdiff(orig_group)<=1e-6),nnz(L1LP_CPX_xdiff(orig_group)<=1e-6),nnz(L1LP_SPX_xdiff(orig_group)<=1e-6));
        
        fprintf(fid,' & & \\multicolumn{1}{r}{avg.~$t$} ');
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}\\\\\n');
        else      
            fprintf(fid,'& \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$}\\\\\n',...
                geomean(Homotopy_time(group)),geomean(ISAL1_noHOC_time(group)),geomean(L1LP_CPX_time(group(L1LP_CPX_time(group)~=0))),geomean(L1LP_SPX_time(group)));       
        end
        fprintf(fid,' & & \\multicolumn{1}{r}{max~$t$} ');        
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}\\\\\n');
        else      
            fprintf(fid,'& \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$}\\\\[0.5em]\n',...
                max(Homotopy_time(group)),max(ISAL1_noHOC_time(group)),max(L1LP_CPX_time(group)),max(L1LP_SPX_time(group)) );                 
        end
    end
    fprintf(fid,'\\bottomrule\n\\end{tabular*}\n');
    fclose(fid);
    
    
    filename = 'HDRandLDR_table_mean_times_solved_w_HOC_over_same_cols.tex';
    fid = fopen(filename,'wt');
    %fprintf(fid,'\\newcolumntype{d}[1]{D{.}{.}{#1}}\n');
    fprintf(fid,'\\begin{tabular*}{\\textwidth}{@{\\extracolsep{\\fill}}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{}}\\toprule\n');
    fprintf(fid,' $n$ & \\multicolumn{1}{r}{used/of} & & \\multicolumn{1}{r}{$\\ell_{1}$-Hom.} & \\multicolumn{1}{r}{ISAL1} & \\multicolumn{1}{r}{$\\ell_1$-Magic} & \\multicolumn{1}{r}{SPGL1} & \\multicolumn{1}{r}{CPLEX} & \\multicolumn{1}{r}{SoPlex} \\\\\n');  %& \\multicolumn{1}{c}{\\ell_{1}-M.} 
    %fprintf(fid,'  & & & \\multicolumn{1}{r}{w/ HOC} & \\multicolumn{1}{r}{w/ HOC} & \\multicolumn{1}{r}{w/ HOC} & \\multicolumn{1}{r}{w/ HOC} & \\multicolumn{1}{r}{(w/o HOC)} & \\multicolumn{1}{r}{(w/o HOC)} \\\\\n');
    fprintf(fid,'\\midrule\n');

    ISAL1_solved = find( ISAL1_xdiff <= 1e-6 );
    L1LP_CPX_solved = find( L1LP_CPX_xdiff <= 1e-6 );
    L1LP_SPX_solved = find( L1LP_SPX_xdiff <= 1e-6 );
    Homotopy_solved = find( Homotopy_HOC_xdiff <= 1e-6 );
    l1MAGIC_solved = find( l1MAGIC_HOC_xdiff <= 1e-6 );
    SPGL1_solved = find( SPGL1_HOC_xdiff <= 1e-6 );

    for j = 1:12
        group = find( k == j );
        orig_groupsize = numel(group);
        orig_group = group;        
        group = intersect( group, Homotopy_solved );
        group = intersect( group, ISAL1_solved );
        group = intersect( group, L1LP_CPX_solved );
        group = intersect( group, L1LP_SPX_solved );
        group = intersect( group, l1MAGIC_solved );
        group = intersect( group, SPGL1_solved );
        
        groupsize = numel(group);
        
        fprintf(fid,' $%d$ & \\multicolumn{1}{r}{$%d/%d$} & \\multicolumn{1}{r}{solved} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$}\\\\\n',...
            columns(j),groupsize,orig_groupsize,nnz(Homotopy_HOC_xdiff(orig_group)<=1e-6),nnz(ISAL1_xdiff(orig_group)<=1e-6),nnz(l1MAGIC_HOC_xdiff(orig_group)<=1e-6),nnz(SPGL1_HOC_xdiff(orig_group)<=1e-6),nnz(L1LP_CPX_xdiff(orig_group)<=1e-6),nnz(L1LP_SPX_xdiff(orig_group)<=1e-6));
        
        fprintf(fid,' & & \\multicolumn{1}{r}{avg.~$t$} ');
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}\\\\\n');
        else      
            fprintf(fid,'& \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$}\\\\\n',...
                geomean(Homotopy_HOC_time(group)),geomean(ISAL1_time(group)),geomean(l1MAGIC_HOC_time(group)),geomean(SPGL1_HOC_time(group)),geomean(L1LP_CPX_time(group(L1LP_CPX_time(group)~=0))),geomean(L1LP_SPX_time(group)));       
        end
        fprintf(fid,' & & \\multicolumn{1}{r}{max~$t$} ');        
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}\\\\\n');
        else      
            fprintf(fid,'& \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$}\\\\[0.5em]\n',...
                max(Homotopy_HOC_time(group)),max(ISAL1_time(group)),max(l1MAGIC_HOC_time(group)),max(SPGL1_HOC_time(group)),max(L1LP_CPX_time(group)),max(L1LP_SPX_time(group)) );                 
        end
    end
    fprintf(fid,'\\bottomrule\n\\end{tabular*}\n');
    fclose(fid);

% with YALL1:    
%     filename = 'HDRandLDR_table_mean_times_acceptable_wo_HOC_over_same_cols.tex';
%     fid = fopen(filename,'wt');
%     %fprintf(fid,'\\newcolumntype{d}[1]{D{.}{.}{#1}}\n');
%     fprintf(fid,'\\begin{tabular*}{\\textwidth}{@{\\extracolsep{\\fill}}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{}}\\toprule\n');
%     fprintf(fid,' $n$ & \\multicolumn{1}{r}{used/of} & & \\multicolumn{1}{r}{$\\ell_{1}$-Magic} & \\multicolumn{1}{r}{SPGL1} & \\multicolumn{1}{r}{SolveBP} & \\multicolumn{1}{r}{YALL1} \\\\\n');  %& \\multicolumn{1}{c}{\\ell_{1}-M.} 
%     %fprintf(fid,'  & & & \\multicolumn{1}{r}{w/o HOC} & \\multicolumn{1}{r}{w/o HOC} & \\multicolumn{1}{r}{(w/o HOC)} & \\multicolumn{1}{r}{(w/o HOC)} \\\\\n');
%     fprintf(fid,'\\midrule\n');
%     
%     l1MAGIC_acceptable = find(l1MAGIC_xdiff<=1e-1);
%     SPGL1_acceptable = find(SPGL1_xdiff<=1e-1);
%     YALL1_acceptable = find(YALL1_xdiff<=1e-1);
%     SolveBP_acceptable = find(SolveBP_xdiff<=1e-1);
%     
%     for j = 1:12
%         group = find( k == j );
%         orig_groupsize = numel(group);
%         orig_group = group;
%         group = intersect( group, l1MAGIC_acceptable );
%         group = intersect( group, SPGL1_acceptable );
%         group = intersect( group, YALL1_acceptable );
%         group = intersect( group, SolveBP_acceptable );
%         
%         groupsize = numel(group);
%         
%         fprintf(fid,' $%d$ & \\multicolumn{1}{r}{$%d/%d$} & \\multicolumn{1}{r}{$\\leq$ acceptable} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$}\\\\\n',...
%             columns(j),groupsize,orig_groupsize,nnz(l1MAGIC_xdiff(orig_group)<=1e-1),nnz(SPGL1_xdiff(orig_group)<=1e-1),nnz(SolveBP_xdiff(orig_group)<=1e-1),nnz(YALL1_xdiff(orig_group)<=1e-1));
%         
%         fprintf(fid,' & & \\multicolumn{1}{r}{avg.~$t$} ');
%         if( groupsize == 0 )
%             fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}\\\\\n');
%         else      
%             fprintf(fid,'& \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$}\\\\\n',...
%                 geomean(l1MAGIC_time(group)),geomean(SPGL1_time(group)),geomean(SolveBP_time(group)),geomean(YALL1_time(group)));       
%         end
%         fprintf(fid,' & & \\multicolumn{1}{r}{max~$t$} ');        
%         if( groupsize == 0 )
%             fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}\\\\\n');
%         else      
%             fprintf(fid,'& \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$}\\\\[0.5em]\n',...
%                 max(l1MAGIC_time(group)),max(SPGL1_time(group)),max(SolveBP_time(group)),max(YALL1_time(group)) );                 
%         end
%     end
%     fprintf(fid,'\\bottomrule\n\\end{tabular*}\n');
%     fclose(fid);

% without YALL1:
    filename = 'HDRandLDR_table_mean_times_acceptable_wo_HOC_over_same_cols.tex';
    fid = fopen(filename,'wt');
    %fprintf(fid,'\\newcolumntype{d}[1]{D{.}{.}{#1}}\n');
    fprintf(fid,'\\begin{tabular*}{\\textwidth}{@{\\extracolsep{\\fill}}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{}}\\toprule\n');
    fprintf(fid,' $n$ & \\multicolumn{1}{r}{used/of} & & \\multicolumn{1}{r}{$\\ell_{1}$-Magic} & \\multicolumn{1}{r}{SPGL1} & \\multicolumn{1}{r}{SolveBP} \\\\\n');  %& \\multicolumn{1}{c}{\\ell_{1}-M.} 
    %fprintf(fid,'  & & & \\multicolumn{1}{r}{w/o HOC} & \\multicolumn{1}{r}{w/o HOC} & \\multicolumn{1}{r}{(w/o HOC)} & \\multicolumn{1}{r}{(w/o HOC)} \\\\\n');
    fprintf(fid,'\\midrule\n');
    
    l1MAGIC_acceptable = find(l1MAGIC_xdiff<=1e-1);
    SPGL1_acceptable = find(SPGL1_xdiff<=1e-1);
    SolveBP_acceptable = find(SolveBP_xdiff<=1e-1);
    
    for j = 1:12
        group = find( k == j );
        orig_groupsize = numel(group);
        orig_group = group;
        group = intersect( group, l1MAGIC_acceptable );
        group = intersect( group, SPGL1_acceptable );
        group = intersect( group, SolveBP_acceptable );
        
        groupsize = numel(group);
        
        fprintf(fid,' $%d$ & \\multicolumn{1}{r}{$%d/%d$} & \\multicolumn{1}{r}{$\\leq$ acceptable} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$} \\\\\n',...
            columns(j),groupsize,orig_groupsize,nnz(l1MAGIC_xdiff(orig_group)<=1e-1),nnz(SPGL1_xdiff(orig_group)<=1e-1),nnz(SolveBP_xdiff(orig_group)<=1e-1));
        
        fprintf(fid,' & & \\multicolumn{1}{r}{avg.~$t$} ');
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--}\\\\\n');
        else      
            fprintf(fid,'& \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} \\\\\n',...
                geomean(l1MAGIC_time(group)),geomean(SPGL1_time(group)),geomean(SolveBP_time(group)));       
        end
        fprintf(fid,' & & \\multicolumn{1}{r}{max~$t$} ');        
        if( groupsize == 0 )
            fprintf(fid,' & \\multicolumn{1}{r}{--} & \\multicolumn{1}{r}{--}& \\multicolumn{1}{r}{--} \\\\\n');
        else      
            fprintf(fid,'& \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} & \\multicolumn{1}{r}{$%3.2f$} \\\\[0.5em]\n',...
                max(l1MAGIC_time(group)),max(SPGL1_time(group)),max(SolveBP_time(group)) );                 
        end
    end
    fprintf(fid,'\\bottomrule\n\\end{tabular*}\n');
    fclose(fid); 
            
    % Create table with L1-Testset instance details, for reference:
    % HDR:
    filename = 'HDR_table_instance_details.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\begin{longtable}{@{}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}}\\toprule\\\\\n');
    fprintf(fid,' Instance No. & $m$ & $n$& $A$ & $\\|x^*\\|_0$  & Dynamic Range of $x^*$ \\\\\n\\midrule\n');
    for k = 1:274
        fprintf(fid,'$%d$ & $%d$ & $%d$ & [%s] & $%d$ & \\verb|%5.3e|\\\\\n',k,InstancesHDR{k,1},InstancesHDR{k,2},InstancesHDR{k,3},InstancesHDR{k,4},InstancesHDR{k,5});
    end
    fprintf(fid,'\\bottomrule\n\\end{longtable}\n');
    fclose(fid);
    % LDR:
    filename = 'LDR_table_instance_details.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\begin{longtable}{@{}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}}\\toprule\\\\\n');
    fprintf(fid,' Instance No. & $m$ & $n$& $A$ & $\\|x^*\\|_0$  & Dynamic Range of $x^*$ \\\\\n\\midrule\n');
    for k = 1:274
        fprintf(fid,'$%d$ & $%d$ & $%d$ & [%s] & $%d$ & \\verb|%5.3e|\\\\\n',k+274,InstancesLDR{k,1},InstancesLDR{k,2},InstancesLDR{k,3},InstancesLDR{k,4},InstancesLDR{k,5});
    end
    fprintf(fid,'\\bottomrule\n\\end{longtable}\n');
    fclose(fid);
    % HDR and LDR:
     filename = 'HDRandLDR_table_instance_details.tex';
     fid = fopen(filename,'wt');
     fprintf(fid,'\\begin{longtable}{@{}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\qquad}r@{\\quad}}\\toprule\\\\\n');
     fprintf(fid,' Testset part & Instance No. & $m$ & $n$& $A$ & $\\|x^*\\|_0$  & Dynamic Range of $x^*$ & Uniqueness via\\\\\n\\midrule\n');
     for k = 1:274
         if( mod(k,2) == 1 && k <= 200 )
             fprintf(fid,'HDR & $%d$ & $%d$ & $%d$ & [%s] & $%d$ & \\verb|%5.3e| & ERC \\\\\n',k,InstancesHDR{k,1},InstancesHDR{k,2},InstancesHDR{k,3},InstancesHDR{k,4},InstancesHDR{k,5});
         elseif( mod(k,2) == 0 && k <= 200 )
             fprintf(fid,'HDR & $%d$ & $%d$ & $%d$ & [%s] & $%d$ & \\verb|%5.3e| & ERC-extend \\\\\n',k,InstancesHDR{k,1},InstancesHDR{k,2},InstancesHDR{k,3},InstancesHDR{k,4},InstancesHDR{k,5});
         else
             fprintf(fid,'HDR & $%d$ & $%d$ & $%d$ & [%s] & $%d$ & \\verb|%5.3e| & $\\ell_1$-testpack \\\\\n',k,InstancesHDR{k,1},InstancesHDR{k,2},InstancesHDR{k,3},InstancesHDR{k,4},InstancesHDR{k,5});
         end
     end
     fprintf(fid,'\\midrule\n');
     for k = 1:274
         if( mod(k,2) == 1 && k <= 200 )
             fprintf(fid,'LDR & $%d$ & $%d$ & $%d$ & [%s] & $%d$ & \\verb|%5.3e| & ERC \\\\\n',k+274,InstancesLDR{k,1},InstancesLDR{k,2},InstancesLDR{k,3},InstancesLDR{k,4},InstancesLDR{k,5});
         elseif( mod(k,2) == 0 && k <= 200 )
             fprintf(fid,'LDR & $%d$ & $%d$ & $%d$ & [%s] & $%d$ & \\verb|%5.3e| & ERC-extend \\\\\n',k+274,InstancesLDR{k,1},InstancesLDR{k,2},InstancesLDR{k,3},InstancesLDR{k,4},InstancesLDR{k,5});
         else
             fprintf(fid,'LDR & $%d$ & $%d$ & $%d$ & [%s] & $%d$ & \\verb|%5.3e| & $\\ell_1$-testpack \\\\\n',k+274,InstancesLDR{k,1},InstancesLDR{k,2},InstancesLDR{k,3},InstancesLDR{k,4},InstancesLDR{k,5});      
         end
     end
     fprintf(fid,'\\bottomrule\n\\end{longtable}\n');
     fclose(fid);
    
    
    % Create tables with *all* results for the L1-Testset (HDR, LDR, both):
    %
    % 1st: without HOC
    %
    % HDR:
    filename = 'HDR_table_all_results_wo_HOC.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\begin{longtable}{@{}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}}\\toprule\\\\\n');
    fprintf(fid,'Inst. & \\multicolumn{2}{c}{ISAL1} & \\multicolumn{2}{c}{CPLEX} & \\multicolumn{2}{c}{SoPlex} & \\multicolumn{2}{c}{SPGL1} & \\multicolumn{2}{c}{$\\ell_1$-Homotopy} & \\multicolumn{2}{c}{YALL1} & \\multicolumn{2}{c}{$\\ell_1$-MAGIC} & \\multicolumn{2}{c}{SparseLab}\\\\\n\n');
    fprintf(fid,' & \\multicolumn{2}{c}{w/o HOC} & \\multicolumn{2}{c}{(w/o HOC)} & \\multicolumn{2}{c}{(w/o HOC)} & \\multicolumn{2}{c}{w/o HOC} & \\multicolumn{2}{c}{w/o HOC} & \\multicolumn{2}{c}{w/o HOC} & \\multicolumn{2}{c}{w/o HOC} & \\multicolumn{2}{c}{w/o HOC} \\\\\n\\midrule\n');
    fprintf(fid,' & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ \\\\\n\\midrule\n');
    for k = 1:274
        fprintf(fid,' %d & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| \\\\\n',...
            k,ISAL1_noHOC_HDR_time(k),ISAL1_noHOC_HDR_xdiff(k),L1LP_CPX_HDR_time(k),L1LP_CPX_HDR_xdiff(k),L1LP_SPX_HDR_time(k),L1LP_SPX_HDR_xdiff(k),SPGL1_HDR_time(k),SPGL1_HDR_xdiff(k),...
            Homotopy_HDR_time(k),Homotopy_HDR_xdiff(k),YALL1_HDR_time(k),YALL1_HDR_xdiff(k),l1MAGIC_HDR_time(k),l1MAGIC_HDR_xdiff(k),SolveBP_HDR_time(k),SolveBP_HDR_xdiff(k));
    end
    fprintf(fid,'\\bottomrule\n\\end{longtable}\n');
    fclose(fid);
    % LDR:
    filename = 'LDR_table_all_results_wo_HOC.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\begin{longtable}{@{}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}}\\toprule\\\\\n');
    fprintf(fid,'Inst. & \\multicolumn{2}{c}{ISAL1} & \\multicolumn{2}{c}{CPLEX} & \\multicolumn{2}{c}{SoPlex} & \\multicolumn{2}{c}{SPGL1} & \\multicolumn{2}{c}{$\\ell_1$-Homotopy} & \\multicolumn{2}{c}{YALL1} & \\multicolumn{2}{c}{$\\ell_1$-MAGIC} & \\multicolumn{2}{c}{SparseLab}\\\\\n\n');
    fprintf(fid,' & \\multicolumn{2}{c}{w/o HOC} & \\multicolumn{2}{c}{(w/o HOC)} & \\multicolumn{2}{c}{(w/o HOC)} & \\multicolumn{2}{c}{w/o HOC} & \\multicolumn{2}{c}{w/o HOC} & \\multicolumn{2}{c}{w/o HOC} & \\multicolumn{2}{c}{w/o HOC} & \\multicolumn{2}{c}{w/o HOC} \\\\\n\\midrule\n');
    fprintf(fid,' & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ \\\\\n\\midrule\n');
    for k = 1:274
        fprintf(fid,' %d & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| \\\\\n',...
            k+274,ISAL1_noHOC_LDR_time(k),ISAL1_noHOC_LDR_xdiff(k),L1LP_CPX_LDR_time(k),L1LP_CPX_LDR_xdiff(k),L1LP_SPX_LDR_time(k),L1LP_SPX_LDR_xdiff(k),SPGL1_LDR_time(k),SPGL1_LDR_xdiff(k),...
            Homotopy_LDR_time(k),Homotopy_LDR_xdiff(k),YALL1_LDR_time(k),YALL1_LDR_xdiff(k),l1MAGIC_LDR_time(k),l1MAGIC_LDR_xdiff(k),SolveBP_LDR_time(k),SolveBP_LDR_xdiff(k));
    end
    fprintf(fid,'\\bottomrule\n\\end{longtable}\n');
    fclose(fid);
    % HDR and LDR:
    filename = 'HDRandLDR_table_all_results_wo_HOC.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\begin{longtable}{@{}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}}\\toprule\\\\\n');
    fprintf(fid,'Inst. & \\multicolumn{2}{c}{ISAL1} & \\multicolumn{2}{c}{CPLEX} & \\multicolumn{2}{c}{SoPlex} & \\multicolumn{2}{c}{SPGL1} & \\multicolumn{2}{c}{$\\ell_1$-Homotopy} & \\multicolumn{2}{c}{YALL1} & \\multicolumn{2}{c}{$\\ell_1$-MAGIC} & \\multicolumn{2}{c}{SparseLab}\\\\\n\n');
    fprintf(fid,' & \\multicolumn{2}{c}{w/o HOC} & \\multicolumn{2}{c}{(w/o HOC)} & \\multicolumn{2}{c}{(w/o HOC)} & \\multicolumn{2}{c}{w/o HOC} & \\multicolumn{2}{c}{w/o HOC} & \\multicolumn{2}{c}{w/o HOC} & \\multicolumn{2}{c}{w/o HOC} & \\multicolumn{2}{c}{w/o HOC} \\\\\n\\midrule\n');
    fprintf(fid,' & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ \\\\\n\\midrule\n');
    for k = 1:274
        fprintf(fid,' %d & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| \\\\\n',...
            k,ISAL1_noHOC_HDR_time(k),ISAL1_noHOC_HDR_xdiff(k),L1LP_CPX_HDR_time(k),L1LP_CPX_HDR_xdiff(k),L1LP_SPX_HDR_time(k),L1LP_SPX_HDR_xdiff(k),SPGL1_HDR_time(k),SPGL1_HDR_xdiff(k),...
            Homotopy_HDR_time(k),Homotopy_HDR_xdiff(k),YALL1_HDR_time(k),YALL1_HDR_xdiff(k),l1MAGIC_HDR_time(k),l1MAGIC_HDR_xdiff(k),SolveBP_HDR_time(k),SolveBP_HDR_xdiff(k));
    end
    fprintf(fid,'\\midrule\n');
    for k = 1:274
        fprintf(fid,' %d & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| \\\\\n',...
            k+274,ISAL1_noHOC_LDR_time(k),ISAL1_noHOC_LDR_xdiff(k),L1LP_CPX_LDR_time(k),L1LP_CPX_LDR_xdiff(k),L1LP_SPX_LDR_time(k),L1LP_SPX_LDR_xdiff(k),SPGL1_LDR_time(k),SPGL1_LDR_xdiff(k),...
            Homotopy_LDR_time(k),Homotopy_LDR_xdiff(k),YALL1_LDR_time(k),YALL1_LDR_xdiff(k),l1MAGIC_LDR_time(k),l1MAGIC_LDR_xdiff(k),SolveBP_LDR_time(k),SolveBP_LDR_xdiff(k));
    end
    fprintf(fid,'\\bottomrule\n\\end{longtable}\n');
    fclose(fid);
    %
    % 2nd: with HOC
    %
    % HDR:
    filename = 'HDR_table_all_results_w_HOC.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\begin{longtable}{@{}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}}\\toprule\\\\\n');
    fprintf(fid,'Inst. & \\multicolumn{2}{c}{ISAL1} & \\multicolumn{2}{c}{CPLEX} & \\multicolumn{2}{c}{SoPlex} & \\multicolumn{2}{c}{SPGL1} & \\multicolumn{2}{c}{$\\ell_1$-Homotopy} & \\multicolumn{2}{c}{YALL1} & \\multicolumn{2}{c}{$\\ell_1$-MAGIC} & \\multicolumn{2}{c}{SparseLab}\\\\\n\n');
    fprintf(fid,' & \\multicolumn{2}{c}{w/ HOC} & \\multicolumn{2}{c}{(w/o HOC)} & \\multicolumn{2}{c}{(w/o HOC)} & \\multicolumn{2}{c}{w/ HOC} & \\multicolumn{2}{c}{w/ HOC} & \\multicolumn{2}{c}{w/ HOC} & \\multicolumn{2}{c}{w/ HOC} & \\multicolumn{2}{c}{w/ HOC} \\\\\n\\midrule\n');
    fprintf(fid,' & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ \\\\\n\\midrule\n');
    for k = 1:274
        fprintf(fid,' %d & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| \\\\\n',...
            k,ISAL1_HDR_time(k),ISAL1_HDR_xdiff(k),L1LP_CPX_HDR_time(k),L1LP_CPX_HDR_xdiff(k),L1LP_SPX_HDR_time(k),L1LP_SPX_HDR_xdiff(k),SPGL1_HOC_HDR_time(k),SPGL1_HOC_HDR_xdiff(k),...
            Homotopy_HOC_HDR_time(k),Homotopy_HOC_HDR_xdiff(k),YALL1_HOC_HDR_time(k),YALL1_HOC_HDR_xdiff(k),l1MAGIC_HOC_HDR_time(k),l1MAGIC_HOC_HDR_xdiff(k),SolveBP_HOC_HDR_time(k),SolveBP_HOC_HDR_xdiff(k));
    end
    fprintf(fid,'\\bottomrule\n\\end{longtable}\n');
    fclose(fid);
    % LDR:
    filename = 'LDR_table_all_results_w_HOC.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\begin{longtable}{@{}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}}\\toprule\\\\\n');
    fprintf(fid,'Inst. & \\multicolumn{2}{c}{ISAL1} & \\multicolumn{2}{c}{CPLEX} & \\multicolumn{2}{c}{SoPlex} & \\multicolumn{2}{c}{SPGL1} & \\multicolumn{2}{c}{$\\ell_1$-Homotopy} & \\multicolumn{2}{c}{YALL1} & \\multicolumn{2}{c}{$\\ell_1$-MAGIC} & \\multicolumn{2}{c}{SparseLab}\\\\\n\n');
    fprintf(fid,' & \\multicolumn{2}{c}{w/ HOC} & \\multicolumn{2}{c}{(w/o HOC)} & \\multicolumn{2}{c}{(w/o HOC)} & \\multicolumn{2}{c}{w/ HOC} & \\multicolumn{2}{c}{w/ HOC} & \\multicolumn{2}{c}{w/ HOC} & \\multicolumn{2}{c}{w/ HOC} & \\multicolumn{2}{c}{w/ HOC} \\\\\n\\midrule\n');
    fprintf(fid,' & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ \\\\\n\\midrule\n');
    for k = 1:274
        fprintf(fid,' %d & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| \\\\\n',...
            k+274,ISAL1_LDR_time(k),ISAL1_LDR_xdiff(k),L1LP_CPX_LDR_time(k),L1LP_CPX_LDR_xdiff(k),L1LP_SPX_LDR_time(k),L1LP_SPX_LDR_xdiff(k),SPGL1_HOC_LDR_time(k),SPGL1_HOC_LDR_xdiff(k),...
            Homotopy_HOC_LDR_time(k),Homotopy_HOC_LDR_xdiff(k),YALL1_HOC_LDR_time(k),YALL1_HOC_LDR_xdiff(k),l1MAGIC_HOC_LDR_time(k),l1MAGIC_HOC_LDR_xdiff(k),SolveBP_HOC_LDR_time(k),SolveBP_HOC_LDR_xdiff(k));
    end
    fprintf(fid,'\\bottomrule\n\\end{longtable}\n');
    fclose(fid);    
    % HDR and LDR:
    filename = 'HDRandLDR_table_all_results_w_HOC.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\begin{longtable}{@{}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}}\\toprule\\\\\n');
    fprintf(fid,'Inst. & \\multicolumn{2}{c}{ISAL1} & \\multicolumn{2}{c}{CPLEX} & \\multicolumn{2}{c}{SoPlex} & \\multicolumn{2}{c}{SPGL1} & \\multicolumn{2}{c}{$\\ell_1$-Homotopy} & \\multicolumn{2}{c}{YALL1} & \\multicolumn{2}{c}{$\\ell_1$-MAGIC} & \\multicolumn{2}{c}{SparseLab}\\\\\n\n');
    fprintf(fid,' & \\multicolumn{2}{c}{w/ HOC} & \\multicolumn{2}{c}{(w/o HOC)} & \\multicolumn{2}{c}{(w/o HOC)} & \\multicolumn{2}{c}{w/ HOC} & \\multicolumn{2}{c}{w/ HOC} & \\multicolumn{2}{c}{w/ HOC} & \\multicolumn{2}{c}{w/ HOC} & \\multicolumn{2}{c}{w/ HOC} \\\\\n\\midrule\n');
    fprintf(fid,' & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ & $t$ [s] & $\\|\\bar x - x^*\\|$ \\\\\n\\midrule\n');
    for k = 1:274
        fprintf(fid,' %d & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| \\\\\n',...
            k,ISAL1_HDR_time(k),ISAL1_HDR_xdiff(k),L1LP_CPX_HDR_time(k),L1LP_CPX_HDR_xdiff(k),L1LP_SPX_HDR_time(k),L1LP_SPX_HDR_xdiff(k),SPGL1_HOC_HDR_time(k),SPGL1_HOC_HDR_xdiff(k),...
            Homotopy_HOC_HDR_time(k),Homotopy_HOC_HDR_xdiff(k),YALL1_HOC_HDR_time(k),YALL1_HOC_HDR_xdiff(k),l1MAGIC_HOC_HDR_time(k),l1MAGIC_HOC_HDR_xdiff(k),SolveBP_HOC_HDR_time(k),SolveBP_HOC_HDR_xdiff(k));
    end
    fprintf(fid,'\\midrule\n');
    for k = 1:274
        fprintf(fid,' %d & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| & \\verb|%3.2e| \\\\\n',...
            k+274,ISAL1_LDR_time(k),ISAL1_LDR_xdiff(k),L1LP_CPX_LDR_time(k),L1LP_CPX_LDR_xdiff(k),L1LP_SPX_LDR_time(k),L1LP_SPX_LDR_xdiff(k),SPGL1_HOC_LDR_time(k),SPGL1_HOC_LDR_xdiff(k),...
            Homotopy_HOC_LDR_time(k),Homotopy_HOC_LDR_xdiff(k),YALL1_HOC_LDR_time(k),YALL1_HOC_LDR_xdiff(k),l1MAGIC_HOC_LDR_time(k),l1MAGIC_HOC_LDR_xdiff(k),SolveBP_HOC_LDR_time(k),SolveBP_HOC_LDR_xdiff(k));
    end    
    fprintf(fid,'\\bottomrule\n\\end{longtable}\n');
    fclose(fid);    
    
    
    
    
    % Create tables with "solved, "acceptable", "unacceptable" instance percentage per solver, w/ and w/o HOC: 
    filename = 'HDRandLDR_table_algo_successes_percentage.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\begin{tabular*}{\\textwidth}{@{\\extracolsep{\\fill}}l@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{}}\\toprule\n');
    fprintf(fid,' & \\multicolumn{3}{c}{\\%% solved} & \\multicolumn{3}{c}{\\%% acceptable} & \\multicolumn{3}{c}{\\%% unacceptable}\\\\\n');
    fprintf(fid,'Solver & HDR & LDR & all & HDR & LDR & all & HDR & LDR & all\\\\\n\\midrule\n');
    fprintf(fid,'ISAL1 & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$\\\\\n',...
	nnz(ISAL1_noHOC_HDR_xdiff<=1e-6)/2.74, nnz(ISAL1_noHOC_LDR_xdiff<=1e-6)/2.74, nnz(ISAL1_noHOC_xdiff<=1e-6)/5.48, nnz(ISAL1_noHOC_HDR_xdiff(ISAL1_noHOC_HDR_xdiff>1e-6)<=1e-1)/2.74, nnz(ISAL1_noHOC_LDR_xdiff(ISAL1_noHOC_LDR_xdiff>1e-6)<=1e-1)/2.74, nnz(ISAL1_noHOC_xdiff(ISAL1_noHOC_xdiff>1e-6)<=1e-1)/5.48, nnz(ISAL1_noHOC_HDR_xdiff>1e-1)/2.74, nnz(ISAL1_noHOC_LDR_xdiff>1e-1)/2.74, nnz(ISAL1_noHOC_xdiff>1e-1)/5.48);
    fprintf(fid,'ISAL1 (HOC) & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$\\\\\n',...
	nnz(ISAL1_HDR_xdiff<=1e-6)/2.74, nnz(ISAL1_LDR_xdiff<=1e-6)/2.74, nnz(ISAL1_xdiff<=1e-6)/5.48, nnz(ISAL1_HDR_xdiff(ISAL1_HDR_xdiff>1e-6)<=1e-1)/2.74, nnz(ISAL1_LDR_xdiff(ISAL1_LDR_xdiff>1e-6)<=1e-1)/2.74, nnz(ISAL1_xdiff(ISAL1_xdiff>1e-6)<=1e-1)/5.48, nnz(ISAL1_HDR_xdiff>1e-1)/2.74, nnz(ISAL1_LDR_xdiff>1e-1)/2.74, nnz(ISAL1_xdiff>1e-1)/5.48);
    fprintf(fid,'SPGL1 & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$\\\\\n',...
	nnz(SPGL1_HDR_xdiff<=1e-6)/2.74, nnz(SPGL1_LDR_xdiff<=1e-6)/2.74, nnz(SPGL1_xdiff<=1e-6)/5.48, nnz(SPGL1_HDR_xdiff(SPGL1_HDR_xdiff>1e-6)<=1e-1)/2.74, nnz(SPGL1_LDR_xdiff(SPGL1_LDR_xdiff>1e-6)<=1e-1)/2.74, nnz(SPGL1_xdiff(SPGL1_xdiff>1e-6)<=1e-1)/5.48, nnz(SPGL1_HDR_xdiff>1e-1)/2.74, nnz(SPGL1_LDR_xdiff>1e-1)/2.74, nnz(SPGL1_xdiff>1e-1)/5.48);
    fprintf(fid,'SPGL1 (HOC) & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$\\\\\n',...
	nnz(SPGL1_HOC_HDR_xdiff<=1e-6)/2.74, nnz(SPGL1_HOC_LDR_xdiff<=1e-6)/2.74, nnz(SPGL1_HOC_xdiff<=1e-6)/5.48, nnz(SPGL1_HOC_HDR_xdiff(SPGL1_HOC_HDR_xdiff>1e-6)<=1e-1)/2.74, nnz(SPGL1_HOC_LDR_xdiff(SPGL1_HOC_LDR_xdiff>1e-6)<=1e-1)/2.74, nnz(SPGL1_HOC_xdiff(SPGL1_HOC_xdiff>1e-6)<=1e-1)/5.48, nnz(SPGL1_HOC_HDR_xdiff>1e-1)/2.74, nnz(SPGL1_HOC_LDR_xdiff>1e-1)/2.74, nnz(SPGL1_HOC_xdiff>1e-1)/5.48);
    fprintf(fid,'YALL1 & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$\\\\\n',...
	nnz(YALL1_HDR_xdiff<=1e-6)/2.74, nnz(YALL1_LDR_xdiff<=1e-6)/2.74, nnz(YALL1_xdiff<=1e-6)/5.48, nnz(YALL1_HDR_xdiff(YALL1_HDR_xdiff>1e-6)<=1e-1)/2.74, nnz(YALL1_LDR_xdiff(YALL1_LDR_xdiff>1e-6)<=1e-1)/2.74, nnz(YALL1_xdiff(YALL1_xdiff>1e-6)<=1e-1)/5.48, nnz(YALL1_HDR_xdiff>1e-1)/2.74, nnz(YALL1_LDR_xdiff>1e-1)/2.74, nnz(YALL1_xdiff>1e-1)/5.48);
    fprintf(fid,'YALL1 (HOC) & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$\\\\\n',...
	nnz(YALL1_HOC_HDR_xdiff<=1e-6)/2.74, nnz(YALL1_HOC_LDR_xdiff<=1e-6)/2.74, nnz(YALL1_HOC_xdiff<=1e-6)/5.48, nnz(YALL1_HOC_HDR_xdiff(YALL1_HOC_HDR_xdiff>1e-6)<=1e-1)/2.74, nnz(YALL1_HOC_LDR_xdiff(YALL1_HOC_LDR_xdiff>1e-6)<=1e-1)/2.74, nnz(YALL1_HOC_xdiff(YALL1_HOC_xdiff>1e-6)<=1e-1)/5.48, nnz(YALL1_HOC_HDR_xdiff>1e-1)/2.74, nnz(YALL1_HOC_LDR_xdiff>1e-1)/2.74, nnz(YALL1_HOC_xdiff>1e-1)/5.48);
    fprintf(fid,'$\\ell_1$-Hom.  & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$\\\\\n',...
	nnz(Homotopy_HDR_xdiff<=1e-6)/2.74, nnz(Homotopy_LDR_xdiff<=1e-6)/2.74, nnz(Homotopy_xdiff<=1e-6)/5.48, nnz(Homotopy_HDR_xdiff(Homotopy_HDR_xdiff>1e-6)<=1e-1)/2.74, nnz(Homotopy_LDR_xdiff(Homotopy_LDR_xdiff>1e-6)<=1e-1)/2.74, nnz(Homotopy_xdiff(Homotopy_xdiff>1e-6)<=1e-1)/5.48, nnz(Homotopy_HDR_xdiff>1e-1)/2.74, nnz(Homotopy_LDR_xdiff>1e-1)/2.74, nnz(Homotopy_xdiff>1e-1)/5.48);
    fprintf(fid,'$\\ell_1$-Hom. (HOC) & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$\\\\\n',...
	nnz(Homotopy_HOC_HDR_xdiff<=1e-6)/2.74, nnz(Homotopy_HOC_LDR_xdiff<=1e-6)/2.74, nnz(Homotopy_HOC_xdiff<=1e-6)/5.48, nnz(Homotopy_HOC_HDR_xdiff(Homotopy_HOC_HDR_xdiff>1e-6)<=1e-1)/2.74, nnz(Homotopy_HOC_LDR_xdiff(Homotopy_HOC_LDR_xdiff>1e-6)<=1e-1)/2.74, nnz(Homotopy_HOC_xdiff(Homotopy_HOC_xdiff>1e-6)<=1e-1)/5.48, nnz(Homotopy_HOC_HDR_xdiff>1e-1)/2.74, nnz(Homotopy_HOC_LDR_xdiff>1e-1)/2.74, nnz(Homotopy_HOC_xdiff>1e-1)/5.48);
    fprintf(fid,'SolveBP & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$\\\\\n',...
	nnz(SolveBP_HDR_xdiff<=1e-6)/2.74, nnz(SolveBP_LDR_xdiff<=1e-6)/2.74, nnz(SolveBP_xdiff<=1e-6)/5.48, nnz(SolveBP_HDR_xdiff(SolveBP_HDR_xdiff>1e-6)<=1e-1)/2.74, nnz(SolveBP_LDR_xdiff(SolveBP_LDR_xdiff>1e-6)<=1e-1)/2.74, nnz(SolveBP_xdiff(SolveBP_xdiff>1e-6)<=1e-1)/5.48, nnz(SolveBP_HDR_xdiff>1e-1)/2.74, nnz(SolveBP_LDR_xdiff>1e-1)/2.74, nnz(SolveBP_xdiff>1e-1)/5.48);
    fprintf(fid,'SolveBP (HOC) & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$\\\\\n',...
	nnz(SolveBP_HOC_HDR_xdiff<=1e-6)/2.74, nnz(SolveBP_HOC_LDR_xdiff<=1e-6)/2.74, nnz(SolveBP_HOC_xdiff<=1e-6)/5.48, nnz(SolveBP_HOC_HDR_xdiff(SolveBP_HOC_HDR_xdiff>1e-6)<=1e-1)/2.74, nnz(SolveBP_HOC_LDR_xdiff(SolveBP_HOC_LDR_xdiff>1e-6)<=1e-1)/2.74, nnz(SolveBP_HOC_xdiff(SolveBP_HOC_xdiff>1e-6)<=1e-1)/5.48, nnz(SolveBP_HOC_HDR_xdiff>1e-1)/2.74, nnz(SolveBP_HOC_LDR_xdiff>1e-1)/2.74, nnz(SolveBP_HOC_xdiff>1e-1)/5.48);
    fprintf(fid,'$\\ell_1$-Magic & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$\\\\\n',...
	nnz(l1MAGIC_HDR_xdiff<=1e-6)/2.74, nnz(l1MAGIC_LDR_xdiff<=1e-6)/2.74, nnz(l1MAGIC_xdiff<=1e-6)/5.48, nnz(l1MAGIC_HDR_xdiff(l1MAGIC_HDR_xdiff>1e-6)<=1e-1)/2.74, nnz(l1MAGIC_LDR_xdiff(l1MAGIC_LDR_xdiff>1e-6)<=1e-1)/2.74, nnz(l1MAGIC_xdiff(l1MAGIC_xdiff>1e-6)<=1e-1)/5.48, nnz(l1MAGIC_HDR_xdiff>1e-1)/2.74, nnz(l1MAGIC_LDR_xdiff>1e-1)/2.74, nnz(l1MAGIC_xdiff>1e-1)/5.48);
    fprintf(fid,'$\\ell_1$-Magic (HOC) & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$ & $%2.1f$\\\\\n',...
	nnz(l1MAGIC_HOC_HDR_xdiff<=1e-6)/2.74, nnz(l1MAGIC_HOC_LDR_xdiff<=1e-6)/2.74, nnz(l1MAGIC_HOC_xdiff<=1e-6)/5.48, nnz(l1MAGIC_HOC_HDR_xdiff(l1MAGIC_HOC_HDR_xdiff>1e-6)<=1e-1)/2.74, nnz(l1MAGIC_HOC_LDR_xdiff(l1MAGIC_HOC_LDR_xdiff>1e-6)<=1e-1)/2.74, nnz(l1MAGIC_HOC_xdiff(l1MAGIC_HOC_xdiff>1e-6)<=1e-1)/5.48, nnz(l1MAGIC_HOC_HDR_xdiff>1e-1)/2.74, nnz(l1MAGIC_HOC_LDR_xdiff>1e-1)/2.74, nnz(l1MAGIC_HOC_xdiff>1e-1)/5.48);
    fprintf(fid,'\\bottomrule\n\\end{tabular*}\n');
    fclose(fid);
    filename = 'HDRandLDR_table_algo_successes_absolute.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\begin{tabular*}{\\textwidth}{@{\\extracolsep{\\fill}}l@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{}}\\toprule\n');
    fprintf(fid,' & \\multicolumn{3}{c}{\\%% solved} & \\multicolumn{3}{c}{\\%% acceptable} & \\multicolumn{3}{c}{\\%% unacceptable}\\\\\n');
    fprintf(fid,'Solver & HDR & LDR & all & HDR & LDR & all & HDR & LDR & all\\\\\n\\midrule\n');
    fprintf(fid,'ISAL1 & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$\\\\\n',...
	nnz(ISAL1_noHOC_HDR_xdiff<=1e-6), nnz(ISAL1_noHOC_LDR_xdiff<=1e-6), nnz(ISAL1_noHOC_xdiff<=1e-6), nnz(ISAL1_noHOC_HDR_xdiff(ISAL1_noHOC_HDR_xdiff>1e-6)<=1e-1), nnz(ISAL1_noHOC_LDR_xdiff(ISAL1_noHOC_LDR_xdiff>1e-6)<=1e-1), nnz(ISAL1_noHOC_xdiff(ISAL1_noHOC_xdiff>1e-6)<=1e-1), nnz(ISAL1_noHOC_HDR_xdiff>1e-1), nnz(ISAL1_noHOC_LDR_xdiff>1e-1), nnz(ISAL1_noHOC_xdiff>1e-1));
    fprintf(fid,'ISAL1 (HOC) & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$\\\\\n',...
	nnz(ISAL1_HDR_xdiff<=1e-6), nnz(ISAL1_LDR_xdiff<=1e-6), nnz(ISAL1_xdiff<=1e-6), nnz(ISAL1_HDR_xdiff(ISAL1_HDR_xdiff>1e-6)<=1e-1), nnz(ISAL1_LDR_xdiff(ISAL1_LDR_xdiff>1e-6)<=1e-1), nnz(ISAL1_xdiff(ISAL1_xdiff>1e-6)<=1e-1), nnz(ISAL1_HDR_xdiff>1e-1), nnz(ISAL1_LDR_xdiff>1e-1), nnz(ISAL1_xdiff>1e-1));
    fprintf(fid,'SPGL1 & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$\\\\\n',...
	nnz(SPGL1_HDR_xdiff<=1e-6), nnz(SPGL1_LDR_xdiff<=1e-6), nnz(SPGL1_xdiff<=1e-6), nnz(SPGL1_HDR_xdiff(SPGL1_HDR_xdiff>1e-6)<=1e-1), nnz(SPGL1_LDR_xdiff(SPGL1_LDR_xdiff>1e-6)<=1e-1), nnz(SPGL1_xdiff(SPGL1_xdiff>1e-6)<=1e-1), nnz(SPGL1_HDR_xdiff>1e-1), nnz(SPGL1_LDR_xdiff>1e-1), nnz(SPGL1_xdiff>1e-1));
    fprintf(fid,'SPGL1 (HOC) & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$\\\\\n',...
	nnz(SPGL1_HOC_HDR_xdiff<=1e-6), nnz(SPGL1_HOC_LDR_xdiff<=1e-6), nnz(SPGL1_HOC_xdiff<=1e-6), nnz(SPGL1_HOC_HDR_xdiff(SPGL1_HOC_HDR_xdiff>1e-6)<=1e-1), nnz(SPGL1_HOC_LDR_xdiff(SPGL1_HOC_LDR_xdiff>1e-6)<=1e-1), nnz(SPGL1_HOC_xdiff(SPGL1_HOC_xdiff>1e-6)<=1e-1), nnz(SPGL1_HOC_HDR_xdiff>1e-1), nnz(SPGL1_HOC_LDR_xdiff>1e-1), nnz(SPGL1_HOC_xdiff>1e-1));
    fprintf(fid,'YALL1 & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$\\\\\n',...
	nnz(YALL1_HDR_xdiff<=1e-6), nnz(YALL1_LDR_xdiff<=1e-6), nnz(YALL1_xdiff<=1e-6), nnz(YALL1_HDR_xdiff(YALL1_HDR_xdiff>1e-6)<=1e-1), nnz(YALL1_LDR_xdiff(YALL1_LDR_xdiff>1e-6)<=1e-1), nnz(YALL1_xdiff(YALL1_xdiff>1e-6)<=1e-1), nnz(YALL1_HDR_xdiff>1e-1), nnz(YALL1_LDR_xdiff>1e-1), nnz(YALL1_xdiff>1e-1));
    fprintf(fid,'YALL1 (HOC) & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$\\\\\n',...
	nnz(YALL1_HOC_HDR_xdiff<=1e-6), nnz(YALL1_HOC_LDR_xdiff<=1e-6), nnz(YALL1_HOC_xdiff<=1e-6), nnz(YALL1_HOC_HDR_xdiff(YALL1_HOC_HDR_xdiff>1e-6)<=1e-1), nnz(YALL1_HOC_LDR_xdiff(YALL1_HOC_LDR_xdiff>1e-6)<=1e-1), nnz(YALL1_HOC_xdiff(YALL1_HOC_xdiff>1e-6)<=1e-1), nnz(YALL1_HOC_HDR_xdiff>1e-1), nnz(YALL1_HOC_LDR_xdiff>1e-1), nnz(YALL1_HOC_xdiff>1e-1));
    fprintf(fid,'$\\ell_1$-Hom.  & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$\\\\\n',...
	nnz(Homotopy_HDR_xdiff<=1e-6), nnz(Homotopy_LDR_xdiff<=1e-6), nnz(Homotopy_xdiff<=1e-6), nnz(Homotopy_HDR_xdiff(Homotopy_HDR_xdiff>1e-6)<=1e-1), nnz(Homotopy_LDR_xdiff(Homotopy_LDR_xdiff>1e-6)<=1e-1), nnz(Homotopy_xdiff(Homotopy_xdiff>1e-6)<=1e-1), nnz(Homotopy_HDR_xdiff>1e-1), nnz(Homotopy_LDR_xdiff>1e-1), nnz(Homotopy_xdiff>1e-1));
    fprintf(fid,'$\\ell_1$-Hom. (HOC) & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$\\\\\n',...
	nnz(Homotopy_HOC_HDR_xdiff<=1e-6), nnz(Homotopy_HOC_LDR_xdiff<=1e-6), nnz(Homotopy_HOC_xdiff<=1e-6), nnz(Homotopy_HOC_HDR_xdiff(Homotopy_HOC_HDR_xdiff>1e-6)<=1e-1), nnz(Homotopy_HOC_LDR_xdiff(Homotopy_HOC_LDR_xdiff>1e-6)<=1e-1), nnz(Homotopy_HOC_xdiff(Homotopy_HOC_xdiff>1e-6)<=1e-1), nnz(Homotopy_HOC_HDR_xdiff>1e-1), nnz(Homotopy_HOC_LDR_xdiff>1e-1), nnz(Homotopy_HOC_xdiff>1e-1));
    fprintf(fid,'SolveBP & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$\\\\\n',...
	nnz(SolveBP_HDR_xdiff<=1e-6), nnz(SolveBP_LDR_xdiff<=1e-6), nnz(SolveBP_xdiff<=1e-6), nnz(SolveBP_HDR_xdiff(SolveBP_HDR_xdiff>1e-6)<=1e-1), nnz(SolveBP_LDR_xdiff(SolveBP_LDR_xdiff>1e-6)<=1e-1), nnz(SolveBP_xdiff(SolveBP_xdiff>1e-6)<=1e-1), nnz(SolveBP_HDR_xdiff>1e-1), nnz(SolveBP_LDR_xdiff>1e-1), nnz(SolveBP_xdiff>1e-1));
    fprintf(fid,'SolveBP (HOC) & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$\\\\\n',...
	nnz(SolveBP_HOC_HDR_xdiff<=1e-6), nnz(SolveBP_HOC_LDR_xdiff<=1e-6), nnz(SolveBP_HOC_xdiff<=1e-6), nnz(SolveBP_HOC_HDR_xdiff(SolveBP_HOC_HDR_xdiff>1e-6)<=1e-1), nnz(SolveBP_HOC_LDR_xdiff(SolveBP_HOC_LDR_xdiff>1e-6)<=1e-1), nnz(SolveBP_HOC_xdiff(SolveBP_HOC_xdiff>1e-6)<=1e-1), nnz(SolveBP_HOC_HDR_xdiff>1e-1), nnz(SolveBP_HOC_LDR_xdiff>1e-1), nnz(SolveBP_HOC_xdiff>1e-1));
    fprintf(fid,'$\\ell_1$-Magic & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$\\\\\n',...
	nnz(l1MAGIC_HDR_xdiff<=1e-6), nnz(l1MAGIC_LDR_xdiff<=1e-6), nnz(l1MAGIC_xdiff<=1e-6), nnz(l1MAGIC_HDR_xdiff(l1MAGIC_HDR_xdiff>1e-6)<=1e-1), nnz(l1MAGIC_LDR_xdiff(l1MAGIC_LDR_xdiff>1e-6)<=1e-1), nnz(l1MAGIC_xdiff(l1MAGIC_xdiff>1e-6)<=1e-1), nnz(l1MAGIC_HDR_xdiff>1e-1), nnz(l1MAGIC_LDR_xdiff>1e-1), nnz(l1MAGIC_xdiff>1e-1));
    fprintf(fid,'$\\ell_1$-Magic (HOC) & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$ & $%3d$\\\\\n',...
	nnz(l1MAGIC_HOC_HDR_xdiff<=1e-6), nnz(l1MAGIC_HOC_LDR_xdiff<=1e-6), nnz(l1MAGIC_HOC_xdiff<=1e-6), nnz(l1MAGIC_HOC_HDR_xdiff(l1MAGIC_HOC_HDR_xdiff>1e-6)<=1e-1), nnz(l1MAGIC_HOC_LDR_xdiff(l1MAGIC_HOC_LDR_xdiff>1e-6)<=1e-1), nnz(l1MAGIC_HOC_xdiff(l1MAGIC_HOC_xdiff>1e-6)<=1e-1), nnz(l1MAGIC_HOC_HDR_xdiff>1e-1), nnz(l1MAGIC_HOC_LDR_xdiff>1e-1), nnz(l1MAGIC_HOC_xdiff>1e-1));
    fprintf(fid,'\\bottomrule\n\\end{tabular*}\n');
    fclose(fid);

          
    % Create tables with details about solution accuracies:
    % HDR:
    filename = 'HDR_table_accuracy_histogram.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\begin{longtable}{@{}r@{\\qquad}c@{\\qquad}c@{\\qquad}c@{\\qquad}c@{\\qquad}c@{\\qquad}}\\toprule\\\\\n');
    fprintf(fid,'Solver & $\\|\\bar x - x^*\\|>10^{-1}$ & $10^{-4}<\\|\\bar x - x^*\\|\\leq 10^{-1}$ & $10^{-6}<\\|\\bar x - x^*\\|\\leq 10^{-4}$ & $10^{-9}<\\|\\bar x - x^*\\|\\leq 10^{-6}$ & $\\|\\bar x - x^*\\|< 10^{-9}$ \\\\\n\\midrule\n');
    
    fprintf(fid,'ISAL1 w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(ISAL1_noHOC_HDR_xdiff>1e-1)/2.74,nnz(ISAL1_noHOC_HDR_xdiff(ISAL1_noHOC_HDR_xdiff<=1e-1)>1e-4)/2.74,nnz(ISAL1_noHOC_HDR_xdiff(ISAL1_noHOC_HDR_xdiff<=1e-4)>1e-6)/2.74,nnz(ISAL1_noHOC_HDR_xdiff(ISAL1_noHOC_HDR_xdiff<=1e-6)>1e-9)/2.74,nnz(ISAL1_noHOC_HDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(ISAL1_noHOC_HDR_xdiff>1e-1)/2.74,nnz(ISAL1_noHOC_HDR_xdiff<=1e-1)/2.74,nnz(ISAL1_noHOC_HDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'ISAL1 w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(ISAL1_HDR_xdiff>1e-1)/2.74,nnz(ISAL1_HDR_xdiff(ISAL1_HDR_xdiff<=1e-1)>1e-4)/2.74,nnz(ISAL1_HDR_xdiff(ISAL1_HDR_xdiff<=1e-4)>1e-6)/2.74,nnz(ISAL1_HDR_xdiff(ISAL1_HDR_xdiff<=1e-6)>1e-9)/2.74,nnz(ISAL1_HDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(ISAL1_HDR_xdiff>1e-1)/2.74,nnz(ISAL1_HDR_xdiff<=1e-1)/2.74,nnz(ISAL1_HDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'SPGL1 w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(SPGL1_HDR_xdiff>1e-1)/2.74,nnz(SPGL1_HDR_xdiff(SPGL1_HDR_xdiff<=1e-1)>1e-4)/2.74,nnz(SPGL1_HDR_xdiff(SPGL1_HDR_xdiff<=1e-4)>1e-6)/2.74,nnz(SPGL1_HDR_xdiff(SPGL1_HDR_xdiff<=1e-6)>1e-9)/2.74,nnz(SPGL1_HDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(SPGL1_HDR_xdiff>1e-1)/2.74,nnz(SPGL1_HDR_xdiff<=1e-1)/2.74,nnz(SPGL1_HDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'SPGL1 w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(SPGL1_HOC_HDR_xdiff>1e-1)/2.74,nnz(SPGL1_HOC_HDR_xdiff(SPGL1_HOC_HDR_xdiff<=1e-1)>1e-4)/2.74,nnz(SPGL1_HOC_HDR_xdiff(SPGL1_HOC_HDR_xdiff<=1e-4)>1e-6)/2.74,nnz(SPGL1_HOC_HDR_xdiff(SPGL1_HOC_HDR_xdiff<=1e-6)>1e-9)/2.74,nnz(SPGL1_HOC_HDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(SPGL1_HOC_HDR_xdiff>1e-1)/2.74,nnz(SPGL1_HOC_HDR_xdiff<=1e-1)/2.74,nnz(SPGL1_HOC_HDR_xdiff<=1e-6)/2.74);
        
    fprintf(fid,'YALL1 w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(YALL1_HDR_xdiff>1e-1)/2.74,nnz(YALL1_HDR_xdiff(YALL1_HDR_xdiff<=1e-1)>1e-4)/2.74,nnz(YALL1_HDR_xdiff(YALL1_HDR_xdiff<=1e-4)>1e-6)/2.74,nnz(YALL1_HDR_xdiff(YALL1_HDR_xdiff<=1e-6)>1e-9)/2.74,nnz(YALL1_HDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(YALL1_HDR_xdiff>1e-1)/2.74,nnz(YALL1_HDR_xdiff<=1e-1)/2.74,nnz(YALL1_HDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'YALL1 w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(YALL1_HOC_HDR_xdiff>1e-1)/2.74,nnz(YALL1_HOC_HDR_xdiff(YALL1_HOC_HDR_xdiff<=1e-1)>1e-4)/2.74,nnz(YALL1_HOC_HDR_xdiff(YALL1_HOC_HDR_xdiff<=1e-4)>1e-6)/2.74,nnz(YALL1_HOC_HDR_xdiff(YALL1_HOC_HDR_xdiff<=1e-6)>1e-9)/2.74,nnz(YALL1_HOC_HDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(YALL1_HOC_HDR_xdiff>1e-1)/2.74,nnz(YALL1_HOC_HDR_xdiff<=1e-1)/2.74,nnz(YALL1_HOC_HDR_xdiff<=1e-6)/2.74);
        
    fprintf(fid,'$\\ell_1$-Magic w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(l1MAGIC_HDR_xdiff>1e-1)/2.74,nnz(l1MAGIC_HDR_xdiff(l1MAGIC_HDR_xdiff<=1e-1)>1e-4)/2.74,nnz(l1MAGIC_HDR_xdiff(l1MAGIC_HDR_xdiff<=1e-4)>1e-6)/2.74,nnz(l1MAGIC_HDR_xdiff(l1MAGIC_HDR_xdiff<=1e-6)>1e-9)/2.74,nnz(l1MAGIC_HDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(l1MAGIC_HDR_xdiff>1e-1)/2.74,nnz(l1MAGIC_HDR_xdiff<=1e-1)/2.74,nnz(l1MAGIC_HDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'$\\ell_1$-Magic w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(l1MAGIC_HOC_HDR_xdiff>1e-1)/2.74,nnz(l1MAGIC_HOC_HDR_xdiff(l1MAGIC_HOC_HDR_xdiff<=1e-1)>1e-4)/2.74,nnz(l1MAGIC_HOC_HDR_xdiff(l1MAGIC_HOC_HDR_xdiff<=1e-4)>1e-6)/2.74,nnz(l1MAGIC_HOC_HDR_xdiff(l1MAGIC_HOC_HDR_xdiff<=1e-6)>1e-9)/2.74,nnz(l1MAGIC_HOC_HDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(l1MAGIC_HOC_HDR_xdiff>1e-1)/2.74,nnz(l1MAGIC_HOC_HDR_xdiff<=1e-1)/2.74,nnz(l1MAGIC_HOC_HDR_xdiff<=1e-6)/2.74);
            
    fprintf(fid,'SparseLab/PDCO w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(SolveBP_HDR_xdiff>1e-1)/2.74,nnz(SolveBP_HDR_xdiff(SolveBP_HDR_xdiff<=1e-1)>1e-4)/2.74,nnz(SolveBP_HDR_xdiff(SolveBP_HDR_xdiff<=1e-4)>1e-6)/2.74,nnz(SolveBP_HDR_xdiff(SolveBP_HDR_xdiff<=1e-6)>1e-9)/2.74,nnz(SolveBP_HDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(SolveBP_HDR_xdiff>1e-1)/2.74,nnz(SolveBP_HDR_xdiff<=1e-1)/2.74,nnz(SolveBP_HDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'SparseLab/PDCO w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(SolveBP_HOC_HDR_xdiff>1e-1)/2.74,nnz(SolveBP_HOC_HDR_xdiff(SolveBP_HOC_HDR_xdiff<=1e-1)>1e-4)/2.74,nnz(SolveBP_HOC_HDR_xdiff(SolveBP_HOC_HDR_xdiff<=1e-4)>1e-6)/2.74,nnz(SolveBP_HOC_HDR_xdiff(SolveBP_HOC_HDR_xdiff<=1e-6)>1e-9)/2.74,nnz(SolveBP_HOC_HDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(SolveBP_HOC_HDR_xdiff>1e-1)/2.74,nnz(SolveBP_HOC_HDR_xdiff<=1e-1)/2.74,nnz(SolveBP_HOC_HDR_xdiff<=1e-6)/2.74);
            
    fprintf(fid,'$\\ell_1$-Homotopy w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(Homotopy_HDR_xdiff>1e-1)/2.74,nnz(Homotopy_HDR_xdiff(Homotopy_HDR_xdiff<=1e-1)>1e-4)/2.74,nnz(Homotopy_HDR_xdiff(Homotopy_HDR_xdiff<=1e-4)>1e-6)/2.74,nnz(Homotopy_HDR_xdiff(Homotopy_HDR_xdiff<=1e-6)>1e-9)/2.74,nnz(Homotopy_HDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(Homotopy_HDR_xdiff>1e-1)/2.74,nnz(Homotopy_HDR_xdiff<=1e-1)/2.74,nnz(Homotopy_HDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'$\\ell_1$-Homotopy w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(Homotopy_HOC_HDR_xdiff>1e-1)/2.74,nnz(Homotopy_HOC_HDR_xdiff(Homotopy_HOC_HDR_xdiff<=1e-1)>1e-4)/2.74,nnz(Homotopy_HOC_HDR_xdiff(Homotopy_HOC_HDR_xdiff<=1e-4)>1e-6)/2.74,nnz(Homotopy_HOC_HDR_xdiff(Homotopy_HOC_HDR_xdiff<=1e-6)>1e-9)/2.74,nnz(Homotopy_HOC_HDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(Homotopy_HOC_HDR_xdiff>1e-1)/2.74,nnz(Homotopy_HOC_HDR_xdiff<=1e-1)/2.74,nnz(Homotopy_HOC_HDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'$\\ell_1$-Homotopy w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(Homotopy_1em9_HDR_xdiff>1e-1)/2.74,nnz(Homotopy_1em9_HDR_xdiff(Homotopy_1em9_HDR_xdiff<=1e-1)>1e-4)/2.74,nnz(Homotopy_1em9_HDR_xdiff(Homotopy_1em9_HDR_xdiff<=1e-4)>1e-6)/2.74,nnz(Homotopy_1em9_HDR_xdiff(Homotopy_1em9_HDR_xdiff<=1e-6)>1e-9)/2.74,nnz(Homotopy_1em9_HDR_xdiff<=1e-9)/2.74);
    fprintf(fid,'($\\lambda=10^{-9}$) & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(Homotopy_1em9_HDR_xdiff>1e-1)/2.74,nnz(Homotopy_1em9_HDR_xdiff<=1e-1)/2.74,nnz(Homotopy_1em9_HDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'$\\ell_1$-Homotopy w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(Homotopy_HOC_1em9_HDR_xdiff>1e-1)/2.74,nnz(Homotopy_HOC_1em9_HDR_xdiff(Homotopy_HOC_1em9_HDR_xdiff<=1e-1)>1e-4)/2.74,nnz(Homotopy_HOC_1em9_HDR_xdiff(Homotopy_HOC_1em9_HDR_xdiff<=1e-4)>1e-6)/2.74,nnz(Homotopy_HOC_1em9_HDR_xdiff(Homotopy_HOC_1em9_HDR_xdiff<=1e-6)>1e-9)/2.74,nnz(Homotopy_HOC_1em9_HDR_xdiff<=1e-9)/2.74);
    fprintf(fid,'($\\lambda=10^{-9}$) & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(Homotopy_HOC_1em9_HDR_xdiff>1e-1)/2.74,nnz(Homotopy_HOC_1em9_HDR_xdiff<=1e-1)/2.74,nnz(Homotopy_HOC_1em9_HDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'CPLEX (w/o HOC) & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(L1LP_CPX_HDR_xdiff>1e-1)/2.74,nnz(L1LP_CPX_HDR_xdiff(L1LP_CPX_HDR_xdiff<=1e-1)>1e-4)/2.74,nnz(L1LP_CPX_HDR_xdiff(L1LP_CPX_HDR_xdiff<=1e-4)>1e-6)/2.74,nnz(L1LP_CPX_HDR_xdiff(L1LP_CPX_HDR_xdiff<=1e-6)>1e-9)/2.74,nnz(L1LP_CPX_HDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(L1LP_CPX_HDR_xdiff>1e-1)/2.74,nnz(L1LP_CPX_HDR_xdiff<=1e-1)/2.74,nnz(L1LP_CPX_HDR_xdiff<=1e-6)/2.74);
      
    fprintf(fid,'SoPlex (w/o HOC) & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(L1LP_SPX_HDR_xdiff>1e-1)/2.74,nnz(L1LP_SPX_HDR_xdiff(L1LP_SPX_HDR_xdiff<=1e-1)>1e-4)/2.74,nnz(L1LP_SPX_HDR_xdiff(L1LP_SPX_HDR_xdiff<=1e-4)>1e-6)/2.74,nnz(L1LP_SPX_HDR_xdiff(L1LP_SPX_HDR_xdiff<=1e-6)>1e-9)/2.74,nnz(L1LP_SPX_HDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(L1LP_SPX_HDR_xdiff>1e-1)/2.74,nnz(L1LP_SPX_HDR_xdiff<=1e-1)/2.74,nnz(L1LP_SPX_HDR_xdiff<=1e-6)/2.74);
        
    fprintf(fid,'\\bottomrule\n\\end{longtable}\n');
    fclose(fid);
    
    % LDR:
    filename = 'LDR_table_accuracy_histogram.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\begin{longtable}{@{}r@{\\qquad}c@{\\qquad}c@{\\qquad}c@{\\qquad}c@{\\qquad}c@{\\qquad}}\\toprule\\\\\n');
    fprintf(fid,'Solver & $\\|\\bar x - x^*\\|>10^{-1}$ & $10^{-4}<\\|\\bar x - x^*\\|\\leq 10^{-1}$ & $10^{-6}<\\|\\bar x - x^*\\|\\leq 10^{-4}$ & $10^{-9}<\\|\\bar x - x^*\\|\\leq 10^{-6}$ & $\\|\\bar x - x^*\\|< 10^{-9}$ \\\\\n\\midrule\n');
    
    fprintf(fid,'ISAL1 w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(ISAL1_noHOC_LDR_xdiff>1e-1)/2.74,nnz(ISAL1_noHOC_LDR_xdiff(ISAL1_noHOC_LDR_xdiff<=1e-1)>1e-4)/2.74,nnz(ISAL1_noHOC_LDR_xdiff(ISAL1_noHOC_LDR_xdiff<=1e-4)>1e-6)/2.74,nnz(ISAL1_noHOC_LDR_xdiff(ISAL1_noHOC_LDR_xdiff<=1e-6)>1e-9)/2.74,nnz(ISAL1_noHOC_LDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(ISAL1_noHOC_LDR_xdiff>1e-1)/2.74,nnz(ISAL1_noHOC_LDR_xdiff<=1e-1)/2.74,nnz(ISAL1_noHOC_LDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'ISAL1 w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(ISAL1_LDR_xdiff>1e-1)/2.74,nnz(ISAL1_LDR_xdiff(ISAL1_LDR_xdiff<=1e-1)>1e-4)/2.74,nnz(ISAL1_LDR_xdiff(ISAL1_LDR_xdiff<=1e-4)>1e-6)/2.74,nnz(ISAL1_LDR_xdiff(ISAL1_LDR_xdiff<=1e-6)>1e-9)/2.74,nnz(ISAL1_LDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(ISAL1_LDR_xdiff>1e-1)/2.74,nnz(ISAL1_LDR_xdiff<=1e-1)/2.74,nnz(ISAL1_LDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'SPGL1 w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(SPGL1_LDR_xdiff>1e-1)/2.74,nnz(SPGL1_LDR_xdiff(SPGL1_LDR_xdiff<=1e-1)>1e-4)/2.74,nnz(SPGL1_LDR_xdiff(SPGL1_LDR_xdiff<=1e-4)>1e-6)/2.74,nnz(SPGL1_LDR_xdiff(SPGL1_LDR_xdiff<=1e-6)>1e-9)/2.74,nnz(SPGL1_LDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(SPGL1_LDR_xdiff>1e-1)/2.74,nnz(SPGL1_LDR_xdiff<=1e-1)/2.74,nnz(SPGL1_LDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'SPGL1 w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(SPGL1_HOC_LDR_xdiff>1e-1)/2.74,nnz(SPGL1_HOC_LDR_xdiff(SPGL1_HOC_LDR_xdiff<=1e-1)>1e-4)/2.74,nnz(SPGL1_HOC_LDR_xdiff(SPGL1_HOC_LDR_xdiff<=1e-4)>1e-6)/2.74,nnz(SPGL1_HOC_LDR_xdiff(SPGL1_HOC_LDR_xdiff<=1e-6)>1e-9)/2.74,nnz(SPGL1_HOC_LDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(SPGL1_HOC_LDR_xdiff>1e-1)/2.74,nnz(SPGL1_HOC_LDR_xdiff<=1e-1)/2.74,nnz(SPGL1_HOC_LDR_xdiff<=1e-6)/2.74);
        
    fprintf(fid,'YALL1 w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(YALL1_LDR_xdiff>1e-1)/2.74,nnz(YALL1_LDR_xdiff(YALL1_LDR_xdiff<=1e-1)>1e-4)/2.74,nnz(YALL1_LDR_xdiff(YALL1_LDR_xdiff<=1e-4)>1e-6)/2.74,nnz(YALL1_LDR_xdiff(YALL1_LDR_xdiff<=1e-6)>1e-9)/2.74,nnz(YALL1_LDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(YALL1_LDR_xdiff>1e-1)/2.74,nnz(YALL1_LDR_xdiff<=1e-1)/2.74,nnz(YALL1_LDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'YALL1 w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(YALL1_HOC_LDR_xdiff>1e-1)/2.74,nnz(YALL1_HOC_LDR_xdiff(YALL1_HOC_LDR_xdiff<=1e-1)>1e-4)/2.74,nnz(YALL1_HOC_LDR_xdiff(YALL1_HOC_LDR_xdiff<=1e-4)>1e-6)/2.74,nnz(YALL1_HOC_LDR_xdiff(YALL1_HOC_LDR_xdiff<=1e-6)>1e-9)/2.74,nnz(YALL1_HOC_LDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(YALL1_HOC_LDR_xdiff>1e-1)/2.74,nnz(YALL1_HOC_LDR_xdiff<=1e-1)/2.74,nnz(YALL1_HOC_LDR_xdiff<=1e-6)/2.74);
        
    fprintf(fid,'$\\ell_1$-Magic w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(l1MAGIC_LDR_xdiff>1e-1)/2.74,nnz(l1MAGIC_LDR_xdiff(l1MAGIC_LDR_xdiff<=1e-1)>1e-4)/2.74,nnz(l1MAGIC_LDR_xdiff(l1MAGIC_LDR_xdiff<=1e-4)>1e-6)/2.74,nnz(l1MAGIC_LDR_xdiff(l1MAGIC_LDR_xdiff<=1e-6)>1e-9)/2.74,nnz(l1MAGIC_LDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(l1MAGIC_LDR_xdiff>1e-1)/2.74,nnz(l1MAGIC_LDR_xdiff<=1e-1)/2.74,nnz(l1MAGIC_LDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'$\\ell_1$-Magic w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(l1MAGIC_HOC_LDR_xdiff>1e-1)/2.74,nnz(l1MAGIC_HOC_LDR_xdiff(l1MAGIC_HOC_LDR_xdiff<=1e-1)>1e-4)/2.74,nnz(l1MAGIC_HOC_LDR_xdiff(l1MAGIC_HOC_LDR_xdiff<=1e-4)>1e-6)/2.74,nnz(l1MAGIC_HOC_LDR_xdiff(l1MAGIC_HOC_LDR_xdiff<=1e-6)>1e-9)/2.74,nnz(l1MAGIC_HOC_LDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(l1MAGIC_HOC_LDR_xdiff>1e-1)/2.74,nnz(l1MAGIC_HOC_LDR_xdiff<=1e-1)/2.74,nnz(l1MAGIC_HOC_LDR_xdiff<=1e-6)/2.74);
            
    fprintf(fid,'SparseLab/PDCO w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(SolveBP_LDR_xdiff>1e-1)/2.74,nnz(SolveBP_LDR_xdiff(SolveBP_LDR_xdiff<=1e-1)>1e-4)/2.74,nnz(SolveBP_LDR_xdiff(SolveBP_LDR_xdiff<=1e-4)>1e-6)/2.74,nnz(SolveBP_LDR_xdiff(SolveBP_LDR_xdiff<=1e-6)>1e-9)/2.74,nnz(SolveBP_LDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(SolveBP_LDR_xdiff>1e-1)/2.74,nnz(SolveBP_LDR_xdiff<=1e-1)/2.74,nnz(SolveBP_LDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'SparseLab/PDCO w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(SolveBP_HOC_LDR_xdiff>1e-1)/2.74,nnz(SolveBP_HOC_LDR_xdiff(SolveBP_HOC_LDR_xdiff<=1e-1)>1e-4)/2.74,nnz(SolveBP_HOC_LDR_xdiff(SolveBP_HOC_LDR_xdiff<=1e-4)>1e-6)/2.74,nnz(SolveBP_HOC_LDR_xdiff(SolveBP_HOC_LDR_xdiff<=1e-6)>1e-9)/2.74,nnz(SolveBP_HOC_LDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(SolveBP_HOC_LDR_xdiff>1e-1)/2.74,nnz(SolveBP_HOC_LDR_xdiff<=1e-1)/2.74,nnz(SolveBP_HOC_LDR_xdiff<=1e-6)/2.74);
            
    fprintf(fid,'$\\ell_1$-Homotopy w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(Homotopy_LDR_xdiff>1e-1)/2.74,nnz(Homotopy_LDR_xdiff(Homotopy_LDR_xdiff<=1e-1)>1e-4)/2.74,nnz(Homotopy_LDR_xdiff(Homotopy_LDR_xdiff<=1e-4)>1e-6)/2.74,nnz(Homotopy_LDR_xdiff(Homotopy_LDR_xdiff<=1e-6)>1e-9)/2.74,nnz(Homotopy_LDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(Homotopy_LDR_xdiff>1e-1)/2.74,nnz(Homotopy_LDR_xdiff<=1e-1)/2.74,nnz(Homotopy_LDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'$\\ell_1$-Homotopy w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(Homotopy_HOC_LDR_xdiff>1e-1)/2.74,nnz(Homotopy_HOC_LDR_xdiff(Homotopy_HOC_LDR_xdiff<=1e-1)>1e-4)/2.74,nnz(Homotopy_HOC_LDR_xdiff(Homotopy_HOC_LDR_xdiff<=1e-4)>1e-6)/2.74,nnz(Homotopy_HOC_LDR_xdiff(Homotopy_HOC_LDR_xdiff<=1e-6)>1e-9)/2.74,nnz(Homotopy_HOC_LDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(Homotopy_HOC_LDR_xdiff>1e-1)/2.74,nnz(Homotopy_HOC_LDR_xdiff<=1e-1)/2.74,nnz(Homotopy_HOC_LDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'$\\ell_1$-Homotopy w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(Homotopy_1em9_LDR_xdiff>1e-1)/2.74,nnz(Homotopy_1em9_LDR_xdiff(Homotopy_1em9_LDR_xdiff<=1e-1)>1e-4)/2.74,nnz(Homotopy_1em9_LDR_xdiff(Homotopy_1em9_LDR_xdiff<=1e-4)>1e-6)/2.74,nnz(Homotopy_1em9_LDR_xdiff(Homotopy_1em9_LDR_xdiff<=1e-6)>1e-9)/2.74,nnz(Homotopy_1em9_LDR_xdiff<=1e-9)/2.74);
    fprintf(fid,'($\\lambda=10^{-9}$) & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(Homotopy_1em9_LDR_xdiff>1e-1)/2.74,nnz(Homotopy_1em9_LDR_xdiff<=1e-1)/2.74,nnz(Homotopy_1em9_LDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'$\\ell_1$-Homotopy w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(Homotopy_HOC_1em9_LDR_xdiff>1e-1)/2.74,nnz(Homotopy_HOC_1em9_LDR_xdiff(Homotopy_HOC_1em9_LDR_xdiff<=1e-1)>1e-4)/2.74,nnz(Homotopy_HOC_1em9_LDR_xdiff(Homotopy_HOC_1em9_LDR_xdiff<=1e-4)>1e-6)/2.74,nnz(Homotopy_HOC_1em9_LDR_xdiff(Homotopy_HOC_1em9_LDR_xdiff<=1e-6)>1e-9)/2.74,nnz(Homotopy_HOC_1em9_LDR_xdiff<=1e-9)/2.74);
    fprintf(fid,'($\\lambda=10^{-9}$) & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(Homotopy_HOC_1em9_LDR_xdiff>1e-1)/2.74,nnz(Homotopy_HOC_1em9_LDR_xdiff<=1e-1)/2.74,nnz(Homotopy_HOC_1em9_LDR_xdiff<=1e-6)/2.74);
    
    fprintf(fid,'CPLEX (w/o HOC) & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(L1LP_CPX_LDR_xdiff>1e-1)/2.74,nnz(L1LP_CPX_LDR_xdiff(L1LP_CPX_LDR_xdiff<=1e-1)>1e-4)/2.74,nnz(L1LP_CPX_LDR_xdiff(L1LP_CPX_LDR_xdiff<=1e-4)>1e-6)/2.74,nnz(L1LP_CPX_LDR_xdiff(L1LP_CPX_LDR_xdiff<=1e-6)>1e-9)/2.74,nnz(L1LP_CPX_LDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(L1LP_CPX_LDR_xdiff>1e-1)/2.74,nnz(L1LP_CPX_LDR_xdiff<=1e-1)/2.74,nnz(L1LP_CPX_LDR_xdiff<=1e-6)/2.74);
      
    fprintf(fid,'SoPlex (w/o HOC) & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(L1LP_SPX_LDR_xdiff>1e-1)/2.74,nnz(L1LP_SPX_LDR_xdiff(L1LP_SPX_LDR_xdiff<=1e-1)>1e-4)/2.74,nnz(L1LP_SPX_LDR_xdiff(L1LP_SPX_LDR_xdiff<=1e-4)>1e-6)/2.74,nnz(L1LP_SPX_LDR_xdiff(L1LP_SPX_LDR_xdiff<=1e-6)>1e-9)/2.74,nnz(L1LP_SPX_LDR_xdiff<=1e-9)/2.74);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(L1LP_SPX_LDR_xdiff>1e-1)/2.74,nnz(L1LP_SPX_LDR_xdiff<=1e-1)/2.74,nnz(L1LP_SPX_LDR_xdiff<=1e-6)/2.74);
        
    fprintf(fid,'\\bottomrule\n\\end{longtable}\n');
    fclose(fid);
    
    % HDR and LDR:
    filename = 'HDRandLDR_table_accuracy_histogram.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\begin{longtable}{@{}r@{\\qquad}c@{\\qquad}c@{\\qquad}c@{\\qquad}c@{\\qquad}c@{\\qquad}}\\toprule\\\\\n');
    fprintf(fid,'Solver & $\\|\\bar x - x^*\\|>10^{-1}$ & $10^{-4}<\\|\\bar x - x^*\\|\\leq 10^{-1}$ & $10^{-6}<\\|\\bar x - x^*\\|\\leq 10^{-4}$ & $10^{-9}<\\|\\bar x - x^*\\|\\leq 10^{-6}$ & $\\|\\bar x - x^*\\|< 10^{-9}$ \\\\\n\\midrule\n');
    
    fprintf(fid,'ISAL1 w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(ISAL1_noHOC_xdiff>1e-1)/5.48,nnz(ISAL1_noHOC_xdiff(ISAL1_noHOC_xdiff<=1e-1)>1e-4)/5.48,nnz(ISAL1_noHOC_xdiff(ISAL1_noHOC_xdiff<=1e-4)>1e-6)/5.48,nnz(ISAL1_noHOC_xdiff(ISAL1_noHOC_xdiff<=1e-6)>1e-9)/5.48,nnz(ISAL1_noHOC_xdiff<=1e-9)/5.48);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(ISAL1_noHOC_xdiff>1e-1)/5.48,nnz(ISAL1_noHOC_xdiff<=1e-1)/5.48,nnz(ISAL1_noHOC_xdiff<=1e-6)/5.48);
    
    fprintf(fid,'ISAL1 w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(ISAL1_xdiff>1e-1)/5.48,nnz(ISAL1_xdiff(ISAL1_xdiff<=1e-1)>1e-4)/5.48,nnz(ISAL1_xdiff(ISAL1_xdiff<=1e-4)>1e-6)/5.48,nnz(ISAL1_xdiff(ISAL1_xdiff<=1e-6)>1e-9)/5.48,nnz(ISAL1_xdiff<=1e-9)/5.48);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(ISAL1_xdiff>1e-1)/5.48,nnz(ISAL1_xdiff<=1e-1)/5.48,nnz(ISAL1_xdiff<=1e-6)/5.48);
    
    fprintf(fid,'SPGL1 w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(SPGL1_xdiff>1e-1)/5.48,nnz(SPGL1_xdiff(SPGL1_xdiff<=1e-1)>1e-4)/5.48,nnz(SPGL1_xdiff(SPGL1_xdiff<=1e-4)>1e-6)/5.48,nnz(SPGL1_xdiff(SPGL1_xdiff<=1e-6)>1e-9)/5.48,nnz(SPGL1_xdiff<=1e-9)/5.48);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(SPGL1_xdiff>1e-1)/5.48,nnz(SPGL1_xdiff<=1e-1)/5.48,nnz(SPGL1_xdiff<=1e-6)/5.48);
    
    fprintf(fid,'SPGL1 w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(SPGL1_HOC_xdiff>1e-1)/5.48,nnz(SPGL1_HOC_xdiff(SPGL1_HOC_xdiff<=1e-1)>1e-4)/5.48,nnz(SPGL1_HOC_xdiff(SPGL1_HOC_xdiff<=1e-4)>1e-6)/5.48,nnz(SPGL1_HOC_xdiff(SPGL1_HOC_xdiff<=1e-6)>1e-9)/5.48,nnz(SPGL1_HOC_xdiff<=1e-9)/5.48);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(SPGL1_HOC_xdiff>1e-1)/5.48,nnz(SPGL1_HOC_xdiff<=1e-1)/5.48,nnz(SPGL1_HOC_xdiff<=1e-6)/5.48);
        
    fprintf(fid,'YALL1 w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(YALL1_xdiff>1e-1)/5.48,nnz(YALL1_xdiff(YALL1_xdiff<=1e-1)>1e-4)/5.48,nnz(YALL1_xdiff(YALL1_xdiff<=1e-4)>1e-6)/5.48,nnz(YALL1_xdiff(YALL1_xdiff<=1e-6)>1e-9)/5.48,nnz(YALL1_xdiff<=1e-9)/5.48);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(YALL1_xdiff>1e-1)/5.48,nnz(YALL1_xdiff<=1e-1)/5.48,nnz(YALL1_xdiff<=1e-6)/5.48);
    
    fprintf(fid,'YALL1 w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(YALL1_HOC_xdiff>1e-1)/5.48,nnz(YALL1_HOC_xdiff(YALL1_HOC_xdiff<=1e-1)>1e-4)/5.48,nnz(YALL1_HOC_xdiff(YALL1_HOC_xdiff<=1e-4)>1e-6)/5.48,nnz(YALL1_HOC_xdiff(YALL1_HOC_xdiff<=1e-6)>1e-9)/5.48,nnz(YALL1_HOC_xdiff<=1e-9)/5.48);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(YALL1_HOC_xdiff>1e-1)/5.48,nnz(YALL1_HOC_xdiff<=1e-1)/5.48,nnz(YALL1_HOC_xdiff<=1e-6)/5.48);
        
    fprintf(fid,'$\\ell_1$-Magic w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(l1MAGIC_xdiff>1e-1)/5.48,nnz(l1MAGIC_xdiff(l1MAGIC_xdiff<=1e-1)>1e-4)/5.48,nnz(l1MAGIC_xdiff(l1MAGIC_xdiff<=1e-4)>1e-6)/5.48,nnz(l1MAGIC_xdiff(l1MAGIC_xdiff<=1e-6)>1e-9)/5.48,nnz(l1MAGIC_xdiff<=1e-9)/5.48);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(l1MAGIC_xdiff>1e-1)/5.48,nnz(l1MAGIC_xdiff<=1e-1)/5.48,nnz(l1MAGIC_xdiff<=1e-6)/5.48);
    
    fprintf(fid,'$\\ell_1$-Magic w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(l1MAGIC_HOC_xdiff>1e-1)/5.48,nnz(l1MAGIC_HOC_xdiff(l1MAGIC_HOC_xdiff<=1e-1)>1e-4)/5.48,nnz(l1MAGIC_HOC_xdiff(l1MAGIC_HOC_xdiff<=1e-4)>1e-6)/5.48,nnz(l1MAGIC_HOC_xdiff(l1MAGIC_HOC_xdiff<=1e-6)>1e-9)/5.48,nnz(l1MAGIC_HOC_xdiff<=1e-9)/5.48);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(l1MAGIC_HOC_xdiff>1e-1)/5.48,nnz(l1MAGIC_HOC_xdiff<=1e-1)/5.48,nnz(l1MAGIC_HOC_xdiff<=1e-6)/5.48);
            
    fprintf(fid,'SparseLab/PDCO w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(SolveBP_xdiff>1e-1)/5.48,nnz(SolveBP_xdiff(SolveBP_xdiff<=1e-1)>1e-4)/5.48,nnz(SolveBP_xdiff(SolveBP_xdiff<=1e-4)>1e-6)/5.48,nnz(SolveBP_xdiff(SolveBP_xdiff<=1e-6)>1e-9)/5.48,nnz(SolveBP_xdiff<=1e-9)/5.48);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(SolveBP_xdiff>1e-1)/5.48,nnz(SolveBP_xdiff<=1e-1)/5.48,nnz(SolveBP_xdiff<=1e-6)/5.48);
    
    fprintf(fid,'SparseLab/PDCO w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(SolveBP_HOC_xdiff>1e-1)/5.48,nnz(SolveBP_HOC_xdiff(SolveBP_HOC_xdiff<=1e-1)>1e-4)/5.48,nnz(SolveBP_HOC_xdiff(SolveBP_HOC_xdiff<=1e-4)>1e-6)/5.48,nnz(SolveBP_HOC_xdiff(SolveBP_HOC_xdiff<=1e-6)>1e-9)/5.48,nnz(SolveBP_HOC_xdiff<=1e-9)/5.48);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(SolveBP_HOC_xdiff>1e-1)/5.48,nnz(SolveBP_HOC_xdiff<=1e-1)/5.48,nnz(SolveBP_HOC_xdiff<=1e-6)/5.48);
            
    fprintf(fid,'$\\ell_1$-Homotopy w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(Homotopy_xdiff>1e-1)/5.48,nnz(Homotopy_xdiff(Homotopy_xdiff<=1e-1)>1e-4)/5.48,nnz(Homotopy_xdiff(Homotopy_xdiff<=1e-4)>1e-6)/5.48,nnz(Homotopy_xdiff(Homotopy_xdiff<=1e-6)>1e-9)/5.48,nnz(Homotopy_xdiff<=1e-9)/5.48);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(Homotopy_xdiff>1e-1)/5.48,nnz(Homotopy_xdiff<=1e-1)/5.48,nnz(Homotopy_xdiff<=1e-6)/5.48);
    
    fprintf(fid,'$\\ell_1$-Homotopy w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(Homotopy_HOC_xdiff>1e-1)/5.48,nnz(Homotopy_HOC_xdiff(Homotopy_HOC_xdiff<=1e-1)>1e-4)/5.48,nnz(Homotopy_HOC_xdiff(Homotopy_HOC_xdiff<=1e-4)>1e-6)/5.48,nnz(Homotopy_HOC_xdiff(Homotopy_HOC_xdiff<=1e-6)>1e-9)/5.48,nnz(Homotopy_HOC_xdiff<=1e-9)/5.48);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(Homotopy_HOC_xdiff>1e-1)/5.48,nnz(Homotopy_HOC_xdiff<=1e-1)/5.48,nnz(Homotopy_HOC_xdiff<=1e-6)/5.48);
    
    fprintf(fid,'$\\ell_1$-Homotopy w/o HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(Homotopy_1em9_xdiff>1e-1)/5.48,nnz(Homotopy_1em9_xdiff(Homotopy_1em9_xdiff<=1e-1)>1e-4)/5.48,nnz(Homotopy_1em9_xdiff(Homotopy_1em9_xdiff<=1e-4)>1e-6)/5.48,nnz(Homotopy_1em9_xdiff(Homotopy_1em9_xdiff<=1e-6)>1e-9)/5.48,nnz(Homotopy_1em9_xdiff<=1e-9)/5.48);
    fprintf(fid,'($\\lambda=10^{-9}$) & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(Homotopy_1em9_xdiff>1e-1)/5.48,nnz(Homotopy_1em9_xdiff<=1e-1)/5.48,nnz(Homotopy_1em9_xdiff<=1e-6)/5.48);
    
    fprintf(fid,'$\\ell_1$-Homotopy w/ HOC & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(Homotopy_HOC_1em9_xdiff>1e-1)/5.48,nnz(Homotopy_HOC_1em9_xdiff(Homotopy_HOC_1em9_xdiff<=1e-1)>1e-4)/5.48,nnz(Homotopy_HOC_1em9_xdiff(Homotopy_HOC_1em9_xdiff<=1e-4)>1e-6)/5.48,nnz(Homotopy_HOC_1em9_xdiff(Homotopy_HOC_1em9_xdiff<=1e-6)>1e-9)/5.48,nnz(Homotopy_HOC_1em9_xdiff<=1e-9)/5.48);
    fprintf(fid,'($\\lambda=10^{-9}$) & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(Homotopy_HOC_1em9_xdiff>1e-1)/5.48,nnz(Homotopy_HOC_1em9_xdiff<=1e-1)/5.48,nnz(Homotopy_HOC_1em9_xdiff<=1e-6)/5.48);
    
    fprintf(fid,'CPLEX (w/o HOC) & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(L1LP_CPX_xdiff>1e-1)/5.48,nnz(L1LP_CPX_xdiff(L1LP_CPX_xdiff<=1e-1)>1e-4)/5.48,nnz(L1LP_CPX_xdiff(L1LP_CPX_xdiff<=1e-4)>1e-6)/5.48,nnz(L1LP_CPX_xdiff(L1LP_CPX_xdiff<=1e-6)>1e-9)/5.48,nnz(L1LP_CPX_xdiff<=1e-9)/5.48);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(L1LP_CPX_xdiff>1e-1)/5.48,nnz(L1LP_CPX_xdiff<=1e-1)/5.48,nnz(L1LP_CPX_xdiff<=1e-6)/5.48);
      
    fprintf(fid,'SoPlex (w/o HOC) & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% & $%3.2f$\\,\\%% \\\\\n',...
        nnz(L1LP_SPX_xdiff>1e-1)/5.48,nnz(L1LP_SPX_xdiff(L1LP_SPX_xdiff<=1e-1)>1e-4)/5.48,nnz(L1LP_SPX_xdiff(L1LP_SPX_xdiff<=1e-4)>1e-6)/5.48,nnz(L1LP_SPX_xdiff(L1LP_SPX_xdiff<=1e-6)>1e-9)/5.48,nnz(L1LP_SPX_xdiff<=1e-9)/5.48);
    fprintf(fid,' & \\multicolumn{5}{l}{inacceptable: $%3.2f$\\,\\%%\\,,~ acceptable: $%3.2f$\\,\\%%\\,,~ solved: $%3.2f$\\,\\%%  }\\\\[1em]\n',nnz(L1LP_SPX_xdiff>1e-1)/5.48,nnz(L1LP_SPX_xdiff<=1e-1)/5.48,nnz(L1LP_SPX_xdiff<=1e-6)/5.48);
        
    fprintf(fid,'\\bottomrule\n\\end{longtable}\n');
    fclose(fid);    
    
    
    
    % HOC Impact table...
    filename = 'HDRandLDR_table_HOCimpact.tex';
    fid = fopen(filename,'wt');
    fprintf(fid,'\\begin{tabular*}{\\textwidth}{@{\\extracolsep{\\fill}}l@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{\\quad}r@{}}\\toprule\n');
    fprintf(fid,' & \\multicolumn{1}{r}{$\\ell_{1}$-Hom.} & \\multicolumn{1}{r}{ISAL1} & \\multicolumn{1}{r}{$\\ell_1$-Magic} & \\multicolumn{1}{r}{SPGL1} & \\multicolumn{1}{r}{SolveBP} & \\multicolumn{1}{r}{YALL1}\\\\\n\\midrule\n');
    fprintf(fid,'solved faster & \\multicolumn{1}{r}{$%d$/$%d$} & \\multicolumn{1}{r}{$%d$/$%d$} & \\multicolumn{1}{r}{$%d$/$%d$} & \\multicolumn{1}{r}{$%d$/$%d$} & \\multicolumn{1}{r}{$%d$/$%d$} & \\multicolumn{1}{r}{$%d$/$%d$}\\\\\n', ...
        nnz(Homotopy_HOC_time(intersect(find(Homotopy_xdiff<=1e-6),find(Homotopy_HOC_xdiff<=1e-6)))<=Homotopy_time(intersect(find(Homotopy_xdiff<=1e-6),find(Homotopy_HOC_xdiff<=1e-6)))), nnz(Homotopy_xdiff<=1e-6), ...
        nnz(ISAL1_time(intersect(find(ISAL1_noHOC_xdiff<=1e-6),find(ISAL1_xdiff<=1e-6)))<=ISAL1_noHOC_time(intersect(find(ISAL1_noHOC_xdiff<=1e-6),find(ISAL1_xdiff<=1e-6)))), nnz(ISAL1_noHOC_xdiff<=1e-6), ...
        nnz(l1MAGIC_HOC_time(intersect(find(l1MAGIC_xdiff<=1e-6),find(l1MAGIC_HOC_xdiff<=1e-6)))<=l1MAGIC_time(intersect(find(l1MAGIC_xdiff<=1e-6),find(l1MAGIC_HOC_xdiff<=1e-6)))), nnz(l1MAGIC_xdiff<=1e-6), ...
        nnz(SPGL1_HOC_time(intersect(find(SPGL1_xdiff<=1e-6),find(SPGL1_HOC_xdiff<=1e-6)))<=SPGL1_time(intersect(find(SPGL1_xdiff<=1e-6),find(SPGL1_HOC_xdiff<=1e-6)))), nnz(SPGL1_xdiff<=1e-6), ...        
        nnz(SolveBP_HOC_time(intersect(find(SolveBP_xdiff<=1e-6),find(SolveBP_HOC_xdiff<=1e-6)))<=SolveBP_time(intersect(find(SolveBP_xdiff<=1e-6),find(SolveBP_HOC_xdiff<=1e-6)))), nnz(SolveBP_xdiff<=1e-6), ...
        nnz(YALL1_HOC_time(intersect(find(YALL1_xdiff<=1e-6),find(YALL1_HOC_xdiff<=1e-6)))<=YALL1_time(intersect(find(YALL1_xdiff<=1e-6),find(YALL1_HOC_xdiff<=1e-6)))), nnz(YALL1_xdiff<=1e-6) );
    fprintf(fid,'(HDR) & \\multicolumn{1}{r}{($%d$/$%d$)} & \\multicolumn{1}{r}{($%d$/$%d$)} & \\multicolumn{1}{r}{($%d$/$%d$)} & \\multicolumn{1}{r}{($%d$/$%d$)} & \\multicolumn{1}{r}{($%d$/$%d$)} & \\multicolumn{1}{r}{($%d$/$%d$)}\\\\\n', ...
        nnz(Homotopy_HOC_HDR_time(intersect(find(Homotopy_HDR_xdiff<=1e-6),find(Homotopy_HOC_HDR_xdiff<=1e-6)))<=Homotopy_HDR_time(intersect(find(Homotopy_HDR_xdiff<=1e-6),find(Homotopy_HOC_HDR_xdiff<=1e-6)))), nnz(Homotopy_HDR_xdiff<=1e-6), ...
        nnz(ISAL1_HDR_time(intersect(find(ISAL1_noHOC_HDR_xdiff<=1e-6),find(ISAL1_HDR_xdiff<=1e-6)))<=ISAL1_noHOC_HDR_time(intersect(find(ISAL1_noHOC_HDR_xdiff<=1e-6),find(ISAL1_HDR_xdiff<=1e-6)))), nnz(ISAL1_noHOC_HDR_xdiff<=1e-6), ...
        nnz(l1MAGIC_HOC_HDR_time(intersect(find(l1MAGIC_HDR_xdiff<=1e-6),find(l1MAGIC_HOC_HDR_xdiff<=1e-6)))<=l1MAGIC_HDR_time(intersect(find(l1MAGIC_HDR_xdiff<=1e-6),find(l1MAGIC_HOC_HDR_xdiff<=1e-6)))), nnz(l1MAGIC_HDR_xdiff<=1e-6), ...
        nnz(SPGL1_HOC_HDR_time(intersect(find(SPGL1_HDR_xdiff<=1e-6),find(SPGL1_HOC_HDR_xdiff<=1e-6)))<=SPGL1_HDR_time(intersect(find(SPGL1_HDR_xdiff<=1e-6),find(SPGL1_HOC_HDR_xdiff<=1e-6)))), nnz(SPGL1_HDR_xdiff<=1e-6), ...        
        nnz(SolveBP_HOC_HDR_time(intersect(find(SolveBP_HDR_xdiff<=1e-6),find(SolveBP_HOC_HDR_xdiff<=1e-6)))<=SolveBP_HDR_time(intersect(find(SolveBP_HDR_xdiff<=1e-6),find(SolveBP_HOC_HDR_xdiff<=1e-6)))), nnz(SolveBP_HDR_xdiff<=1e-6), ...
        nnz(YALL1_HOC_HDR_time(intersect(find(YALL1_HDR_xdiff<=1e-6),find(YALL1_HOC_HDR_xdiff<=1e-6)))<=YALL1_HDR_time(intersect(find(YALL1_HDR_xdiff<=1e-6),find(YALL1_HOC_HDR_xdiff<=1e-6)))), nnz(YALL1_HDR_xdiff<=1e-6) );
    fprintf(fid,'(LDR) & \\multicolumn{1}{r}{($%d$/$%d$)} & \\multicolumn{1}{r}{($%d$/$%d$)} & \\multicolumn{1}{r}{($%d$/$%d$)} & \\multicolumn{1}{r}{($%d$/$%d$)} & \\multicolumn{1}{r}{($%d$/$%d$)} & \\multicolumn{1}{r}{($%d$/$%d$)}\\\\[0.5em]\n', ...
        nnz(Homotopy_HOC_LDR_time(intersect(find(Homotopy_LDR_xdiff<=1e-6),find(Homotopy_HOC_LDR_xdiff<=1e-6)))<=Homotopy_LDR_time(intersect(find(Homotopy_LDR_xdiff<=1e-6),find(Homotopy_HOC_LDR_xdiff<=1e-6)))), nnz(Homotopy_LDR_xdiff<=1e-6), ...
        nnz(ISAL1_LDR_time(intersect(find(ISAL1_noHOC_LDR_xdiff<=1e-6),find(ISAL1_LDR_xdiff<=1e-6)))<=ISAL1_noHOC_LDR_time(intersect(find(ISAL1_noHOC_LDR_xdiff<=1e-6),find(ISAL1_LDR_xdiff<=1e-6)))), nnz(ISAL1_noHOC_LDR_xdiff<=1e-6), ...
        nnz(l1MAGIC_HOC_LDR_time(intersect(find(l1MAGIC_LDR_xdiff<=1e-6),find(l1MAGIC_HOC_LDR_xdiff<=1e-6)))<=l1MAGIC_LDR_time(intersect(find(l1MAGIC_LDR_xdiff<=1e-6),find(l1MAGIC_HOC_LDR_xdiff<=1e-6)))), nnz(l1MAGIC_LDR_xdiff<=1e-6), ...
        nnz(SPGL1_HOC_LDR_time(intersect(find(SPGL1_LDR_xdiff<=1e-6),find(SPGL1_HOC_LDR_xdiff<=1e-6)))<=SPGL1_LDR_time(intersect(find(SPGL1_LDR_xdiff<=1e-6),find(SPGL1_HOC_LDR_xdiff<=1e-6)))), nnz(SPGL1_LDR_xdiff<=1e-6), ...        
        nnz(SolveBP_HOC_LDR_time(intersect(find(SolveBP_LDR_xdiff<=1e-6),find(SolveBP_HOC_LDR_xdiff<=1e-6)))<=SolveBP_LDR_time(intersect(find(SolveBP_LDR_xdiff<=1e-6),find(SolveBP_HOC_LDR_xdiff<=1e-6)))), nnz(SolveBP_LDR_xdiff<=1e-6), ...
        nnz(YALL1_HOC_LDR_time(intersect(find(YALL1_LDR_xdiff<=1e-6),find(YALL1_HOC_LDR_xdiff<=1e-6)))<=YALL1_LDR_time(intersect(find(YALL1_LDR_xdiff<=1e-6),find(YALL1_HOC_LDR_xdiff<=1e-6)))), nnz(YALL1_LDR_xdiff<=1e-6) );
    fprintf(fid,'solved extra & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$} & \\multicolumn{1}{r}{$%d$}\\\\\n', ...
        nnz(setdiff(find(Homotopy_HOC_xdiff<=1e-6),find(Homotopy_xdiff<=1e-6))), nnz(setdiff(find(ISAL1_xdiff<=1e-6),find(ISAL1_noHOC_xdiff<=1e-6))), nnz(setdiff(find(l1MAGIC_HOC_xdiff<=1e-6),find(l1MAGIC_xdiff<=1e-6))), ...
        nnz(setdiff(find(SPGL1_HOC_xdiff<=1e-6),find(SPGL1_xdiff<=1e-6))), nnz(setdiff(find(SolveBP_HOC_xdiff<=1e-6),find(SolveBP_xdiff<=1e-6))), nnz(setdiff(find(YALL1_HOC_xdiff<=1e-6),find(YALL1_xdiff<=1e-6))) );
    fprintf(fid,'(HDR) & \\multicolumn{1}{r}{($%d$)} & \\multicolumn{1}{r}{($%d$)} & \\multicolumn{1}{r}{($%d$)} & \\multicolumn{1}{r}{($%d$)} & \\multicolumn{1}{r}{($%d$)} & \\multicolumn{1}{r}{($%d$)}\\\\\n', ...
        nnz(setdiff(find(Homotopy_HOC_HDR_xdiff<=1e-6),find(Homotopy_HDR_xdiff<=1e-6))), nnz(setdiff(find(ISAL1_HDR_xdiff<=1e-6),find(ISAL1_noHOC_HDR_xdiff<=1e-6))), nnz(setdiff(find(l1MAGIC_HOC_HDR_xdiff<=1e-6),find(l1MAGIC_HDR_xdiff<=1e-6))), ...
        nnz(setdiff(find(SPGL1_HOC_HDR_xdiff<=1e-6),find(SPGL1_HDR_xdiff<=1e-6))), nnz(setdiff(find(SolveBP_HOC_HDR_xdiff<=1e-6),find(SolveBP_HDR_xdiff<=1e-6))), nnz(setdiff(find(YALL1_HOC_HDR_xdiff<=1e-6),find(YALL1_HDR_xdiff<=1e-6))) );    
    fprintf(fid,'(LDR) & \\multicolumn{1}{r}{($%d$)} & \\multicolumn{1}{r}{($%d$)} & \\multicolumn{1}{r}{($%d$)} & \\multicolumn{1}{r}{($%d$)} & \\multicolumn{1}{r}{($%d$)} & \\multicolumn{1}{r}{($%d$)}\\\\[0.5em]\n', ...
        nnz(setdiff(find(Homotopy_HOC_LDR_xdiff<=1e-6),find(Homotopy_LDR_xdiff<=1e-6))), nnz(setdiff(find(ISAL1_LDR_xdiff<=1e-6),find(ISAL1_noHOC_LDR_xdiff<=1e-6))), nnz(setdiff(find(l1MAGIC_HOC_LDR_xdiff<=1e-6),find(l1MAGIC_LDR_xdiff<=1e-6))), ...
        nnz(setdiff(find(SPGL1_HOC_LDR_xdiff<=1e-6),find(SPGL1_LDR_xdiff<=1e-6))), nnz(setdiff(find(SolveBP_HOC_LDR_xdiff<=1e-6),find(SolveBP_LDR_xdiff<=1e-6))), nnz(setdiff(find(YALL1_HOC_LDR_xdiff<=1e-6),find(YALL1_LDR_xdiff<=1e-6))) );    
    fprintf(fid,'\\%% imp. ERC & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$}\\\\\n', ...
        (nnz(Homotopy_HOC_time(intersect(TSerc,intersect(find(Homotopy_xdiff<=1e-6),find(Homotopy_HOC_xdiff<=1e-6))))<=Homotopy_time(intersect(TSerc,intersect(find(Homotopy_xdiff<=1e-6),find(Homotopy_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(Homotopy_HOC_xdiff(TSerc)<=1e-6),find(Homotopy_xdiff(TSerc)<=1e-6))))/4.00, ...
        (nnz(ISAL1_time(intersect(TSerc,intersect(find(ISAL1_noHOC_xdiff<=1e-6),find(ISAL1_xdiff<=1e-6))))<=ISAL1_noHOC_time(intersect(TSerc,intersect(find(ISAL1_noHOC_xdiff<=1e-6),find(ISAL1_xdiff<=1e-6)))))+nnz(setdiff(find(ISAL1_xdiff(TSerc)<=1e-6),find(ISAL1_noHOC_xdiff(TSerc)<=1e-6))))/4.00, ...
        (nnz(l1MAGIC_HOC_time(intersect(TSerc,intersect(find(l1MAGIC_xdiff<=1e-6),find(l1MAGIC_HOC_xdiff<=1e-6))))<=l1MAGIC_time(intersect(TSerc,intersect(find(l1MAGIC_xdiff<=1e-6),find(l1MAGIC_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(l1MAGIC_HOC_xdiff(TSerc)<=1e-6),find(l1MAGIC_xdiff(TSerc)<=1e-6))))/4.00, ...
        (nnz(SPGL1_HOC_time(intersect(TSerc,intersect(find(SPGL1_xdiff<=1e-6),find(SPGL1_HOC_xdiff<=1e-6))))<=SPGL1_time(intersect(TSerc,intersect(find(SPGL1_xdiff<=1e-6),find(SPGL1_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(SPGL1_HOC_xdiff(TSerc)<=1e-6),find(SPGL1_xdiff(TSerc)<=1e-6))))/4.00, ...
        (nnz(SolveBP_HOC_time(intersect(TSerc,intersect(find(SolveBP_xdiff<=1e-6),find(SolveBP_HOC_xdiff<=1e-6))))<=SolveBP_time(intersect(TSerc,intersect(find(SolveBP_xdiff<=1e-6),find(SolveBP_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(SolveBP_HOC_xdiff(TSerc)<=1e-6),find(SolveBP_xdiff(TSerc)<=1e-6))))/4.00, ...
        (nnz(YALL1_HOC_time(intersect(TSerc,intersect(find(YALL1_xdiff<=1e-6),find(YALL1_HOC_xdiff<=1e-6))))<=YALL1_time(intersect(TSerc,intersect(find(YALL1_xdiff<=1e-6),find(YALL1_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(YALL1_HOC_xdiff(TSerc)<=1e-6),find(YALL1_xdiff(TSerc)<=1e-6))))/4.00 );
    fprintf(fid,'(HDR) & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)}\\\\\n', ...
        (nnz(Homotopy_HOC_time(intersect(HDRerc,intersect(find(Homotopy_xdiff<=1e-6),find(Homotopy_HOC_xdiff<=1e-6))))<=Homotopy_time(intersect(HDRerc,intersect(find(Homotopy_xdiff<=1e-6),find(Homotopy_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(Homotopy_HOC_xdiff(HDRerc)<=1e-6),find(Homotopy_xdiff(HDRerc)<=1e-6))))/2.00, ...
        (nnz(ISAL1_time(intersect(HDRerc,intersect(find(ISAL1_noHOC_xdiff<=1e-6),find(ISAL1_xdiff<=1e-6))))<=ISAL1_noHOC_time(intersect(HDRerc,intersect(find(ISAL1_noHOC_xdiff<=1e-6),find(ISAL1_xdiff<=1e-6)))))+nnz(setdiff(find(ISAL1_xdiff(HDRerc)<=1e-6),find(ISAL1_noHOC_xdiff(HDRerc)<=1e-6))))/2.00, ...
        (nnz(l1MAGIC_HOC_time(intersect(HDRerc,intersect(find(l1MAGIC_xdiff<=1e-6),find(l1MAGIC_HOC_xdiff<=1e-6))))<=l1MAGIC_time(intersect(HDRerc,intersect(find(l1MAGIC_xdiff<=1e-6),find(l1MAGIC_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(l1MAGIC_HOC_xdiff(HDRerc)<=1e-6),find(l1MAGIC_xdiff(HDRerc)<=1e-6))))/2.00, ...
        (nnz(SPGL1_HOC_time(intersect(HDRerc,intersect(find(SPGL1_xdiff<=1e-6),find(SPGL1_HOC_xdiff<=1e-6))))<=SPGL1_time(intersect(HDRerc,intersect(find(SPGL1_xdiff<=1e-6),find(SPGL1_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(SPGL1_HOC_xdiff(HDRerc)<=1e-6),find(SPGL1_xdiff(HDRerc)<=1e-6))))/2.00, ...
        (nnz(SolveBP_HOC_time(intersect(HDRerc,intersect(find(SolveBP_xdiff<=1e-6),find(SolveBP_HOC_xdiff<=1e-6))))<=SolveBP_time(intersect(HDRerc,intersect(find(SolveBP_xdiff<=1e-6),find(SolveBP_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(SolveBP_HOC_xdiff(HDRerc)<=1e-6),find(SolveBP_xdiff(HDRerc)<=1e-6))))/2.00, ...
        (nnz(YALL1_HOC_time(intersect(HDRerc,intersect(find(YALL1_xdiff<=1e-6),find(YALL1_HOC_xdiff<=1e-6))))<=YALL1_time(intersect(HDRerc,intersect(find(YALL1_xdiff<=1e-6),find(YALL1_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(YALL1_HOC_xdiff(HDRerc)<=1e-6),find(YALL1_xdiff(HDRerc)<=1e-6))))/2.00 );
    fprintf(fid,'(LDR) & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)}\\\\[0.5em]\n', ...
        (nnz(Homotopy_HOC_time(intersect(LDRerc,intersect(find(Homotopy_xdiff<=1e-6),find(Homotopy_HOC_xdiff<=1e-6))))<=Homotopy_time(intersect(LDRerc,intersect(find(Homotopy_xdiff<=1e-6),find(Homotopy_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(Homotopy_HOC_xdiff(LDRerc)<=1e-6),find(Homotopy_xdiff(LDRerc)<=1e-6))))/2.00, ...
        (nnz(ISAL1_time(intersect(LDRerc,intersect(find(ISAL1_noHOC_xdiff<=1e-6),find(ISAL1_xdiff<=1e-6))))<=ISAL1_noHOC_time(intersect(LDRerc,intersect(find(ISAL1_noHOC_xdiff<=1e-6),find(ISAL1_xdiff<=1e-6)))))+nnz(setdiff(find(ISAL1_xdiff(LDRerc)<=1e-6),find(ISAL1_noHOC_xdiff(LDRerc)<=1e-6))))/2.00, ...
        (nnz(l1MAGIC_HOC_time(intersect(LDRerc,intersect(find(l1MAGIC_xdiff<=1e-6),find(l1MAGIC_HOC_xdiff<=1e-6))))<=l1MAGIC_time(intersect(LDRerc,intersect(find(l1MAGIC_xdiff<=1e-6),find(l1MAGIC_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(l1MAGIC_HOC_xdiff(LDRerc)<=1e-6),find(l1MAGIC_xdiff(LDRerc)<=1e-6))))/2.00, ...
        (nnz(SPGL1_HOC_time(intersect(LDRerc,intersect(find(SPGL1_xdiff<=1e-6),find(SPGL1_HOC_xdiff<=1e-6))))<=SPGL1_time(intersect(LDRerc,intersect(find(SPGL1_xdiff<=1e-6),find(SPGL1_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(SPGL1_HOC_xdiff(LDRerc)<=1e-6),find(SPGL1_xdiff(LDRerc)<=1e-6))))/2.00, ...
        (nnz(SolveBP_HOC_time(intersect(LDRerc,intersect(find(SolveBP_xdiff<=1e-6),find(SolveBP_HOC_xdiff<=1e-6))))<=SolveBP_time(intersect(LDRerc,intersect(find(SolveBP_xdiff<=1e-6),find(SolveBP_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(SolveBP_HOC_xdiff(LDRerc)<=1e-6),find(SolveBP_xdiff(LDRerc)<=1e-6))))/2.00, ...
        (nnz(YALL1_HOC_time(intersect(LDRerc,intersect(find(YALL1_xdiff<=1e-6),find(YALL1_HOC_xdiff<=1e-6))))<=YALL1_time(intersect(LDRerc,intersect(find(YALL1_xdiff<=1e-6),find(YALL1_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(YALL1_HOC_xdiff(LDRerc)<=1e-6),find(YALL1_xdiff(LDRerc)<=1e-6))))/2.00 );
    fprintf(fid,'\\%% imp. non-ERC & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$}\\\\\n', ...
        (nnz(Homotopy_HOC_time(intersect(TSnonERC,intersect(find(Homotopy_xdiff<=1e-6),find(Homotopy_HOC_xdiff<=1e-6))))<=Homotopy_time(intersect(TSnonERC,intersect(find(Homotopy_xdiff<=1e-6),find(Homotopy_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(Homotopy_HOC_xdiff(TSnonERC)<=1e-6),find(Homotopy_xdiff(TSnonERC)<=1e-6))))/1.48, ...
        (nnz(ISAL1_time(intersect(TSnonERC,intersect(find(ISAL1_noHOC_xdiff<=1e-6),find(ISAL1_xdiff<=1e-6))))<=ISAL1_noHOC_time(intersect(TSnonERC,intersect(find(ISAL1_noHOC_xdiff<=1e-6),find(ISAL1_xdiff<=1e-6)))))+nnz(setdiff(find(ISAL1_xdiff(TSnonERC)<=1e-6),find(ISAL1_noHOC_xdiff(TSnonERC)<=1e-6))))/1.48, ...
        (nnz(l1MAGIC_HOC_time(intersect(TSnonERC,intersect(find(l1MAGIC_xdiff<=1e-6),find(l1MAGIC_HOC_xdiff<=1e-6))))<=l1MAGIC_time(intersect(TSnonERC,intersect(find(l1MAGIC_xdiff<=1e-6),find(l1MAGIC_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(l1MAGIC_HOC_xdiff(TSnonERC)<=1e-6),find(l1MAGIC_xdiff(TSnonERC)<=1e-6))))/1.48, ...
        (nnz(SPGL1_HOC_time(intersect(TSnonERC,intersect(find(SPGL1_xdiff<=1e-6),find(SPGL1_HOC_xdiff<=1e-6))))<=SPGL1_time(intersect(TSnonERC,intersect(find(SPGL1_xdiff<=1e-6),find(SPGL1_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(SPGL1_HOC_xdiff(TSnonERC)<=1e-6),find(SPGL1_xdiff(TSnonERC)<=1e-6))))/1.48, ...
        (nnz(SolveBP_HOC_time(intersect(TSnonERC,intersect(find(SolveBP_xdiff<=1e-6),find(SolveBP_HOC_xdiff<=1e-6))))<=SolveBP_time(intersect(TSnonERC,intersect(find(SolveBP_xdiff<=1e-6),find(SolveBP_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(SolveBP_HOC_xdiff(TSnonERC)<=1e-6),find(SolveBP_xdiff(TSnonERC)<=1e-6))))/1.48, ...
        (nnz(YALL1_HOC_time(intersect(TSnonERC,intersect(find(YALL1_xdiff<=1e-6),find(YALL1_HOC_xdiff<=1e-6))))<=YALL1_time(intersect(TSnonERC,intersect(find(YALL1_xdiff<=1e-6),find(YALL1_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(YALL1_HOC_xdiff(TSnonERC)<=1e-6),find(YALL1_xdiff(TSnonERC)<=1e-6))))/1.48 );
    fprintf(fid,'(HDR) & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)}\\\\\n', ...
        (nnz(Homotopy_HOC_time(intersect(HDRnonERC,intersect(find(Homotopy_xdiff<=1e-6),find(Homotopy_HOC_xdiff<=1e-6))))<=Homotopy_time(intersect(HDRnonERC,intersect(find(Homotopy_xdiff<=1e-6),find(Homotopy_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(Homotopy_HOC_xdiff(HDRnonERC)<=1e-6),find(Homotopy_xdiff(HDRnonERC)<=1e-6))))/0.74, ...
        (nnz(ISAL1_time(intersect(HDRnonERC,intersect(find(ISAL1_noHOC_xdiff<=1e-6),find(ISAL1_xdiff<=1e-6))))<=ISAL1_noHOC_time(intersect(HDRnonERC,intersect(find(ISAL1_noHOC_xdiff<=1e-6),find(ISAL1_xdiff<=1e-6)))))+nnz(setdiff(find(ISAL1_xdiff(HDRnonERC)<=1e-6),find(ISAL1_noHOC_xdiff(HDRnonERC)<=1e-6))))/0.74, ...
        (nnz(l1MAGIC_HOC_time(intersect(HDRnonERC,intersect(find(l1MAGIC_xdiff<=1e-6),find(l1MAGIC_HOC_xdiff<=1e-6))))<=l1MAGIC_time(intersect(HDRnonERC,intersect(find(l1MAGIC_xdiff<=1e-6),find(l1MAGIC_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(l1MAGIC_HOC_xdiff(HDRnonERC)<=1e-6),find(l1MAGIC_xdiff(HDRnonERC)<=1e-6))))/0.74, ...
        (nnz(SPGL1_HOC_time(intersect(HDRnonERC,intersect(find(SPGL1_xdiff<=1e-6),find(SPGL1_HOC_xdiff<=1e-6))))<=SPGL1_time(intersect(HDRnonERC,intersect(find(SPGL1_xdiff<=1e-6),find(SPGL1_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(SPGL1_HOC_xdiff(HDRnonERC)<=1e-6),find(SPGL1_xdiff(HDRnonERC)<=1e-6))))/0.74, ...
        (nnz(SolveBP_HOC_time(intersect(HDRnonERC,intersect(find(SolveBP_xdiff<=1e-6),find(SolveBP_HOC_xdiff<=1e-6))))<=SolveBP_time(intersect(HDRnonERC,intersect(find(SolveBP_xdiff<=1e-6),find(SolveBP_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(SolveBP_HOC_xdiff(HDRnonERC)<=1e-6),find(SolveBP_xdiff(HDRnonERC)<=1e-6))))/0.74, ...
        (nnz(YALL1_HOC_time(intersect(HDRnonERC,intersect(find(YALL1_xdiff<=1e-6),find(YALL1_HOC_xdiff<=1e-6))))<=YALL1_time(intersect(HDRnonERC,intersect(find(YALL1_xdiff<=1e-6),find(YALL1_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(YALL1_HOC_xdiff(HDRnonERC)<=1e-6),find(YALL1_xdiff(HDRnonERC)<=1e-6))))/0.74 );
    fprintf(fid,'(LDR) & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)}\\\\[0.5em]\n', ...
        (nnz(Homotopy_HOC_time(intersect(LDRnonERC,intersect(find(Homotopy_xdiff<=1e-6),find(Homotopy_HOC_xdiff<=1e-6))))<=Homotopy_time(intersect(LDRnonERC,intersect(find(Homotopy_xdiff<=1e-6),find(Homotopy_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(Homotopy_HOC_xdiff(LDRnonERC)<=1e-6),find(Homotopy_xdiff(LDRnonERC)<=1e-6))))/0.74, ...
        (nnz(ISAL1_time(intersect(LDRnonERC,intersect(find(ISAL1_noHOC_xdiff<=1e-6),find(ISAL1_xdiff<=1e-6))))<=ISAL1_noHOC_time(intersect(LDRnonERC,intersect(find(ISAL1_noHOC_xdiff<=1e-6),find(ISAL1_xdiff<=1e-6)))))+nnz(setdiff(find(ISAL1_xdiff(LDRnonERC)<=1e-6),find(ISAL1_noHOC_xdiff(LDRnonERC)<=1e-6))))/0.74, ...
        (nnz(l1MAGIC_HOC_time(intersect(LDRnonERC,intersect(find(l1MAGIC_xdiff<=1e-6),find(l1MAGIC_HOC_xdiff<=1e-6))))<=l1MAGIC_time(intersect(LDRnonERC,intersect(find(l1MAGIC_xdiff<=1e-6),find(l1MAGIC_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(l1MAGIC_HOC_xdiff(LDRnonERC)<=1e-6),find(l1MAGIC_xdiff(LDRnonERC)<=1e-6))))/0.74, ...
        (nnz(SPGL1_HOC_time(intersect(LDRnonERC,intersect(find(SPGL1_xdiff<=1e-6),find(SPGL1_HOC_xdiff<=1e-6))))<=SPGL1_time(intersect(LDRnonERC,intersect(find(SPGL1_xdiff<=1e-6),find(SPGL1_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(SPGL1_HOC_xdiff(LDRnonERC)<=1e-6),find(SPGL1_xdiff(LDRnonERC)<=1e-6))))/0.74, ...
        (nnz(SolveBP_HOC_time(intersect(LDRnonERC,intersect(find(SolveBP_xdiff<=1e-6),find(SolveBP_HOC_xdiff<=1e-6))))<=SolveBP_time(intersect(LDRnonERC,intersect(find(SolveBP_xdiff<=1e-6),find(SolveBP_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(SolveBP_HOC_xdiff(LDRnonERC)<=1e-6),find(SolveBP_xdiff(LDRnonERC)<=1e-6))))/0.74, ...
        (nnz(YALL1_HOC_time(intersect(LDRnonERC,intersect(find(YALL1_xdiff<=1e-6),find(YALL1_HOC_xdiff<=1e-6))))<=YALL1_time(intersect(LDRnonERC,intersect(find(YALL1_xdiff<=1e-6),find(YALL1_HOC_xdiff<=1e-6)))))+nnz(setdiff(find(YALL1_HOC_xdiff(LDRnonERC)<=1e-6),find(YALL1_xdiff(LDRnonERC)<=1e-6))))/0.74 );
    fprintf(fid,'\\%% avg. rel. speed-up & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$}\\\\\n', ...
        mean((Homotopy_time-Homotopy_HOC_time)./Homotopy_time)*100, mean((ISAL1_noHOC_time-ISAL1_time)./ISAL1_noHOC_time)*100, mean((l1MAGIC_time-l1MAGIC_HOC_time)./l1MAGIC_time)*100, ...
        mean((SPGL1_time-SPGL1_HOC_time)./SPGL1_time)*100, mean((SolveBP_time-SolveBP_HOC_time)./SolveBP_time)*100, mean((YALL1_time-YALL1_HOC_time)./YALL1_time)*100 );
    fprintf(fid,'(HDR) & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)}\\\\\n', ...
        mean((Homotopy_HDR_time-Homotopy_HOC_HDR_time)./Homotopy_HDR_time)*100, mean((ISAL1_noHOC_HDR_time-ISAL1_HDR_time)./ISAL1_noHOC_HDR_time)*100, mean((l1MAGIC_HDR_time-l1MAGIC_HOC_HDR_time)./l1MAGIC_HDR_time)*100, ...
        mean((SPGL1_HDR_time-SPGL1_HOC_HDR_time)./SPGL1_HDR_time)*100, mean((SolveBP_HDR_time-SolveBP_HOC_HDR_time)./SolveBP_HDR_time)*100, mean((YALL1_HDR_time-YALL1_HOC_HDR_time)./YALL1_HDR_time)*100 );
    fprintf(fid,'(LDR) & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)} & \\multicolumn{1}{r}{($%3.1f$)}\\\\[0.5em]\n', ...
        mean((Homotopy_LDR_time-Homotopy_HOC_LDR_time)./Homotopy_LDR_time)*100, mean((ISAL1_noHOC_LDR_time-ISAL1_LDR_time)./ISAL1_noHOC_LDR_time)*100, mean((l1MAGIC_LDR_time-l1MAGIC_HOC_LDR_time)./l1MAGIC_LDR_time)*100, ...
        mean((SPGL1_LDR_time-SPGL1_HOC_LDR_time)./SPGL1_LDR_time)*100, mean((SolveBP_LDR_time-SolveBP_HOC_LDR_time)./SolveBP_LDR_time)*100, mean((YALL1_LDR_time-YALL1_HOC_LDR_time)./YALL1_LDR_time)*100 );
    fprintf(fid,'\\# faster & \\multicolumn{1}{r}{$%3d$} & \\multicolumn{1}{r}{$%3d$} & \\multicolumn{1}{r}{$%3d$} & \\multicolumn{1}{r}{$%3d$} & \\multicolumn{1}{r}{$%3d$} & \\multicolumn{1}{r}{$%3d$}\\\\\n', ...
        nnz(Homotopy_HOC_time<=Homotopy_time), nnz(ISAL1_time<=ISAL1_noHOC_time), nnz(l1MAGIC_HOC_time<=l1MAGIC_time), nnz(SPGL1_HOC_time<=SPGL1_time), nnz(SolveBP_HOC_time<=SolveBP_time), nnz(YALL1_HOC_time<=YALL1_time) );
    fprintf(fid,'\\%% speed-up if faster & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$}\\\\[0.5em]\n', ...
        mean((Homotopy_time(Homotopy_HOC_time<=Homotopy_time)-Homotopy_HOC_time(Homotopy_HOC_time<=Homotopy_time))./Homotopy_time(Homotopy_HOC_time<=Homotopy_time))*100, mean((ISAL1_noHOC_time(ISAL1_time<=ISAL1_noHOC_time)-ISAL1_time(ISAL1_time<=ISAL1_noHOC_time))./ISAL1_noHOC_time(ISAL1_time<=ISAL1_noHOC_time))*100, mean((l1MAGIC_time(l1MAGIC_HOC_time<=l1MAGIC_time)-l1MAGIC_HOC_time(l1MAGIC_HOC_time<=l1MAGIC_time))./l1MAGIC_time(l1MAGIC_HOC_time<=l1MAGIC_time))*100, ...
        mean((SPGL1_time(SPGL1_HOC_time<=SPGL1_time)-SPGL1_HOC_time(SPGL1_HOC_time<=SPGL1_time))./SPGL1_time(SPGL1_HOC_time<=SPGL1_time))*100, mean((SolveBP_time(SolveBP_HOC_time<=SolveBP_time)-SolveBP_HOC_time(SolveBP_HOC_time<=SolveBP_time))./SolveBP_time(SolveBP_HOC_time<=SolveBP_time))*100, mean((YALL1_time(YALL1_HOC_time<=YALL1_time)-YALL1_HOC_time(YALL1_HOC_time<=YALL1_time))./YALL1_time(YALL1_HOC_time<=YALL1_time))*100 );
    fprintf(fid,'\\# slower & \\multicolumn{1}{r}{$%3d$} & \\multicolumn{1}{r}{$%3d$} & \\multicolumn{1}{r}{$%3d$} & \\multicolumn{1}{r}{$%3d$} & \\multicolumn{1}{r}{$%3d$} & \\multicolumn{1}{r}{$%3d$}\\\\\n', ...
        nnz(Homotopy_HOC_time>Homotopy_time), nnz(ISAL1_time>ISAL1_noHOC_time), nnz(l1MAGIC_HOC_time>l1MAGIC_time), nnz(SPGL1_HOC_time>SPGL1_time), nnz(SolveBP_HOC_time>SolveBP_time), nnz(YALL1_HOC_time>YALL1_time) );
    fprintf(fid,'\\%% overhead if slower & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$} & \\multicolumn{1}{r}{$%3.1f$}\\\\\n', ...
        mean((Homotopy_HOC_time(Homotopy_HOC_time>Homotopy_time)-Homotopy_time(Homotopy_HOC_time>Homotopy_time))./Homotopy_HOC_time(Homotopy_HOC_time>Homotopy_time))*100, mean((ISAL1_time(ISAL1_time>ISAL1_noHOC_time)-ISAL1_noHOC_time(ISAL1_time>ISAL1_noHOC_time))./ISAL1_time(ISAL1_time>ISAL1_noHOC_time))*100, mean((l1MAGIC_HOC_time(l1MAGIC_HOC_time>l1MAGIC_time)-l1MAGIC_time(l1MAGIC_HOC_time>l1MAGIC_time))./l1MAGIC_HOC_time(l1MAGIC_HOC_time>l1MAGIC_time))*100, ...
        mean((SPGL1_HOC_time(SPGL1_HOC_time>SPGL1_time)-SPGL1_time(SPGL1_HOC_time>SPGL1_time))./SPGL1_HOC_time(SPGL1_HOC_time>SPGL1_time))*100, mean((SolveBP_HOC_time(SolveBP_HOC_time>SolveBP_time)-SolveBP_time(SolveBP_HOC_time>SolveBP_time))./SolveBP_HOC_time(SolveBP_HOC_time>SolveBP_time))*100, mean((YALL1_HOC_time(YALL1_HOC_time>YALL1_time)-YALL1_time(YALL1_HOC_time>YALL1_time))./YALL1_HOC_time(YALL1_HOC_time>YALL1_time))*100 );
    fprintf(fid,'\\bottomrule\n\\end{tabular*}\n');
    fclose(fid);
end